indexing
   description: "gdk drag context"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen"
   id: "$Id: gdk_drag_context.e,v 1.6 1999/01/18 19:54:55 pcj Exp $"

class GDK_DRAG_CONTEXT
inherit 
   GDK_OBJECT
      redefine create end
creation 
   create
feature -- Creation
   create ( p : POINTER ) is
      do
	 !!protocol.make_gtk_constant(ext_drag_context_protocol(p))
	 is_source := ext_drag_context_is_source(p)
	 !!source_window.create(ext_drag_context_source_window(p))
	 !!dest_window.create(ext_drag_context_dest_window(p))
	 !!actions.make_gtk_constant(ext_drag_context_actions(p))
	 !!suggested_action.make_gtk_constant(ext_drag_context_action(p))
	 !!action.make_gtk_constant(ext_drag_context_action(p))
	 start_time := ext_drag_context_start_time(p)

	 gdkobject := p
      end

feature {ANY} -- Queries

   protocol : GDK_DRAG_PROTOCOL 
   is_source : BOOLEAN
   source_window, dest_window : GDK_WINDOW; 
   actions, suggested_action, action: GDK_DRAG_ACTION
   start_time: INTEGER
   -- targets : somebody tell me what this data field is please :-) 

feature {NONE} -- Private

   ext_drag_context_protocol (p : POINTER) : INTEGER is
      external "C"
      end

   ext_drag_context_is_source (p : POINTER) : BOOLEAN is
      external "C"
      end

   ext_drag_context_source_window (p : POINTER) : POINTER is
      external "C"
      end
   
   ext_drag_context_dest_window (p : POINTER) : POINTER is
      external "C"
      end
	 
   ext_drag_context_actions (p : POINTER) : INTEGER is
      external "C"
      end

   ext_drag_context_suggested_action (p: POINTER) : INTEGER is
      external "C"
      end

   ext_drag_context_action (p : POINTER) : INTEGER is
      external "C"
      end

   ext_drag_context_start_time (p: POINTER) : INTEGER is
      external "C"
      end

invariant
end 

