indexing
   description: "gdk drawable"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen"
   id: "$Id: gdk_drawable.e,v 1.8 1999/01/18 19:54:55 pcj Exp $"

class GDK_DRAWABLE
inherit 
   GDK_OBJECT
creation
   make,
   create
feature -- Creation
   make is
      do
      end -- make
feature {ANY} -- Queries
feature {ANY} -- Commands
   draw_point (gc : GDK_GC; x, y : INTEGER) is
      do
	 ext_draw_point(gdkobject, gc.to_external, x, y)
      end

   draw_line (gc : GDK_GC; x1, y1, x2, y2 : INTEGER) is
      do
	 ext_draw_line(gdkobject, gc.to_external, x1, y1, x2, y2)
      end

   draw_rectangle(gc : GDK_GC; filled : BOOLEAN; 
		  x, y, width, height : INTEGER) is
      do
	 ext_draw_rectangle(gdkobject, gc.to_external, filled, 
			    x, y, width, height)
      end

   draw_arc(gc : GDK_GC; filled : BOOLEAN; 
	    x, y, width, height, angle1, angle2 : INTEGER) is
      do
	 ext_draw_arc(gdkobject, gc.to_external, filled, 
		      x, y, width, height, angle1, angle2)
      end

   draw_polygon(gc : GDK_GC; filled : BOOLEAN; 
		points : COLLECTION[GDK_POINT] ) is
      local 
	 pts_array : GDK_OBJECT_ARRAY
      do
	 !!pts_array.from_collection(points)
	 ext_draw_polygon(gdkobject, gc.to_external, filled, 
			  pts_array.to_external, points.upper)
      end

   draw_string(font : GDK_FONT; gc : GDK_GC; x, y : INTEGER; text : STRING) is
      do
	 ext_draw_string(gdkobject, font.to_external, gc.to_external, 
			 x, y, text.to_external)
      end

   -- What does this do? 
   draw_text(font : GDK_FONT; gc : GDK_GC; 
	     x, y : INTEGER; text : STRING; text_length : INTEGER) is
      do
	 ext_draw_text(gdkobject, font.to_external, gc.to_external, 
			 x, y, text.to_external, text_length)
      end

   draw_pixmap(gc : GDK_GC; source : like Current ; xsrc, ysrc, 
	       xdest, ydest, width, height : INTEGER) is
      do
	 ext_draw_pixmap(gdkobject, gc.to_external, source.to_external, 
			 xsrc, ysrc,
			 xdest, ydest, 
			 width, height)
      end
   
   draw_image(gc : GDK_GC; image : GDK_IMAGE; 
	      xsrc, ysrc, xdest, ydest, width, height : INTEGER) is
      do
	 ext_draw_image(gdkobject, gc.to_external, 
			image.to_external, xsrc, ysrc, 
			xdest, ydest, width, height)
      end

   draw_points(gc : GDK_GC; points : COLLECTION[GDK_POINT] ) is
      local
	 pts_array : GDK_OBJECT_ARRAY
      do
	 !!pts_array.from_collection(points)
	 ext_draw_points(gdkobject, gc.to_external, 
			 pts_array.to_external, points.upper)
      end
   
   draw_segments(gc : GDK_GC; segs : COLLECTION[GDK_SEGMENT] ) is 
      local 
	 segs_array : GDK_OBJECT_ARRAY 
      do
	 !!segs_array.from_collection(segs)
	 ext_draw_segments(gdkobject, gc.to_external, 
			   segs_array.to_external, segs.upper) 
      end
   
   draw_lines(gc : GDK_GC; points : COLLECTION[GDK_POINT]) is
      local
	 pts_array : GDK_OBJECT_ARRAY
      do
	 !!pts_array.from_collection(points)
	 ext_draw_lines(gdkobject, gc.to_external, pts_array.to_external, 
			points.upper)
      end

feature {NONE} -- Private
   ext_draw_point(p1, p2: POINTER; x, y: INTEGER) is
      external "C"
      alias "gdk_draw_point"
      end
   ext_draw_line(p1, p2 : POINTER; x1, y1, x2, y2 : INTEGER) is 
      external "C"
      alias "gdk_draw_line"
      end
   ext_draw_rectangle(p1, p2: POINTER; filled : BOOLEAN; 
		      x, y, w, h: INTEGER) is
      external "C"
      alias "gdk_draw_rectangle"
      end
   ext_draw_arc(p1, p2: POINTER; filled : BOOLEAN; 
		x, y, w, h, a1, a2 : INTEGER) is
      external "C"
      alias "gdk_draw_arc"
      end
   ext_draw_polygon(p1, p2: POINTER; filled: BOOLEAN; 
		    points : POINTER; npoints : INTEGER) is
      external "C"
      alias "gdk_draw_polygon"
      end
   ext_draw_string(p1, p2, p3: POINTER; x, y : INTEGER; 
		   string : POINTER) is
      external "C"
      alias "gdk_draw_string"
      end
   ext_draw_text(p1, p2, p3: POINTER; x, y : INTEGER; 
		 string : POINTER; len : INTEGER) is
      external "C"
      alias "gdk_draw_text"
      end
   ext_draw_pixmap(p1, p2, p3: POINTER; xs, ys, xd, yd, w, h: INTEGER) is
      external "C"
      alias "gdk_draw_pixmap"
      end
   ext_draw_image(p1, p2, p3: POINTER; xs, ys, xd, yd, w, h: INTEGER) is
      external "C"
      alias "gdk_draw_image"
      end
   ext_draw_points(p1, p2, p3: POINTER; n: INTEGER) is 
      external "C"
      alias "gdk_draw_points"
      end
   ext_draw_segments(p1, p2, p3: POINTER; n: INTEGER) is
      external "C"
      alias "gdk_draw_segments"
      end
   ext_draw_lines(p1, p2, p3: POINTER ; n: INTEGER) is 
      external "C"
      alias "gdk_draw_lines"
      end
invariant
end
