indexing
   description: "gdk pixmap"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen"
   id: "$Id: gdk_pixmap.e,v 1.7 1999/01/18 19:54:55 pcj Exp $"

-- This should be a lot smarter.  We want to avoid doing any more 
-- pixmap_creates than is absolutely necessary. 

class GDK_PIXMAP
inherit 
   GDK_OBJECT
   rename 
      create as gdk_object_create
   redefine
      make_default 
      end
creation
   make_default, 
   make_from_xpm, 
   make_from_xpm_d,
   create_pixmap
   
feature -- Creation

   create_pixmap ( pixptr, maskptr : POINTER ) is
      do
	 gdkobject := pixptr
	 !!mask.create(pixptr)
      end

   make_from_xpm (window : GDK_WINDOW; transparent_color : GDK_COLOR; 
		  filename : STRING) is
      do
	 gdkobject := ext_pixmap_create_from_xpm(window.to_external, $maskobj, 
						 transparent_color.to_external, 
						 filename.to_external)
	 !!mask.create(maskobj)
      end -- make

   make_from_xpm_d (window : GDK_WINDOW; transparent_color : GDK_COLOR; 
		    data : COLLECTION[STRING]) is
      local 
	 string_array : STRING_ARRAY
      do
	 !!string_array.from_collection(data)
	 gdkobject := 
	    ext_pixmap_create_from_xpm_d(window.to_external, $maskobj, 
				       transparent_color.to_external, 
				       string_array.to_external)
	 !!mask.create(maskobj)
      end

   make_default is
      do
	 gdkobject := default_pointer
	 !!mask.make_default
      end

feature {ANY} -- Queries
feature {ANY} -- Commands

   -- I think you have to do this explicitly. 
   destroy is 
      do
	 ext_pixmap_unref(gdkobject)
      end

   mask : GDK_BITMAP

feature {GTK_WIDGET}

   maskobj : POINTER

feature {NONE} -- Private

   ext_pixmap_create_from_xpm(c1, c2, c3, c4: POINTER) : POINTER is 
      external "C"
      alias "gdk_pixmap_create_from_xpm"
      end

   ext_pixmap_create_from_xpm_d(c1, c2, c3, c4: POINTER) : POINTER is 
      external "C"
      alias "gdk_pixmap_create_from_xpm_d"
      end

   ext_pixmap_unref(p: POINTER) is
      external "C"
      alias "gdk_pixmap_unref"
      end

invariant
end

