indexing
   description: "gdk window"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen"
   id: "$Id: gdk_window.e,v 1.6 1999/01/18 19:54:55 pcj Exp $"

class GDK_WINDOW
inherit GDK_OBJECT
creation
   make, create, make_default
feature -- Creation
   make is
      do
      end -- make
feature {ANY} -- Queries
feature {ANY} -- Commands
   set_cursor(cursor : GDK_CURSOR) is
      do
	 ext_set_cursor(gdkobject, cursor.to_external)
      end

   set_icon(icon_window : GDK_WINDOW ;
	    pixmap : GDK_PIXMAP) is
      do
	 ext_window_set_icon ( gdkobject, icon_window.to_external, 
			       pixmap.to_external, pixmap.mask.to_external)
      end
   set_icon_name(name : STRING) is
      do
	 ext_window_set_icon_name(gdkobject, name.to_external) 
      end

   set_decorations(decorations : GDK_WMDECORATION) is
      do
	 ext_window_set_decorations (gdkobject, decorations.value)
      end

   set_functions ( functions : GDK_WMFUNCTION ) is
      do
	 ext_window_set_functions ( gdkobject, functions.value )
      end
   
feature {NONE} -- Private
   ext_set_cursor(c_object, cursor : POINTER) is
      external "C"
      alias "gdk_window_set_cursor"
      end
   ext_window_set_icon ( c_object, icon_window, pixmap, mask : POINTER ) is
      external "C"
      alias "gdk_window_set_icon"
      end
   ext_window_set_icon_name ( c_object, name : POINTER ) is
      external "C"
      alias "gdk_window_set_icon_name"
      end
   ext_window_set_decorations ( c_object : POINTER ; decorations : INTEGER ) is
      external "C"
      alias "gdk_window_set_decorations"
      end
   ext_window_set_functions ( c_object : POINTER ; functions : INTEGER ) is
      external "C"
      alias "gdk_window_set_functions"
      end

invariant
end
