indexing
   description: "gtk accel group"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen"
   id: "$Id: gtk_accel_group.e,v 1.7 1999/01/18 19:54:56 pcj Exp $"

-- Missing: create_add, create_remove, entries_from_object, 
-- get_entry, handle_add, handle_remove, ref
class GTK_ACCEL_GROUP
inherit 
   MEMORY
      redefine dispose end
creation
   make, create, make_default
feature -- Creation
   make is
      do
	 gtkobject := ext_accel_group_new
      end -- make

   create ( p : POINTER ) is
      do
	 gtkobject := p 
      end

   make_default is
      do
	 gtkobject := ext_accel_group_get_default
      end

feature {ANY} -- Queries

   to_external : POINTER is
      do
	 Result := gtkobject
      end

feature {ANY} -- Commands

   activate ( accel_key : INTEGER ; 
	      accel_mods : GDK_MODIFIER_TYPE ) : BOOLEAN is
      do
	 Result := ext_accel_group_activate ( gtkobject, 
					      accel_key, accel_mods.value ) 
      end

   attach ( object : GTK_OBJECT ) is
      do
	 ext_accel_group_attach ( gtkobject, object.to_external ) 
      end

   detach ( object : GTK_OBJECT ) is
      do
	 ext_accel_group_detach ( gtkobject, object.to_external ) 
      end

   lock is
      do
	 ext_accel_group_lock ( gtkobject ) 
      end
	 
   unlock is
      do
	 ext_accel_group_unlock ( gtkobject ) 
      end

--    get_entry ( accel_key : INTEGER ; 
-- 	       accel_mods : GDK_MODIFIER_TYPE ) : GTK_ACCEL_ENTRY is
--       do
-- 	 !!Result.create(ext_accel_group_get_entry (gtkobject, 
-- 						    accel_key, 
-- 						    accel_mods.value ) )
--       end

   lock_entry ( accel_key : INTEGER ; accel_mods : GDK_MODIFIER_TYPE ) is
      do
	 ext_accel_group_lock_entry ( gtkobject, accel_key, accel_mods.value ) 
      end

   unlock_entry ( accel_key : INTEGER ; accel_mods : GDK_MODIFIER_TYPE ) is
      do
	 ext_accel_group_unlock_entry ( gtkobject, accel_key, 
					accel_mods.value ) 
      end

   add  ( accel_key : INTEGER ; accel_mods : GDK_MODIFIER_TYPE ;
	  accel_flags : GTK_ACCEL_FLAGS ; 
	  object : GTK_OBJECT ; 
	  accel_signal : STRING ) is
      do
	 ext_accel_group_add ( gtkobject, accel_key, accel_mods.value, 
			       accel_flags.value, 
			       object.to_external, 
			       accel_signal.to_external ) 
      end

   remove ( accel_key : INTEGER ; 
	    accel_mods : GDK_MODIFIER_TYPE ; 
	    object : GTK_OBJECT ) is
      do
	 ext_accel_group_remove ( gtkobject, accel_key, accel_mods.value, 
				  object.to_external ) 
      end

feature {NONE} -- Private
   gtkobject : POINTER 

   ext_accel_group_new : POINTER is
      external "C"
      alias "gtk_accel_group_new"
      end

   ext_accel_group_get_default : POINTER is
      external "C"
      alias "gtk_accel_group_get_default"
      end

   ext_accel_group_activate ( accel_group : POINTER ; 
			      accel_key, accel_mods : INTEGER ) : BOOLEAN is
      external "C"
      alias "gtk_accel_group_activate"
      end

   
   ext_accel_group_attach ( accel_group, object : POINTER ) is
      external "C"
      alias "gtk_accel_group_attach"
      end

   ext_accel_group_detach ( accel_group, object : POINTER ) is
      external "C"
      alias "gtk_accel_group_detach"
      end

   ext_accel_group_lock ( accel_group : POINTER ) is
      external "C"
      alias "gtk_accel_group_lock"
      end

   ext_accel_group_unlock ( accel_group : POINTER ) is
      external "C"
      alias "gtk_accel_group_unlock"
      end

   ext_accel_group_lock_entry ( accel_group : POINTER ; 
				accel_key, accel_mods  : INTEGER ) is
      external "C"
      alias "gtk_accel_group_lock_entry"
      end

   ext_accel_group_unlock_entry ( accel_group : POINTER ; 
				accel_key, accel_mods  : INTEGER ) is
      external "C"
      alias "gtk_accel_group_unlock_entry"
      end


   ext_accel_group_add ( accel_group : POINTER ; 
			 accel_key, accel_mods, accel_flags : INTEGER ; 
			 object, accel_signal : POINTER ) is
      external "C"
      alias "gtk_accel_group_add"
      end

   ext_accel_group_remove ( accel_group : POINTER ; 
			    accel_key, accel_mods : INTEGER ; 
			    object : POINTER ) is
      external "C"
      alias "gtk_accel_group_remove"
      end

   dispose is
      do
	 ext_accel_group_unref ( gtkobject ) 
      end

   ext_accel_group_unref ( accel_group : POINTER ) is
      external "C"
      alias "gtk_accel_group_unref" 
      end

invariant
end 

