indexing
   description: "gtk accel label"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen"
   id: "$Id: gtk_accel_label.e,v 1.4 1999/01/18 19:54:56 pcj Exp $"

class GTK_ACCEL_LABEL
inherit 
   GTK_LABEL
   redefine make, make_with_label
creation
   make, make_with_label, create
feature -- Creation
   make, make_with_label ( label : STRING ) is
      do
	 gtkobject := ext_accel_label_new ( label.to_external ) 
      end
   
feature -- Commands

   get_accel_width : INTEGER is
      do
	 Result := ext_accel_label_get_accel_width ( gtkobject ) 
      end

   set_accel_widget ( accel_widget : GTK_WIDGET ) is
      do
	 ext_accel_label_set_accel_widget ( gtkobject, accel_widget.to_external ) 
      end
   
   refetch : BOOLEAN is
      do
	 Result := ext_accel_label_refetch ( gtkobject ) 
      end

feature {NONE} -- Private

   ext_accel_label_new ( label : POINTER ) : POINTER is
      external "C"
      alias "gtk_accel_label_new"
      end

   ext_accel_label_get_accel_width ( accel_label : POINTER ) : INTEGER is
      external "C"
      alias "gtk_accel_label_get_accel_width"
      end

   ext_accel_label_set_accel_widget ( accel_label, accel_widget : POINTER ) is
      external "C"
      alias "gtk_accel_label_set_accel_widget"
      end

   ext_accel_label_refetch ( accel_label : POINTER ) : BOOLEAN is
      external "C"
      alias "gtk_accel_label_refetch"
      end

invariant
end 

