indexing
   description: "gtk accelerator"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen"
   id: "$Id: gtk_accelerator.e,v 1.4 1999/01/18 19:54:56 pcj Exp $"

class GTK_ACCELERATOR
feature
   valid ( keyval : INTEGER ; 
	   modifiers : GDK_MODIFIER_TYPE ) : BOOLEAN is
      do
	 Result := ext_accelerator_valid (keyval, modifiers.value)
      end

   parse_key ( accelerator : STRING ) : INTEGER is
      do
	 ext_accelerator_parse ( accelerator.to_external, $key, $mods )
	 Result := key
      end

   parse_mods ( accelerator : STRING ) : GDK_MODIFIER_TYPE is
      do
	 ext_accelerator_parse ( accelerator.to_external, $key, $mods)
	 !!Result.make(mods) 
      end

   name ( accelerator_key : INTEGER; 
	  accelerator_mods : GDK_MODIFIER_TYPE ) : STRING is
      do
	 !!Result.from_external ( ext_accelerator_name ( accelerator_key, 
							 accelerator_mods.value))
      end

   set_default_mod_mask ( default_mod_mask : GDK_MODIFIER_TYPE ) is
      do
	 ext_set_default_mod_mask ( default_mod_mask.value  ) 
      end

   get_default_mod_mask : INTEGER is
      do
	 Result := ext_get_default_mod_mask 
      end

feature {NONE} 
   
   ext_accelerator_valid ( keyval, modifiers : INTEGER ) : BOOLEAN is
      external "C"
      alias "gtk_accelerator_valid" 
      end

   ext_accelerator_name ( accelerator_key, 
			  accelerator_mods : INTEGER ) : POINTER is
      external "C"
      alias "gtk_accelerator_name"
      end

   ext_accelerator_parse ( accelerator, accelerator_key, 
			   accelerator_mods : POINTER ) is
      external "C" 
      alias "gtk_accelerator_parse"
      end

   ext_set_default_mod_mask ( default_mod_mask : INTEGER ) is
      external "C"
      alias "gtk_accelerator_set_default_mod_mask" 
      end
   
   ext_get_default_mod_mask : INTEGER is
      external "C"
      alias "gtk_accelerator_get_default_mod_mask"
      end

   key, mods : INTEGER 

end 

