indexing
   description: "gtk adjustment"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen and Francois Pennaneach"
   id: "$Id: gtk_adjustment.e,v 1.8 1999/01/18 19:54:56 pcj Exp $"

class GTK_ADJUSTMENT
inherit
   GTK_DATA
creation
   make, 
   make_default, 
   create
feature -- Creation
   make(value_, lower_, upper_, 
	step_increment_, page_increment_, page_size_ : REAL) is
      do
	 gtkobject := ext_adjustment_new(value_, lower_, upper_, 
					 step_increment_, 
					 page_increment_, page_size_)
      end -- make
   
   make_default is
      do
	 gtkobject := ext_adjustment_new (0.0, 0.0, 0.0, 
					  0.0, 0.0, 0.0)
      end

feature {ANY} -- Queries
   lower : REAL is
      do
	 Result := ext_adjustment_lower(gtkobject)
      end
   upper : REAL is
      do
	 Result := ext_adjustment_upper(gtkobject)
      end
   value : REAL is
      do
	 Result := ext_adjustment_value(gtkobject)
      end
   step_increment : REAL is
      do
	 Result := ext_adjustment_step_increment(gtkobject)
      end
   page_increment : REAL is
      do
	 Result := ext_adjustment_page_increment(gtkobject)
      end
   page_size : REAL is
      do
	 Result := ext_adjustment_page_size(gtkobject)
      end

feature {ANY} -- Commands

   changed is
      do
	 ext_adjustment_changed(gtkobject) 
      end

   value_changed is
      do
	 ext_adjustment_value_changed(gtkobject)
      end

   set_value(value_ : REAL) is
      do
	 ext_set_value(gtkobject, value_)
      end

   clamp_page(lower_, upper_ : REAL) is
      do
	 ext_clamp_page(gtkobject, lower_, upper_)
      end

feature {NONE} -- Private
   ext_adjustment_new ( value_, lower_, upper_, step_increment_, 
			page_increment_, page_size_ : REAL ) : POINTER is
      external "C"
      alias "gtk_adjustment_new"
      end

   ext_set_value(c_object : POINTER;  upper_ : REAL)  is
      external "C"
      alias "gtk_adjustment_set_value"
      end

   ext_clamp_page(c_object : POINTER; lower_, upper_ : REAL) is
      external "C"
      alias "gtk_adjustment_clamp_page"
      end

   ext_adjustment_changed ( c_object : POINTER ) is
      external "C"
      alias "gtk_adjustment_changed"
      end

   ext_adjustment_value_changed ( c_object : POINTER ) is
      external "C"
      alias "gtk_adjustment_value_changed"
      end

   ext_adjustment_lower(c_object : POINTER) : REAL is
      external "C"
      end

   ext_adjustment_upper(c_object : POINTER) : REAL is
      external "C"
      end

   ext_adjustment_value(c_object : POINTER) : REAL is
      external "C"
      end

   ext_adjustment_step_increment(c_object : POINTER) : REAL is
      external "C"
      end

   ext_adjustment_page_increment(c_object : POINTER) : REAL is
      external "C"
      end

   ext_adjustment_page_size(c_object : POINTER) : REAL is
      external "C"
      end

invariant
end -- GTK_ADJUSTMENT

