indexing
   description: "gtk box"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen and Francois Pennaneach"
   id: "$Id: gtk_box.e,v 1.8 1999/01/18 19:54:56 pcj Exp $"

-- missing: query_child_packing
class GTK_BOX
inherit
   GTK_CONTAINER
feature -- Creation
feature {ANY} -- Queries
feature {ANY} -- Commands

   -- children : ARRAY[GTK_BOX_CHILD]
   -- spacing : INTEGER 
   -- homogeneous : BOOLEAN

   pack_end(child : GTK_WIDGET; expand, fill : BOOLEAN ;  padding : INTEGER) is
      do
	 ext_pack_end(gtkobject, child.to_external, expand, fill, padding)
      end -- pack_end

   pack_end_defaults(child : GTK_WIDGET) is
      do
	 ext_pack_end_defaults(gtkobject, child.to_external)
      end -- pack_end_defaults

   pack_start(child : GTK_WIDGET; expand, fill : BOOLEAN; padding : INTEGER) is
      do
	 ext_pack_start(gtkobject, child.to_external, expand, fill, padding)
      end -- pack_start

   pack_start_defaults(child : GTK_WIDGET) is
      do
	 ext_pack_start_defaults(gtkobject, child.to_external)
      end -- pack_start_default

   reorder_child ( child : GTK_WIDGET ; pos : INTEGER ) is
      do
         ext_reorder_child ( gtkobject, child.to_external, pos )
      end

   set_child_packing ( child : GTK_WIDGET ; expand, fill : BOOLEAN ; 
		       padding : INTEGER ; pack_type : GTK_PACK_TYPE ) is
      do
         ext_set_child_packing ( gtkobject, child.to_external, expand, 
				 fill, padding, pack_type.value )
      end

   set_homogeneous(homogeneous : BOOLEAN) is
      do
	 ext_set_homogeneous(gtkobject, homogeneous)
      end -- set_homogeneous

   set_spacing(spacing : INTEGER) is
      do
	 ext_set_spacing(gtkobject, spacing)
      end -- set_spacing

feature {NONE} -- Private
   ext_pack_end(c_object, child : POINTER; expand, fill : BOOLEAN ;
		padding : INTEGER) is
      external "C"
      alias "gtk_box_pack_end"
      end -- ext_pack_end

   ext_pack_end_defaults(c_object, child : POINTER) is
      external "C"
      alias "gtk_box_pack_end_defaults"
      end -- ext_pack_end_defaults

   ext_pack_start(c_object, child : POINTER; 
		  expand, fill : BOOLEAN; padding : INTEGER) is
      external "C"
      alias "gtk_box_pack_start"
      end -- ext_pack_start

   ext_pack_start_defaults(c_object, child : POINTER) is
      external "C"
      alias "gtk_box_pack_start_defaults"
      end -- ext_pack_start_defaults

   ext_reorder_child ( box, child : POINTER ; pos : INTEGER ) is
      external "C"
      alias "gtk_box_reorder_child"
      end

   ext_set_child_packing ( box, child : POINTER ; 
			   expand, fill : BOOLEAN ;
			   padding, pack_type : INTEGER ) is
      external "C"
      alias "gtk_box_set_child_packing"
      end

   ext_set_homogeneous(c_object : POINTER; homogeneous : BOOLEAN) is
      external "C"
      alias "gtk_box_set_homogeneous"
      end -- ext_set_homogeneous

   ext_set_spacing(c_object : POINTER; spacing : INTEGER) is
      external "C"
      alias "gtk_box_set_spacing"
      end -- ext_set_spacing
invariant
end -- GTK_BOX

