indexing
   description: "gtk button"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen and Francois Pennaneach"
   id: "$Id: gtk_button.e,v 1.6 1999/01/18 19:54:56 pcj Exp $"

class GTK_BUTTON
   -- implements a GTK_BUTTON
inherit
   GTK_CONTAINER
creation
   create,
   make,
   make_with_label -- make a new button with a label
feature -- Creation
   make is
	 -- Creation and initialization
	 -- without a label
      do
	 gtkobject := ext_button_new
      end -- make

   make_with_label(label : STRING) is
	 -- Creation and initialization
	 -- make a new button with a label
      require
	 label /= Void
      do
	 gtkobject := ext_new_with_label(label.to_external)
      end -- make_with_label

   clicked is
      do
	 ext_clicked(gtkobject)
      end -- clicked

   enter is
      do
	 ext_enter(gtkobject)
      end -- enter
   
   leave is
      do
	 ext_leave(gtkobject)
      end -- leave

   pressed is
      do
	 ext_pressed(gtkobject)
      end -- pressed

   released is
      do
	 ext_released(gtkobject)
      end -- released
   
feature {ANY} -- Queries
   
   get_relief : GTK_RELIEF_STYLE is
      do
	 !!Result.make(ext_button_get_relief(gtkobject))
      end

feature {ANY} -- Commands

   set_relief ( newstyle : GTK_RELIEF_STYLE ) is
      do
	 ext_button_set_relief(gtkobject, newstyle.value)
      end

   add_clicked_action(command : GTK_COMMAND; data : ANY) is
      do
	 add_action("clicked", command, data)
      end -- add_clicked_ation

   add_enter_action(command : GTK_COMMAND; data : ANY) is
      do
	 add_action("enter", command, data)
      end -- add_enter_action

feature {NONE} -- Private, calls to external functions

   ext_button_new : POINTER is
      external "C"
      alias "gtk_button_new"
      end -- ext_new

   ext_new_with_label(s : POINTER) : POINTER is
      external "C"
      alias "gtk_button_new_with_label"
      end -- ext_new_with_label

   ext_clicked(c_object : POINTER) is
      external "C"
      alias "gtk_button_clicked"
      end -- ext_clicked

   ext_enter(c_object : POINTER) is
      external "C"
      alias "gtk_button_enter"
      end -- ext_enter
   
   ext_leave(c_object : POINTER) is
      external "C"
      alias "gtk_button_leave"
      end -- ext_leave
  
   ext_pressed(c_object : POINTER) is
      external "C"
      alias "gtk_button_pressed"
      end -- ext_pressed

   ext_released(c_object : POINTER) is
      external "C"
      alias "gtk_button_released"
      end -- ext_released

   ext_button_set_relief ( button : POINTER ; newstyle : INTEGER ) is
      external "C"
      alias "gtk_button_set_relief"
      end

   ext_button_get_relief ( button : POINTER ) : INTEGER is
      external "C"
      alias "gtk_button_get_relief"
      end

invariant
end -- GTK_BUTTON

