indexing
   description: "gtk button box"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen and Francois Pennaneach"
   id: "$Id: gtk_button_box.e,v 1.7 1999/01/18 19:54:56 pcj Exp $"

-- missing: child_requisition
deferred class GTK_BUTTON_BOX
inherit
   GTK_BOX
   redefine 
      set_spacing, 
      ext_set_spacing      
      end
feature -- Creation
feature {ANY} -- Queries
   type : INTEGER is
      deferred
      end -- type
   
   get_layout : GTK_BUTTON_BOX_STYLE is 
      do 
	 !!Result.make(ext_get_layout(gtkobject))
      end

   get_spacing : INTEGER is
      do
	 Result := ext_get_spacing ( gtkobject )
      end 

   get_child_size_default_width : INTEGER is
      do
	 ext_get_child_size_default ( $dummy1, $dummy2 ) 
	 Result := dummy1
      end

   get_child_size_width : INTEGER is
      do
	 ext_get_child_size ( gtkobject, $dummy1, $dummy2 ) 
	 Result := dummy1
      end

   get_child_size_default_height : INTEGER is
      do
	 ext_get_child_size_default ( $dummy1, $dummy2 ) 
	 Result := dummy2
      end

   get_child_size_height : INTEGER is
      do
	 ext_get_child_size ( gtkobject, $dummy1, $dummy2 ) 
	 Result := dummy2
      end
	 
feature {ANY} -- Commands

   set_child_ipadding ( ipad_x, ipad_y : INTEGER ) is
      do
         ext_set_child_ipadding ( gtkobject, ipad_x, ipad_y )
      end

   set_child_ipadding_default ( ipad_x, ipad_y : INTEGER ) is
      do
         ext_set_child_ipadding_default ( ipad_x, ipad_y )
      end

   set_child_size(min_width, min_height : INTEGER) is
      do
	 ext_set_child_size(gtkobject, min_width, min_height)
      end -- set_child_size

   set_child_size_default ( min_width, min_height : INTEGER ) is
      do
         ext_set_child_size_default ( min_width, min_height )
      end

   set_layout(layout_style : GTK_BUTTON_BOX_STYLE ) is
      do
	 ext_set_layout(gtkobject, layout_style.value)
      end -- set_layout

   set_spacing ( spacing : INTEGER ) is
      do
         ext_set_spacing ( gtkobject, spacing )
      end

feature {NONE} -- Private

   dummy1, dummy2 : INTEGER

   ext_get_layout ( widget : POINTER ) : INTEGER is
      external "C"
      alias "gtk_button_box_get_layout"
      end

   ext_get_spacing ( widget : POINTER ) : INTEGER is
      external "C"
      alias "gtk_button_box_get_spacing"
      end

   ext_get_child_size_default ( min_width, min_height : POINTER ) is
      external "C"
      alias "gtk_button_box_get_child_size_default"
      end

   ext_get_child_size ( widget, min_width, min_height : POINTER ) is
      external "C"
      alias "gtk_button_box_get_child_size"
      end

   ext_get_child_ipadding_default ( ipad_x, ipad_y : POINTER ) is
      external "C"
      alias "gtk_button_box_get_child_ipadding_default"
      end

   ext_get_child_ipadding ( widget, ipad_x, ipad_y : POINTER ) is
      external "C"
      alias "gtk_button_box_get_child_ipadding"
      end

   ext_set_child_ipadding ( widget : POINTER ; ipad_x, ipad_y : INTEGER ) is
      external "C"
      alias "gtk_button_box_set_child_ipadding"
      end

   ext_set_child_ipadding_default ( ipad_x, ipad_y : INTEGER ) is
      external "C"
      alias "gtk_button_box_set_child_ipadding_default"
      end

   ext_set_child_size(c_object : POINTER; min_width, min_height : INTEGER) is
      external "C"
      alias "gtk_button_box_set_child_size"
      end -- ext_set_child_size

   ext_set_child_size_default ( min_width, min_height : INTEGER ) is
      external "C"
      alias "gtk_button_box_set_child_size_default"
      end

   ext_set_layout(c_object : POINTER; layout_style : INTEGER) is
      external "C"
      alias "gtk_button_box_set_layout"
      end -- ext_set_layout

   ext_set_spacing ( widget : POINTER ; spacing : INTEGER ) is
      external "C"
      alias "gtk_button_box_set_spacing"
      end

invariant
end -- GTK_BUTTON_BOX

