indexing
   description: "gtk calendar"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen"
   id: "$Id: gtk_calendar.e,v 1.4 1999/01/18 19:54:56 pcj Exp $"

class GTK_CALENDAR
inherit 
   GTK_WIDGET
creation
   make, create
feature -- Creation
   make is
      do
	 gtkobject := ext_calendar_new
      end -- make

   select_month ( month, year : INTEGER ) : INTEGER is
      require 
	 month >= 0
	 year >= 0 
      do
	 Result := ext_calendar_select_month ( gtkobject, 
					       month, year )
      end

   select_day ( day : INTEGER ) is
      require 
	 day >= 0 
      do
	 ext_calendar_select_day ( gtkobject, day ) 
      end

   mark_day ( day : INTEGER ) : INTEGER is
      require 
	 day >= 0 
      do
	 Result := ext_calendar_mark_day ( gtkobject, day ) 
      end

   unmark_day ( day : INTEGER ) : INTEGER is
      require
	 day >= 0 
      do
	 Result := ext_calendar_unmark_day ( gtkobject, day ) 
      end

   clear_marks is
      do
	 ext_calendar_clear_marks ( gtkobject ) 
      end

   display_options ( flags : GTK_CALENDAR_DISPLAY_OPTIONS ) is
      do
	 ext_calendar_display_options ( gtkobject, flags.value ) 
      end

   get_date_year : INTEGER is
      do
	 ext_calendar_get_date ( gtkobject, $dateint, 
				 default_pointer, 
				 default_pointer ) 
	 Result := dateint
      end
			
   get_date_month : INTEGER is
      do
	 ext_calendar_get_date ( gtkobject, default_pointer, 
				 $dateint, default_pointer ) 
	 Result := dateint
      end

   get_date_day : INTEGER is
      do
	 ext_calendar_get_date ( gtkobject, default_pointer, 
				 default_pointer, $dateint ) 
	 Result := dateint
      end

   freeze is
      do
	 ext_calendar_freeze ( gtkobject ) 
      end
	 
   thaw is
      do
	 ext_calendar_thaw ( gtkobject )
      end

feature {NONE} -- Private

   dateint : INTEGER 

   ext_calendar_new : POINTER is
      external "C"
      alias "gtk_calendar_new"
      end

   ext_calendar_select_month ( calendar : POINTER ; 
			       month, year : INTEGER ) : INTEGER is
      external "C"
      alias "gtk_calendar_select_month"
      end

   ext_calendar_select_day ( calendar : POINTER ; day : INTEGER ) is
      external "C"
      alias "gtk_calendar_select_day" 
      end

   ext_calendar_mark_day ( calendar : POINTER ; day : INTEGER ) : INTEGER is
      external "C"
      alias "gtk_calendar_mark_day"
      end

   ext_calendar_unmark_day ( calendar : POINTER ; day : INTEGER ) : INTEGER is
      external "C"
      alias "gtk_calendar_unmark_day"
      end

   ext_calendar_clear_marks ( calendar : POINTER ) is
      external "C"
      alias "gtk_calendar_clear_marks"
      end

   ext_calendar_display_options ( calendar : POINTER ; flags : INTEGER ) is
      external "C"
      alias "gtk_calendar_display_options"
      end

   ext_calendar_get_date ( calendar, year, month, day : POINTER ) is
      external "C"
      alias "gtk_calendar_get_date"
      end

   ext_calendar_freeze ( calendar : POINTER ) is
      external "C"
      alias "gtk_calendar_freeze"
      end

   ext_calendar_thaw ( calendar : POINTER ) is
      external "C"
      alias "gtk_calendar_thaw"
      end

invariant
end 

