indexing
   description: "gtk check menu item"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen and Francois Pennaneach"
   id: "$Id: gtk_check_menu_item.e,v 1.5 1999/01/18 19:54:56 pcj Exp $"

class GTK_CHECK_MENU_ITEM
inherit
   GTK_MENU_ITEM
      redefine
	 make,
	 make_with_label
      end;
creation
   make,
   make_with_label,
   create
feature -- Creation
   make is
      -- Creation and initialization
      do
	 gtkobject := ext_check_menu_item_new
      end -- make

   make_with_label(label : STRING) is
      do
	 gtkobject := ext_new_with_label(label.to_external)
      end -- make_with_label

feature {ANY} -- Queries
feature {ANY} -- Commands
   set_active(is_active : BOOLEAN ) is
      do
	 ext_set_active(gtkobject, is_active)
      end

   toggled is
      do
	 ext_toggled(gtkobject)
      end -- toggled

   set_show_toggle ( always : BOOLEAN ) is
      do
         ext_set_show_toggle ( gtkobject, always )
      end
   

feature {NONE} -- Private
   ext_check_menu_item_new : POINTER is
      external "C"
      alias "gtk_check_menu_item_new"
      end 

   ext_new_with_label(label : POINTER) : POINTER is
      external "C"
      alias "gtk_check_menu_item_new_with_label"
      end 

   ext_set_active(c_object : POINTER; is_active : BOOLEAN ) is
      external "C"
      alias "gtk_check_menu_item_set_active"
      end 

   ext_toggled(c_object : POINTER) is
      external "C"
      alias "gtk_check_menu_item_toggled"
      end 

   ext_set_show_toggle ( menu_item : POINTER ; always : BOOLEAN ) is
      external "C"
      alias "gtk_check_menu_item_set_show_toggle"
      end


invariant
end -- GTK_CHECK_MENU_ITEM

