indexing
   description: "gtk clist ctree type"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen"
   id: "$Id: gtk_clist_ctree_type.e,v 1.5 1999/01/18 19:54:56 pcj Exp $"

deferred class GTK_CLIST_CTREE_TYPE
inherit 
   GTK_CONTAINER
      rename remove as container_remove 
      end
feature {ANY} 

   get_hadjustment : GTK_ADJUSTMENT  is
      do
	 !!Result.create(ext_clist_get_hadjustment(gtkobject))
      end

   get_vadjustment : GTK_ADJUSTMENT  is
      do
	 !!Result.create(ext_clist_get_vadjustment(gtkobject))
      end
   
   get_column_title ( column : INTEGER ) : STRING is
      local 
	 ptitle : POINTER
      do
	 ptitle := ext_clist_get_column_title ( gtkobject, column )
	 if ptitle = default_pointer then
	    Result := Void
	 else
	    !!Result.from_external(ptitle)
	 end
      end

   set_hadjustment ( adjustment : GTK_ADJUSTMENT ) is
      do
	 ext_clist_set_hadjustment ( gtkobject, adjustment.to_external ) 
      end

   set_vadjustment ( adjustment : GTK_ADJUSTMENT ) is
      do
	 ext_clist_set_vadjustment ( gtkobject, adjustment.to_external )
      end

   columns_autosize : INTEGER is
      do
	 Result := ext_clist_columns_autosize ( gtkobject ) 
      end

   optimal_column_width ( column : INTEGER ) : INTEGER is
      do
	 Result := ext_clist_optimal_column_width (gtkobject, column)
      end

   set_column_min_width ( column, min_width : INTEGER ) is
      do
	 ext_clist_set_column_min_width (gtkobject, column, min_width) 
      end

   set_column_max_width ( column, max_width : INTEGER ) is
      do
	 ext_clist_set_column_max_width (gtkobject, column, max_width) 
      end

   undo_selection is
      do
	 ext_clist_undo_selection ( gtkobject )
      end

   select_all is
      do
	 ext_clist_select_all (gtkobject)
      end

   unselect_all is
      do
	 ext_clist_unselect_all (gtkobject)
      end

   set_auto_sort ( auto_sort : BOOLEAN ) is
      do
	 ext_clist_set_auto_sort ( gtkobject, auto_sort )
      end

   clear  is
      do
         ext_clist_clear ( gtkobject )
      end

   column_title_active ( column : INTEGER ) is
      do
         ext_clist_column_title_active ( gtkobject, column )
      end

   column_title_passive ( column : INTEGER ) is
      do
         ext_clist_column_title_passive ( gtkobject, column )
      end

   column_titles_active is
      do
         ext_clist_column_titles_active ( gtkobject )
      end

   column_titles_passive is
      do
         ext_clist_column_titles_passive ( gtkobject )
      end

   column_titles_hide is
      do
         ext_clist_column_titles_hide ( gtkobject )
      end

   column_titles_show is
      do
         ext_clist_column_titles_show ( gtkobject )
      end

   freeze is
      do
         ext_clist_freeze ( gtkobject )
      end

   set_shadow_type ( type : GTK_SHADOW_TYPE ) is
      do
         ext_clist_set_shadow_type ( gtkobject, type.value )
      end

   set_column_justification ( column : INTEGER ; 
			      justification : GTK_JUSTIFICATION ) is
      do
         ext_clist_set_column_justification ( gtkobject, column, 
					      justification.value )
      end

   set_column_visibility ( column : INTEGER ; visible_ : BOOLEAN ) is
      do
	 ext_clist_set_column_visibility ( gtkobject, column, visible_ )
      end
   
   set_column_resizeable ( column : INTEGER ; resizeable : BOOLEAN ) is
      do
	 ext_clist_set_column_resizeable ( gtkobject, column, resizeable ) 
      end

   set_column_auto_resize ( column : INTEGER ; auto_resize : BOOLEAN ) is
      do
	 ext_clist_set_column_auto_resize ( gtkobject, column, auto_resize ) 
      end
   
   set_column_title ( column : INTEGER ; title : STRING ) is
      do
         ext_clist_set_column_title ( gtkobject, column, title.to_external )
      end

   set_column_widget ( column : INTEGER ; widget : GTK_WIDGET ) is
      do
         ext_clist_set_column_widget ( gtkobject, column, widget.to_external )
      end

   set_column_width ( column, width : INTEGER ) is
      do
         ext_clist_set_column_width ( gtkobject, column, width )
      end

   set_row_height ( height : INTEGER ) is
      do
         ext_clist_set_row_height ( gtkobject, height )
      end

   set_selection_mode ( mode : GTK_SELECTION_MODE ) is
      do
         ext_clist_set_selection_mode ( gtkobject, mode.value )
      end

   thaw is
      do
         ext_clist_thaw ( gtkobject )
      end

   set_reorderable ( reorderable : BOOLEAN ) is
      do
	 ext_clist_set_reorderable ( gtkobject, reorderable ) 
      end
	 
   set_use_drag_icons ( use_icon : BOOLEAN ) is
      do
	 ext_clist_set_use_drag_icons ( gtkobject, use_icon ) 
      end
   
   set_button_actions ( button, button_actions : INTEGER ) is
      do
	 ext_clist_set_button_actions ( gtkobject, button, button_actions ) 
      end

   --   get_column_widget

feature {NONE} -- Private

   ext_clist_get_hadjustment ( clist : POINTER ) : POINTER is
      external "C"
      alias "gtk_clist_get_hadjustment"
      end

   ext_clist_get_vadjustment ( clist : POINTER ) : POINTER is
      external "C"
      alias "gtk_clist_get_vadjustment"
      end

   ext_clist_get_column_title ( clist : POINTER; 
				column : INTEGER ) : POINTER is
      external "C"
      alias "gtk_clist_get_column_title"
      end

   ext_clist_set_hadjustment ( clist, adjustment : POINTER ) is
      external "C"
      alias "gtk_clist_set_hadjustment"
      end

   ext_clist_set_vadjustment ( clist, adjustment : POINTER ) is
      external "C"
      alias "gtk_clist_set_vadjustment"
      end

   ext_clist_columns_autosize ( clist : POINTER ) : INTEGER is
      external "C"
      alias "gtk_clist_columns_autosize"
      end

   ext_clist_optimal_column_width ( clist : POINTER ; 
				    column : INTEGER ) : INTEGER is
      external "C"
      alias "gtk_clist_optimal_column_width"
      end

   ext_clist_set_column_min_width ( clist : POINTER ; 
				    column, min_width : INTEGER ) is
      external "C"
      alias "gtk_clist_set_column_min_width"
      end

   ext_clist_set_column_max_width ( clist : POINTER ; 
				    column, max_width : INTEGER ) is
      external "C"
      alias "gtk_clist_set_column_max_width"
      end
   
   ext_clist_undo_selection ( clist : POINTER ) is
      external "C"
      alias "gtk_clist_undo_selection"
      end

   ext_clist_select_all ( clist : POINTER ) is
      external "C"
      alias "gtk_clist_select_all"
      end

   ext_clist_unselect_all ( clist : POINTER ) is
      external "C"
      alias "gtk_clist_unselect_all"
      end

   ext_clist_set_auto_sort ( clist : POINTER ; auto_sort : BOOLEAN ) is
      external "C"
      alias "gtk_clist_set_auto_sort"
      end

   ext_clist_clear ( clist : POINTER ) is
      external "C"
      alias "gtk_clist_clear"
      end

   ext_clist_column_title_active ( clist : POINTER ; column : INTEGER ) is
      external "C"
      alias "gtk_clist_column_title_active"
      end

   ext_clist_column_title_passive ( clist : POINTER ; column : INTEGER ) is
      external "C"
      alias "gtk_clist_column_title_passive"
      end

   ext_clist_column_titles_active ( clist : POINTER ) is
      external "C"
      alias "gtk_clist_column_titles_active"
      end

   ext_clist_column_titles_hide ( clist : POINTER ) is
      external "C"
      alias "gtk_clist_column_titles_hide"
      end

   ext_clist_column_titles_passive ( clist : POINTER ) is
      external "C"
      alias "gtk_clist_column_titles_passive"
      end

   ext_clist_column_titles_show ( clist : POINTER ) is
      external "C"
      alias "gtk_clist_column_titles_show"
      end

   ext_clist_freeze ( clist : POINTER ) is
      external "C"
      alias "gtk_clist_freeze"
      end

   ext_clist_set_shadow_type ( clist : POINTER ; type : INTEGER ) is
      external "C"
      alias "gtk_clist_set_shadow_type"
      end

   ext_clist_set_column_justification ( clist : POINTER ; 
					column, justification : INTEGER ) is
      external "C"
      alias "gtk_clist_set_column_justification"
      end

   ext_clist_set_column_visibility ( clist : POINTER ; column : INTEGER ;
				     visible_ : BOOLEAN ) is
      external "C"
      alias "gtk_clist_set_column_visibility"
      end
   
   ext_clist_set_column_resizeable ( clist : POINTER ; column : INTEGER ; 
				     resizeable : BOOLEAN ) is
      external "C"
      alias "gtk_clist_set_column_resizeable"
      end
                                                      
   ext_clist_set_column_auto_resize ( clist : POINTER ; column : INTEGER ; 
				      auto_resize : BOOLEAN ) is
      external "C"
      alias "gtk_clist_set_column_auto_resize" 
      end

   ext_clist_set_column_title ( clist : POINTER ; 
				column : INTEGER ; title : POINTER ) is
      external "C"
      alias "gtk_clist_set_column_title"
      end

   ext_clist_set_column_widget ( clist : POINTER ; 
				 column : INTEGER ; widget : POINTER ) is
      external "C"
      alias "gtk_clist_set_column_widget"
      end

   ext_clist_set_column_width ( clist : POINTER ; column, width : INTEGER ) is
      external "C"
      alias "gtk_clist_set_column_width"
      end

   ext_clist_set_row_height ( clist : POINTER ; height : INTEGER ) is
      external "C"
      alias "gtk_clist_set_row_height"
      end

   ext_clist_set_selection_mode ( clist : POINTER; mode : INTEGER ) is
      external "C"
      alias "gtk_clist_set_selection_mode"
      end

   ext_clist_thaw ( clist : POINTER ) is
      external "C"
      alias "gtk_clist_thaw"
      end

   ext_clist_set_reorderable ( clist : POINTER ; reorderable : BOOLEAN ) is
      external "C"
      alias "gtk_clist_set_reorderable"
      end

   ext_clist_set_use_drag_icons ( clist : POINTER ; use_icon : BOOLEAN ) is
      external "C"
      alias "gtk_clist_set_use_drag_icons"
      end

   ext_clist_set_button_actions ( clist : POINTER ; 
				  button, button_actions : INTEGER ) is
      external "C"
      alias "gtk_clist_set_button_actions"
      end

invariant
end 

