indexing
   description: "gtk color selection"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen and Francois Pennaneach"
   id: "$Id: gtk_color_selection.e,v 1.5 1999/01/18 19:54:56 pcj Exp $"

class GTK_COLOR_SELECTION
inherit
   GTK_VBOX
      rename make as make_vbox
      end
creation
   make_color_selection,
   create
feature -- Creation
   make_color_selection is
      do
	 gtkobject := ext_color_selection_new
      end -- make

feature {ANY} -- Commands

   set_opacity ( use_opacity : BOOLEAN ) is
      do
         ext_color_selection_set_opacity ( gtkobject, use_opacity )
      end

   set_update_policy ( policy : GTK_UPDATE_TYPE ) is
      do
         ext_color_selection_set_update_policy ( gtkobject, policy.value )
      end

   set_color ( color : ARRAYED_COLLECTION[DOUBLE] ) is 
      require 
	 color.count >= 4
      do
	 ext_color_selection_set_color(gtkobject, color.to_external)
      end

feature {ANY} -- Queries

   get_color : FIXED_ARRAY[DOUBLE] is
      do
	 !!Result.make(4)
	 ext_color_selection_get_color(gtkobject, Result.to_external)
      end

feature {NONE} -- Private

   ext_color_selection_new : POINTER is
      external "C"
      alias "gtk_color_selection_new"
      end -- ext_color_selection_new

   ext_color_selection_set_opacity ( colorsel : POINTER ; 
				     use_opacity : BOOLEAN ) is
      external "C"
      alias "gtk_color_selection_set_opacity"
      end

   ext_color_selection_set_update_policy ( colorsel : POINTER; 
					   policy : INTEGER ) is
      external "C"
      alias "gtk_color_selection_set_update_policy"
      end

   ext_color_selection_set_color ( colorsel, color : POINTER ) is
      external "C"
      alias "gtk_color_selection_set_color"
      end

   ext_color_selection_get_color ( colorsel, color : POINTER ) is
      external "C"
      alias "gtk_color_selection_get_color"
      end

invariant
end -- GTK_COLOR_SELECTION

