indexing
   description: "gtk color selection dialog"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen"
   id: "$Id: gtk_color_selection_dialog.e,v 1.5 1999/01/18 19:54:56 pcj Exp $"

class GTK_COLOR_SELECTION_DIALOG
inherit 
   GTK_WINDOW
creation
   make_dialog, create
feature -- Creation

   make_dialog ( title : STRING ) is
      do
	 gtkobject := ext_color_selection_dialog_new ( title.to_external )
      end

feature {ANY} -- Queries

   colorsel : GTK_COLOR_SELECTION is 
      do
	 if colorsel_object = Void then
	    !!colorsel_object.create(ext_color_selection_dialog_colorsel(gtkobject))
	 end
	 Result := colorsel_object
      end

   main_vbox : GTK_VBOX is
      do
	 if main_vbox_object = Void then
	    !!main_vbox_object.create(ext_color_selection_dialog_main_vbox(gtkobject))
	 end
	 Result := main_vbox_object
      end
   
   ok_button : GTK_BUTTON is
      do
	 if ok_button_object = Void then
	    !!ok_button_object.create(ext_color_selection_dialog_ok_button(gtkobject))
	 end
	 Result := ok_button_object
      end

   reset_button : GTK_BUTTON is
      do
	 if reset_button_object = Void then
	    !!reset_button_object.create(ext_color_selection_dialog_reset_button(gtkobject))
	 end
	 Result := reset_button_object
      end
   
   cancel_button : GTK_BUTTON is
      do
	 if cancel_button_object = Void then
	    !!cancel_button_object.create(ext_color_selection_dialog_cancel_button(gtkobject))
	 end
	 Result := cancel_button_object
      end
   
   help_button : GTK_BUTTON is
      do
	 if help_button_object = Void then
	    !!help_button_object.create(ext_color_selection_dialog_help_button(gtkobject))
	 end
	 Result := help_button_object
      end

feature {ANY} -- Commands
feature {NONE} -- Private
   
   colorsel_object: GTK_COLOR_SELECTION
   main_vbox_object: GTK_VBOX
   ok_button_object: GTK_BUTTON
   reset_button_object: GTK_BUTTON
   cancel_button_object: GTK_BUTTON
   help_button_object: GTK_BUTTON

   ext_color_selection_dialog_new ( title : POINTER ) : POINTER is
      external "C"
      alias "gtk_color_selection_dialog_new"
      end

   ext_color_selection_dialog_colorsel ( c_object : POINTER ) : POINTER is
      external "C"
      end

   ext_color_selection_dialog_main_vbox ( c_object : POINTER ) : POINTER is
      external "C"
      end

   ext_color_selection_dialog_ok_button ( c_object : POINTER ) : POINTER is
      external "C"
      end

   ext_color_selection_dialog_reset_button ( c_object : POINTER ) : POINTER is
      external "C"
      end

   ext_color_selection_dialog_cancel_button ( c_object : POINTER ) : POINTER is
      external "C"
      end

   ext_color_selection_dialog_help_button ( c_object : POINTER ) : POINTER is
      external "C"
      end

invariant
end
