indexing
   description: "gtk combo"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen"
   id: "$Id: gtk_combo.e,v 1.9 1999/01/18 19:54:56 pcj Exp $"

class GTK_COMBO
inherit 
   GTK_HBOX
   rename make as make_hbox
creation
   make, 
   create
feature -- Creation

   make is
      do
	 gtkobject := ext_combo_new
      end -- make

feature {ANY} -- Queries
feature {ANY} -- Commands

   set_case_sensitive ( val : BOOLEAN ) is
      do
         ext_combo_set_case_sensitive ( gtkobject, val )
      end

   set_item_string ( item : GTK_ITEM ; item_value : STRING ) is
      do
         ext_combo_set_item_string ( gtkobject, 
				     item.to_external, item_value.to_external )
      end

   set_use_arrows ( val : BOOLEAN ) is
      do
         ext_combo_set_use_arrows ( gtkobject, val )
      end

   set_use_arrows_always ( val : BOOLEAN ) is
      do
         ext_combo_set_use_arrows_always ( gtkobject, val )
      end

   set_value_in_list ( val, ok_if_empty : BOOLEAN ) is
      do
         ext_combo_set_value_in_list ( gtkobject, val, ok_if_empty )
      end

   disable_activate is
      do
	 ext_combo_disable_activate ( gtkobject ) 
      end

   set_popdown_strings ( strings : COLLECTION[STRING] ) is
      local 
	 string_glist : STRING_GLIST
      do
	 !!string_glist.from_collection(strings)
	 ext_combo_set_popdown_strings ( gtkobject, string_glist.to_external )
      end

feature {NONE} -- Private

   ext_combo_new  : POINTER is
      external "C"
      alias "gtk_combo_new"
      end
   ext_combo_set_case_sensitive ( combo : POINTER ; val : BOOLEAN ) is
      external "C"
      alias "gtk_combo_set_case_sensitive"
      end
   ext_combo_set_item_string ( combo, item, item_value : POINTER ) is
      external "C"
      alias "gtk_combo_set_item_string"
      end
   ext_combo_set_use_arrows ( combo : POINTER ; val : BOOLEAN ) is
      external "C"
      alias "gtk_combo_set_use_arrows"
      end
   ext_combo_set_use_arrows_always ( combo : POINTER ; val : BOOLEAN ) is
      external "C"
      alias "gtk_combo_set_use_arrows_always"
      end
   ext_combo_set_value_in_list ( combo : POINTER ; 
				 val, ok_if_empty : BOOLEAN ) is
      external "C"
      alias "gtk_combo_set_value_in_list"
      end
   ext_combo_disable_activate ( combo : POINTER ) is
      external "C"
      alias "gtk_combo_disable_activate"
      end
   ext_combo_set_popdown_strings ( combo, strings : POINTER ) is
      external "C"
      alias "gtk_combo_set_popdown_strings"
      end

invariant
end

