indexing
   description: "gtk command type"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen"
   id: "$Id: gtk_command_type.e,v 1.4 1999/01/18 19:54:57 pcj Exp $"

deferred class GTK_COMMAND_TYPE
feature {ANY}

   -- Decode the extra data and call "execute"
   command_execution ( data : ANY ) is
      deferred
      end 

feature {SE_WORKAROUND}

   -- Primary C to Eiffel entry point. 
   -- external "Cecil"
   marshal ( data : ANY ; p : POINTER ) is
      do
	 params := p
	 command_execution ( data ) 
	 params := default_pointer
      end

-- Utility functions for accessing extra data and setting return values
feature {NONE} -- Private

   params : POINTER 

   shift_int : INTEGER is
      -- Remove an integer from the param list
      do
	 Result := ext_shift_param_int ( params ) 
      end
   
   ext_shift_param_int ( p : POINTER ) : INTEGER is
      external "C"
      end

   shift_pointer : POINTER is
      -- Remove a pointer from the param list
      do
	 Result := ext_shift_param_pointer ( params ) 
      end
	 
   ext_shift_param_pointer ( p : POINTER ) : POINTER is 
      external "C"
      end

   shift_float, shift_real : REAL is 
      -- Remove a float from the param list
      do
	 Result := ext_shift_param_float ( params ) 
      end

   ext_shift_param_float ( p : POINTER ) : REAL is
      external "C"
      end

   num_params : INTEGER is
      -- Get the number of params on the list
      do
	 Result := ext_num_params ( params ) 
      end
   
   ext_num_params ( p : POINTER ) : INTEGER is
      external "C"
      end
   
   argument_type : GTK_TYPE is
      -- Return the type of the next argument to be shifted
      do
	 !!Result.make_gtk_constant( ext_argument_type ( params ) )
      end

   ext_argument_type ( p : POINTER ) : INTEGER is
      external "C"
      end

   return_value_type : GTK_FUNDAMENTAL_TYPE is
      -- Return the callback's return type
      do
	 !!Result.make_gtk_constant( ext_return_value_type ( params ) )
      end
   
   ext_return_value_type ( p : POINTER ) : INTEGER is
      external "C"
      end

   set_return_value_boolean ( retval : BOOLEAN )  is
      do
	 ext_set_return_value_boolean ( params, retval ) 
      end

   ext_set_return_value_boolean ( p : POINTER; retval : BOOLEAN ) is
      external "C"
      end

   set_return_value_int ( retval : INTEGER ) is
      do
	 ext_set_return_value_integer ( params, retval ) 
      end
   
   ext_set_return_value_integer ( p : POINTER ; retval : INTEGER ) is
      external "C"
      end

   ext_create_signal_data ( data : ANY ) : POINTER is 
      external "C_WithCurrent"
      end

invariant
end

