indexing
   description: "gtk container"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen and Francois Pennaneach"
   id: "$Id: gtk_container.e,v 1.9 1999/01/18 19:54:57 pcj Exp $"

class GTK_CONTAINER
inherit
   GTK_WIDGET
feature -- Creation
feature {ANY} -- Queries
feature {ANY} -- Commands
   add(widget : GTK_WIDGET) is
      -- add a new widget in this container
      do
	 ext_add(gtkobject, widget.to_external)
      end -- add

   check_resize is 
      do
	 ext_check_resize(gtkobject)
      end

   focus(direction : GTK_DIRECTION_TYPE) : INTEGER is
      do
	 Result := ext_focus(gtkobject, direction.value)
      end -- focus

   register_toplevel is
      do
	 ext_register_toplevel(gtkobject)
      end

   unregister_toplevel is
      do
	 ext_unregister_toplevel(gtkobject)
      end

   remove(widget : GTK_WIDGET) is
	 -- remove a widget from this container
      do
	 ext_remove(gtkobject, widget.to_external)
      end -- remove

   resize_children is
      do
	 ext_resize_children(gtkobject)
      end
  
   set_border_width(new_width : INTEGER) is
	 -- set the border width for this container
      do
	 ext_set_border_width(gtkobject, new_width)
      end -- set_border_width

   set_focus_child (child : GTK_WIDGET) is
      do
	 ext_set_focus_child(gtkobject, child.to_external)
      end

   set_focus_vadjustment (adjustment : GTK_ADJUSTMENT) is
      do
	 ext_set_focus_vadjustment(gtkobject, adjustment.to_external)
      end

   set_focus_hadjustment(adjustment : GTK_ADJUSTMENT) is
      do
	 ext_set_focus_hadjustment(gtkobject, adjustment.to_external)
      end

   set_resize_mode ( resize_mode : GTK_RESIZE_MODE ) is
      do
	 ext_set_resize_mode (gtkobject, resize_mode.value) 
      end

feature {NONE} -- Private

   ext_add(c_object, widget : POINTER) is
      external "C"
      alias "gtk_container_add"
      end -- ext_add

   ext_check_resize(container : POINTER ) is
      external "C"
      alias "gtk_container_check_resize"
      end

   ext_focus(c_object : POINTER; direction : INTEGER) : INTEGER is
      external "C"
      alias "gtk_container_focus"
      end -- ext_focus

   ext_register_toplevel (c_object : POINTER) is
      external "C"
      alias "gtk_container_register_toplevel"
      end

   ext_unregister_toplevel (c_object : POINTER) is
      external "C"
      alias "gtk_container_unregister_toplevel"
      end

   ext_remove(c_object, widget : POINTER) is
      external "C"
      alias "gtk_container_remove"
      end -- ext_remove

   ext_resize_children (c_object : POINTER) is
      external "C"
      alias "gtk_container_resize_children"
      end

   ext_set_border_width(c_object : POINTER; new_width : INTEGER) is
      external "C"
      alias "gtk_container_set_border_width"
      end -- ext_set_border

   ext_set_focus_child(c_object, child : POINTER) is
      external "C"
      alias "gtk_container_set_focus_child"
      end

   ext_set_focus_vadjustment(c_object, adjustment : POINTER) is
      external "C"
      alias "gtk_container_set_focus_vadjustment"
      end

   ext_set_focus_hadjustment(c_object, adjustment : POINTER) is
      external "C"
      alias "gtk_container_set_focus_hadjustment"
      end

   ext_set_resize_mode(c_object : POINTER ; resize_mode : INTEGER) is
      external "C"
      alias "gtk_container_set_resize_mode"
      end

invariant
end -- GTK_CONTAINER

