indexing
   description: "gtk curve"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen and Francois Pennaneach"
   id: "$Id: gtk_curve.e,v 1.6 1999/01/18 19:54:57 pcj Exp $"

-- missing : get_vector
class GTK_CURVE
inherit
   GTK_DRAWING_AREA
      redefine
	 make
      end;
creation
   make,
   create
feature -- Creation
   make is
      -- Creation and initialization
      do
	 gtkobject := ext_curve_new 
      end -- make

feature {ANY} -- Commands

   reset  is
      do
         ext_curve_reset ( gtkobject )
      end

   set_curve_type ( type : GTK_CURVE_TYPE ) is
      do
         ext_curve_set_curve_type ( gtkobject, type.value )
      end

   set_gamma ( gamma : REAL ) is
      do
         ext_curve_set_gamma ( gtkobject, gamma )
      end

   set_range ( min_x, max_x, min_y, max_y : REAL ) is
      do
         ext_curve_set_range ( gtkobject, min_x, max_x, min_y, max_y )
      end

   set_vector ( veclen : INTEGER ; vector : ARRAY[REAL] ) is
      do
	 ext_curve_set_vector ( gtkobject, veclen, vector.to_external )
      end
   
feature {ANY} -- Queries
   
--   get_vector ( veclen : INTEGER ) : ARRAY[REAL] is
--      do
--         not_yet_implemented
--      end

feature {NONE} -- Private
   ext_curve_new  : POINTER is
      external "C"
      alias "gtk_curve_new"
      end
   ext_curve_reset ( curve : POINTER ) is
      external "C"
      alias "gtk_curve_reset"
      end
   ext_curve_set_curve_type ( curve : POINTER; type : INTEGER ) is
      external "C"
      alias "gtk_curve_set_curve_type"
      end
   ext_curve_set_gamma ( curve : POINTER ; gamma : REAL ) is
      external "C"
      alias "gtk_curve_set_gamma"
      end
   ext_curve_set_range ( curve : POINTER ; 
			 min_x, max_x, min_y, max_y : REAL ) is
      external "C"
      alias "gtk_curve_set_range"
      end

   ext_curve_set_vector ( curve : POINTER ; veclen : INTEGER ; 
			  vector : POINTER ) is
      external "C"
      alias "gtk_curve_set_vector"
      end

invariant
end -- GTK_CURVE

