indexing
   description: "gtk editable"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen"
   id: "$Id: gtk_editable.e,v 1.6 1999/01/18 19:54:57 pcj Exp $"

deferred class GTK_EDITABLE
inherit 
   GTK_WIDGET
feature {ANY}

   select_region ( start_, end_ : INTEGER ) is
      do
	 ext_editable_select_region(gtkobject, start_, end_) 
      end

   -- Should I return this position?
   insert_text ( new_text : STRING ; length, position : INTEGER ) is
      do
	 dummy := position
	 ext_editable_insert_text ( gtkobject, new_text.to_external, length, $dummy )
      end
   
   delete_text ( start_pos , end_pos : INTEGER ) is
      do
	 ext_editable_delete_text ( gtkobject, start_pos, end_pos ) 
      end
   
   get_chars ( start_pos, end_pos: INTEGER ) : STRING is
      do
	 !!Result.from_external(ext_editable_get_chars ( gtkobject, 
							 start_pos, 
							 end_pos ))
      end

   cut_clipboard is
      do
	 ext_editable_cut_clipboard(gtkobject)
      end

   copy_clipboard is
      do
	 ext_editable_copy_clipboard(gtkobject)
      end
   
   paste_clipboard is
      do
	 ext_editable_paste_clipboard(gtkobject)
      end

   claim_selection ( claim : BOOLEAN ; time : INTEGER ) is
      do
	 ext_editable_claim_selection ( gtkobject, claim, time )
      end

   delete_selection is
      do
	 ext_editable_delete_selection (gtkobject)
      end

   changed is
      do
	 ext_editable_changed (gtkobject)
      end

   set_position (position : INTEGER) is
      do
	 ext_editable_set_position (gtkobject, position)
      end

   get_position : INTEGER is
      do
	 Result := ext_editable_get_position(gtkobject)
      end

   set_editable ( is_editable : BOOLEAN ) is
      do
	 ext_editable_set_editable(gtkobject, is_editable) 
      end

feature {NONE} 

   dummy : INTEGER
   
   ext_editable_select_region ( editable : POINTER ; 
				start, end_ : INTEGER ) is
      external "C"
      alias "gtk_editable_select_region"
      end

   ext_editable_insert_text( editable, new_text : POINTER ;
			     new_text_length : INTEGER ; 
			     position : POINTER ) is
      external "C"
      alias "gtk_editable_insert_text"
      end
   
   ext_editable_delete_text ( editable : POINTER ; 
			      start_pos, end_pos : INTEGER ) is
      external "C"
      alias "gtk_editable_delete_text"
      end

   ext_editable_get_chars ( editable : POINTER ; 
			    start_pos, end_pos : INTEGER ) : POINTER is
      external "C"
      alias "gtk_editable_get_chars"
      end

   ext_editable_cut_clipboard ( editable : POINTER ) is
      external "C"
      alias "gtk_editable_cut_clipboard"
      end

   ext_editable_copy_clipboard ( editable : POINTER ) is
      external "C"
      alias "gtk_editable_copy_clipboard"
      end

   ext_editable_paste_clipboard ( editable : POINTER ) is
      external "C"
      alias "gtk_editable_paste_clipboard"
      end

   ext_editable_claim_selection ( editable : POINTER ; claim : BOOLEAN ; 
				  time : INTEGER ) is
      external "C"
      alias "gtk_editable_claim_selection"
      end

   ext_editable_delete_selection ( editable : POINTER ) is
      external "C"
      alias "gtk_editable_delete_selection"
      end

   ext_editable_changed ( editable : POINTER ) is
      external "C"
      alias "gtk_editable_changed"
      end

   ext_editable_set_position ( editable : POINTER ; position : INTEGER ) is
      external "C"
      alias "gtk_editable_set_position"
      end

   ext_editable_get_position ( editable : POINTER ) : INTEGER is
      external "C"
      alias "gtk_editable_get_position"
      end
   
   ext_editable_set_editable ( editable : POINTER ; is_editable : BOOLEAN ) is
      external "C"
      alias "gtk_editable_set_editable"
      end

end 

