indexing
   description: "gtk file selection"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen and Francois Pennaneach"
   id: "$Id: gtk_file_selection.e,v 1.8 1999/01/18 19:54:57 pcj Exp $"

class GTK_FILE_SELECTION
inherit
   GTK_WINDOW
   rename make as make_window
creation
   make,
   make_with_title, 
   create
feature -- Creation
   make, make_with_title(title : STRING) is
      -- Creation and initialization
      do
	 gtkobject := ext_file_selection_new(title.to_external)
	 !!ok_button.create(ext_ok_button(gtkobject))
	 !!cancel_button.create(ext_cancel_button(gtkobject))
	 !!help_button.create(ext_help_button(gtkobject))
	 !!action_area.create(ext_action_area(gtkobject))
      end -- make_with_title

feature {ANY} -- Queries
   ok_button : GTK_BUTTON
   cancel_button : GTK_BUTTON
   help_button : GTK_BUTTON
   action_area : GTK_HBOX

   filename, get_filename : STRING is
      do
	 !!Result.make(100)
	 Result.from_external(ext_file_selection_get_filename(gtkobject))
      end -- get_filename

feature {ANY} -- Commands
   set_filename(new_filename : STRING) is
      require
	 new_filename /= Void
      do
	 ext_file_selection_set_filename(gtkobject, new_filename.to_external)
      end -- set_filename

   hide_fileop_buttons is
      do
         ext_file_selection_hide_fileop_buttons ( gtkobject )
      end

   show_fileop_buttons is
      do
	 ext_file_selection_show_fileop_buttons ( gtkobject )
      end

   complete (pattern : STRING) is
      do
	 ext_file_selection_complete(gtkobject, pattern.to_external)
      end

feature {NONE} -- Private

   ext_file_selection_hide_fileop_buttons ( filesel : POINTER ) is
      external "C"
      alias "gtk_file_selection_hide_fileop_buttons"
      end

   ext_file_selection_show_fileop_buttons ( filesel : POINTER ) is
      external "C"
      alias "gtk_file_selection_show_fileop_buttons"
      end

   ext_file_selection_new(s : POINTER) : POINTER is
      external "C"
      alias "gtk_file_selection_new"
      end

   ext_file_selection_set_filename(c_object : POINTER; 
				   new_filename : POINTER) is
      external "C"
      alias "gtk_file_selection_set_filename"
      end

   ext_file_selection_get_filename(c_object : POINTER) : POINTER is
      external "C"
      alias "gtk_file_selection_get_filename"
      end 

   ext_ok_button(c_object : POINTER) : POINTER is
      external "C"
      alias "ext_fileselection_ok_button"
      end -- ext_ok_button

   ext_cancel_button(c_object : POINTER) : POINTER is
      external "C"
      alias "ext_fileselection_cancel_button"
      end -- ext_cancel_button

   ext_help_button(c_object : POINTER) : POINTER is
      external "C"
      alias "ext_fileselection_help_button"
      end -- ext_help_button

   ext_action_area ( filesel: POINTER ) : POINTER is
      external "C"
      alias "ext_fileselection_action_area"
      end

   ext_file_selection_complete(filesel, pattern : POINTER) is
      external "C"
      alias "gtk_file_selection_complete"
      end

invariant
end -- GTK_FILE_SELECTION

