indexing
   description: "gtk frame"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen and Francois Pennaneach"
   id: "$Id: gtk_frame.e,v 1.6 1999/01/18 19:54:57 pcj Exp $"

class GTK_FRAME
inherit
   GTK_BIN
creation
   make, make_with_label,
   make_without_label, 
   create
feature -- Creation
   make_with_label(label : STRING) is
      -- Creation and initialization
      do
	 gtkobject := ext_frame_new(label.to_external)
      end -- make_with_label

   make, make_without_label is
      do
	 gtkobject := ext_frame_new ( default_pointer ) 
      end

   set_label(label : STRING) is
      do
	 ext_set_label(gtkobject, label.to_external)
      end -- set_label

   set_label_align(xalign, yalign : REAL) is
      do
	 ext_set_label_align(gtkobject, xalign, yalign)
      end -- set_label_align

   set_shadow_type(type : GTK_SHADOW_TYPE) is
      do
	 ext_set_shadow_type(gtkobject, type.value)
      end -- set_shadow_type

feature {ANY} -- Queries
feature {ANY} -- Commands
feature {NONE} -- Private
   ext_frame_new(label : POINTER) : POINTER is
      external "C"
      alias "gtk_frame_new"
      end -- ext_frame_new

   ext_set_label(c_object : POINTER; label : POINTER) is
      external "C"
      alias "gtk_frame_set_label"
      end -- ext_set_label

   ext_set_label_align(c_object : POINTER; xalign, yalign : REAL) is
      external "C"
      alias "gtk_frame_set_label_align"
      end -- ext_set_label_align

   ext_set_shadow_type(c_object : POINTER; type : INTEGER) is
      external "C"
      alias "gtk_frame_set_shadow_type"
      end -- ext_set_shadow_type
invariant
end -- GTK_FRAME

