indexing
   description: "gtk handle box"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen"
   id: "$Id: gtk_handle_box.e,v 1.7 1999/01/18 19:54:57 pcj Exp $"

class GTK_HANDLE_BOX
inherit 
   GTK_BIN
creation
   make, 
   create
feature -- Creation
   make is
      do
	 gtkobject := ext_handle_box_new 
      end -- make
feature {ANY} -- Queries

   bin_window : GDK_WINDOW is
      local 
	 p : POINTER
      do
	 if bin_window_obj = Void then 
	    p := ext_handle_box_bin_window ( gtkobject ) 
	    if p = default_pointer then
	    else
	       !!bin_window_obj.create(p)
	    end
	 end
	 Result := bin_window_obj
      end

   float_window : GDK_WINDOW is
      local 
	 p : POINTER
      do
	 if float_window_obj = Void then 
	    p := ext_handle_box_float_window ( gtkobject ) 
	    if p = default_pointer then
	    else
	       !!float_window_obj.create(p)
	    end
	 end
	 Result := float_window_obj
      end

   set_shadow_type (type : GTK_SHADOW_TYPE) is
      do
	 ext_handle_box_set_shadow_type(gtkobject, type.value)
      end

feature {NONE} -- Private

   bin_window_obj, float_window_obj : GDK_WINDOW

   ext_handle_box_new  : POINTER is
      external "C"
      alias "gtk_handle_box_new"
      end

   ext_handle_box_bin_window ( handlebox : POINTER ) : POINTER is 
      external "C"
      end

   ext_handle_box_float_window ( handlebox : POINTER ) : POINTER is
      external "C"
      end
   
   ext_handle_box_set_shadow_type(handlebox : POINTER; type : INTEGER) is
      external "C"
      alias "gtk_handle_box_set_shadow_type"
      end

invariant
end
