indexing
   description: "gtk label"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen and Francois Pennaneach"
   id: "$Id: gtk_label.e,v 1.5 1999/01/18 19:54:58 pcj Exp $"

class GTK_LABEL
inherit
   GTK_MISC
creation
   make, 
   make_with_label,
   create
feature -- Creation
   make, make_with_label(label : STRING) is
      -- Creation and initialization
      do
	 gtkobject := ext_label_new(label.to_external)
      end -- make_with_label

feature {ANY} -- Queries
   
   get : STRING is
      do
	 ext_label_get(gtkobject, $str)
	 !!Result.from_external(str)
      end

feature {ANY} -- Commands

   set_text(label : STRING) is
      do
	 ext_label_set_text(gtkobject, label.to_external)
      end

   set_justify(jtype : GTK_JUSTIFICATION) is
      do
	 ext_label_set_justify(gtkobject, jtype.value)
      end

   set_pattern(pattern : STRING) is
      do
	 ext_label_set_pattern(gtkobject, pattern.to_external)
      end

   set_line_wrap(wrap : BOOLEAN) is
      do
	 ext_label_set_line_wrap(gtkobject, wrap)
      end

   parse_uline(string : STRING) is
      do
	 ext_label_parse_uline(gtkobject, string.to_external) 
      end

feature {NONE} -- Private
   ext_label_new(label : POINTER) : POINTER is
      external "C"
      alias "gtk_label_new"
      end -- ext_label_new

   ext_label_get(label, string : POINTER) is
      external "C"
      alias "gtk_label_get"
      end

   ext_label_set_text(label, string : POINTER) is
      external "C"
      alias "gtk_label_set_text"
      end

   ext_label_set_justify(label : POINTER ; jtype : INTEGER) is
      external "C"
      alias "gtk_label_set_justify"
      end

   ext_label_set_pattern(label, pattern : POINTER) is
      external "C"
      alias "gtk_label_set_pattern"
      end

   ext_label_set_line_wrap(label : POINTER ; wrap : BOOLEAN) is
      external "C"
      alias "gtk_label_set_line_wrap"
      end

   ext_label_parse_uline(label, string : POINTER) is
      external "C"
      alias "gtk_label_parse_uline"
      end

   str : POINTER 

invariant
end -- GTK_LABEL

