indexing
   description: "gtk layout"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen"
   id: "$Id: gtk_layout.e,v 1.4 1999/01/18 19:54:58 pcj Exp $"

class GTK_LAYOUT
inherit 
   GTK_CONTAINER
creation
   make, create
feature -- Creation
   make ( hadjustment, vadjustment : GTK_ADJUSTMENT ) is
      do
	 gtkobject := ext_layout_new(hadjustment.to_external, vadjustment.to_external)
      end -- make

feature {ANY} -- Queries

   get_hadjustment : GTK_ADJUSTMENT is
      do
	 !!Result.create(ext_layout_get_hadjustment(gtkobject))
      end

   get_vadjustment : GTK_ADJUSTMENT is
      do
	 !!Result.create(ext_layout_get_vadjustment(gtkobject))
      end

feature {ANY} -- Commands

   put (widget : GTK_WIDGET; x, y : INTEGER) is
      do
	 ext_layout_put(gtkobject, widget.to_external, x, y)
      end

   move (widget : GTK_WIDGET; x, y : INTEGER) is
      do
	 ext_layout_move(gtkobject, widget.to_external, x, y)
      end

   set_size(width, height : INTEGER) is
      require
	 width >=0
	 height >=0 
      do
	 ext_layout_set_size(gtkobject, width, height)
      end

   freeze is
      do
	 ext_layout_freeze(gtkobject)
      end

   thaw is
      do
	 ext_layout_thaw(gtkobject)
      end

   set_hadjustment (adjustment : GTK_ADJUSTMENT) is
      do
	 ext_layout_set_hadjustment(gtkobject, adjustment.to_external)
      end

   set_vadjustment (adjustment : GTK_ADJUSTMENT) is
      do
	 ext_layout_set_vadjustment(gtkobject, adjustment.to_external)
      end

feature {NONE} -- Private

   ext_layout_new (hadjustment, vadjustment : POINTER ) : POINTER is
      external "C"
      alias "gtk_layout_new"
      end

   ext_layout_put(layout, widget : POINTER ; x, y : INTEGER ) is
      external "C"
      alias "gtk_layout_put"
      end

   ext_layout_move(layout, widget : POINTER ; x, y : INTEGER ) is
      external "C"
      alias "gtk_layout_move"
      end

   ext_layout_set_size(layout : POINTER ; width, height : INTEGER ) is
      external "C"
      alias "gtk_layout_set_size"
      end

   ext_layout_freeze( layout : POINTER ) is
      external "C"
      alias "gtk_layout_freeze"
      end

   ext_layout_thaw( layout : POINTER ) is
      external "C"
      alias "gtk_layout_thaw"
      end

   ext_layout_get_hadjustment(layout : POINTER) : POINTER is
      external "C"
      alias "gtk_layout_get_hadjustment"
      end

   ext_layout_get_vadjustment(layout : POINTER) : POINTER is
      external "C"
      alias "gtk_layout_get_vadjustment"
      end

   ext_layout_set_hadjustment ( layout, adjustment : POINTER ) is
      external "C"
      alias "gtk_layout_set_hadjustment"
      end

   ext_layout_set_vadjustment ( layout, adjustment : POINTER ) is
      external "C"
      alias "gtk_layout_set_vadjustment"
      end
   
invariant
end 

