indexing
   description: "gtk list"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen and Francois Pennaneach"
   id: "$Id: gtk_list.e,v 1.8 1999/01/18 19:54:58 pcj Exp $"

class GTK_LIST
inherit
   GTK_CONTAINER
creation
   make,
   create
feature -- Creation
   make is
      -- Creation and initialization
      do
	 gtkobject := ext_list_new
      end -- make

feature {ANY} -- Queries

   selection : ARRAY[GTK_LIST_ITEM] is
      local
	 glist : GTK_LIST_ITEM_GLIST
      do
	 !!glist.create(ext_list_selection(gtkobject))
	 Result := glist.to_array
      end -- selection
   
   child_position(child : GTK_WIDGET) : INTEGER is
      do
	 Result := ext_child_position(gtkobject, child.to_external)
      end -- child_position

feature {ANY} -- Commands
   
   insert_items(items : COLLECTION[GTK_LIST_ITEM]; position : INTEGER) is
      local
	 item_glist : GTK_LIST_ITEM_GLIST
      do
	 !!item_glist.from_collection(items)
	 ext_insert_items(gtkobject, item_glist.to_external, position)
      end -- make

   append_items(items : COLLECTION[GTK_LIST_ITEM]) is
      local
	 item_glist : GTK_LIST_ITEM_GLIST
      do
	 !!item_glist.from_collection(items)
	 ext_append_items(gtkobject, item_glist.to_external)
      end -- append_items

   prepend_items(items : COLLECTION[GTK_LIST_ITEM]) is
      local
	 item_glist : GTK_LIST_ITEM_GLIST
      do
	 !!item_glist.from_collection(items)
	 ext_prepend_items(gtkobject, item_glist.to_external)
      end -- prepend_items

   remove_items(items : COLLECTION[GTK_LIST_ITEM] ) is
      local 
	 item_glist : GTK_LIST_ITEM_GLIST
      do
	 !!item_glist.from_collection(items)
	 ext_list_remove_items(gtkobject, item_glist.to_external)
      end -- remove_items

   remove_items_no_unref(items : COLLECTION[GTK_LIST_ITEM] ) is
      local 
	 item_glist : GTK_LIST_ITEM_GLIST
      do
	 !!item_glist.from_collection(items)
	 ext_list_remove_items_no_unref(gtkobject, item_glist.to_external)
      end

   clear_items(lower, upper : INTEGER) is
      do
	 ext_clear_items(gtkobject, lower, upper)
      end -- clear_items

   select_item(item : INTEGER) is
      do
	 ext_select_item(gtkobject, item)
      end -- select_item

   unselect_item(item : INTEGER) is
      do
	 ext_unselect_item(gtkobject, item)
      end -- unselect_item

   select_child(child : GTK_WIDGET) is
      do
	 ext_select_child(gtkobject, child.to_external)
      end -- select_child

   unselect_child(child : GTK_WIDGET) is
      do
	 ext_unselect_child(gtkobject, child.to_external)
      end -- unselect_child

   set_selection_mode(mode : GTK_SELECTION_MODE) is
      do
	 ext_set_selection_mode(gtkobject, mode.value)
      end -- set_selection_mode

   extend_selection(scroll_type : GTK_SCROLL_TYPE ; position : REAL) is
      do
	 ext_list_extend_selection(gtkobject, scroll_type.value, position) 
      end

   start_selection is
      do
	 ext_list_start_selection(gtkobject)
      end

   select_all is 
      do
	 ext_list_select_all(gtkobject)
      end

   unselect_all is
      do
	 ext_list_unselect_all(gtkobject)
      end
   
   scroll_horizontal(scroll_type : GTK_SCROLL_TYPE; position : REAL ) is
      do
	 ext_list_scroll_horizontal(gtkobject, scroll_type.value, position) 
      end

   scroll_vertical(scroll_type : GTK_SCROLL_TYPE; position : REAL ) is
      do
	 ext_list_scroll_vertical(gtkobject, scroll_type.value, position) 
      end

   toggle_add_mode is
      do
	 ext_list_toggle_add_mode(gtkobject)
      end

   toggle_focus_row is
      do
	 ext_list_toggle_focus_row(gtkobject)
      end

   toggle_row(item : GTK_WIDGET) is
      do
	 ext_list_toggle_row(gtkobject, item.to_external) 
      end

   undo_selection is
      do
	 ext_list_undo_selection(gtkobject)
      end

   end_drag_selection is
      do
	 ext_list_end_drag_selection(gtkobject)
      end

feature {NONE} -- Private
   ext_list_new : POINTER is
      external "C"
      alias "gtk_list_new"
      end -- ext_new

   ext_child_position(c_object, child : POINTER) : INTEGER is
      external "C"
      alias "gtk_list_child_position"
      end -- ext_child_position

   ext_append_items(c_object, items : POINTER) is
      external "C"
      alias "gtk_list_append_items"
      end -- ext_append_items

   ext_clear_items(c_object : POINTER; lower, upper : INTEGER) is
      external "C"
      alias "gtk_list_clear_items"
      end -- ext_clear_items

   ext_insert_items(c_object, items : POINTER; position : INTEGER) is
      external "C"
      alias "gtk_list_insert_items"
      end -- ext_insert_items

   ext_prepend_items(c_object, items : POINTER) is
      external "C"
      alias "gtk_list_prepend_items"
      end -- ext_prepend_items

   ext_list_remove_items(c_object, items : POINTER) is
      external "C"
      alias "gtk_list_remove_items"
      end -- ext_remove_items

   ext_select_child(c_object, child : POINTER) is
      external "C"
      alias "gtk_list_select_child"
      end -- ext_select_child

   ext_select_item(c_object : POINTER; item : INTEGER) is
      external "C"
      alias "gtk_list_select_item"
      end -- ext_select_item

   ext_unselect_child(c_object, child : POINTER) is
      external "C"
      alias "gtk_list_unselect_child"
      end -- ext_unselect_child

   ext_unselect_item(c_object : POINTER; item : INTEGER) is
      external "C"
      alias "gtk_list_unselect_item"
      end -- ext_unselect_item

   ext_set_selection_mode(c_object : POINTER; mode : INTEGER) is
      external "C"
      alias "gtk_list_set_selection_mode"
      end -- ext_set_selection_mode

   ext_list_selection(c_object : POINTER) : POINTER is
      external "C"
      end

   ext_list_remove_items_no_unref(list, items : POINTER) is
      external "C"
      alias "gtk_list_remove_items_no_unref"
      end

   ext_list_extend_selection(list : POINTER ; scroll_type : INTEGER ; 
			     position : REAL) is
      external "C"
      alias "gtk_list_extend_selection"
      end

   ext_list_start_selection(list : POINTER) is
      external "C"
      alias "gtk_list_start_selection"
      end

   ext_list_select_all(list : POINTER) is
      external "C"
      alias "gtk_list_select_all"
      end

   ext_list_unselect_all(list : POINTER) is
      external "C"
      alias "gtk_list_unselect_all"
      end

   ext_list_scroll_horizontal(list : POINTER ; 
			      scroll_type : INTEGER ; 
			      position : REAL) is
      external "C"
      alias "gtk_list_scroll_horizontal"
      end

   ext_list_scroll_vertical(list : POINTER ; 
			    scroll_type : INTEGER ; 
			    position : REAL) is
      external "C"
      alias "gtk_list_scroll_vertical"
      end
   
   ext_list_toggle_add_mode(list : POINTER) is
      external "C"
      alias "gtk_list_toggle_add_mode"
      end

   ext_list_toggle_focus_row(list : POINTER) is
      external "C"
      alias "gtk_list_toggle_focus_row"
      end

   ext_list_toggle_row(list, item : POINTER) is
      external "C"
      alias "gtk_list_toggle_row"
      end

   ext_list_undo_selection(list : POINTER) is
      external "C"
      alias "gtk_list_undo_selection"
      end

   ext_list_end_drag_selection(list : POINTER) is
      external "C"
      alias "gtk_list_end_drag_selection"
      end

invariant
end -- GTK_LIST

