indexing
   description: "gtk list item"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen and Francois Pennaneach"
   id: "$Id: gtk_list_item.e,v 1.5 1999/01/18 19:54:58 pcj Exp $"

class GTK_LIST_ITEM
inherit
   GTK_ITEM
creation
   make,
   make_with_label,
   create
feature -- Creation
   make is
      -- Creation and initialization
      do
	 gtkobject := ext_list_item_new
      end -- make

   make_with_label(label : STRING) is
      do
	 gtkobject := ext_list_item_new_with_label(label.to_external)
      end -- make_with_label

   -- select is a keyword
   item_select is
      do
         ext_list_item_select ( gtkobject )
      end

   item_deselect is
      do
         ext_list_item_deselect ( gtkobject )
      end

feature {ANY} -- Queries
feature {ANY} -- Commands
feature {NONE} -- Private

   ext_list_item_new : POINTER is
      external "C"
      alias "gtk_list_item_new"
      end -- ext_list_item_new

   ext_list_item_new_with_label( label : POINTER) : POINTER is 
      external "C"
      alias "gtk_list_item_new_with_label"
      end -- ext_list_item_new_with_label

   ext_list_item_select ( list_item : POINTER ) is
      external "C"
      alias "gtk_list_item_select" 
      end

   ext_list_item_deselect ( list_item : POINTER ) is
      external "C"
      alias "gtk_list_item_deselect"
      end

invariant
end -- GTK_LIST_ITEM

