indexing
   description: "gtk main"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen and Francois Pennaneach"
   id: "$Id: gtk_main.e,v 1.6 1999/01/18 19:54:58 pcj Exp $"

class GTK_MAIN
-- implements the gtk class Main
-- some methods from gtkrc.h are also defined here

feature {ANY}
   exit(error_code : INTEGER) is
      external "C"
      alias "gtk_exit"
      end -- exit

   -- grab_add and grab_remove are in GTK_WIDGET

   init is
      -- gtk_init, parse command line arguments
      local se_workaround : SE_WORKAROUND
      do
	 !!se_workaround.make
	 ext_init
      end -- init

   main is
	 -- launch the app
      external "C"
      alias "gtk_main"
      end -- main

   main_iteration is
      external "C"
      alias "gtk_main_iteration"
      end -- main_iteration

   quit is
	 -- quit the app
      external "C"
      alias "gtk_main_quit"
      end -- quit
	 
   rc_init is
      external "C"
      alias "gtk_rc_init"
      end -- rc_init

   rc_parse(filename : STRING) is
      do
	 ext_rc_parse(filename.to_external)
      end -- rc_parse

   set_locale is
      external "C"
      alias "gtk_set_locale"
      end -- set_locale

   events_pending : INTEGER is 
      do
	 Result := ext_events_pending
      end

   check_version(required_major, 
		 required_minor, 
		 required_micro : INTEGER) : STRING is
      require
	 required_major >=0
	 required_minor >=0
	 required_micro >=0
      local
	 retval : POINTER
      do
	 retval := ext_check_version(required_major, 
				     required_minor, 
				     required_micro)
	 if retval /= default_pointer then 
	    !!Result.from_external(retval)
	 else
	    Result := Void
	 end
      end

   major_version : INTEGER is
      external "C"
      alias "ext_version_major_version"
      end

   minor_version : INTEGER is
      external "C"
      alias "ext_version_minor_version"
      end

   micro_version : INTEGER is
      external "C"
      alias "ext_version_micro_version"
      end

   binary_age : INTEGER is
      external "C"
      alias "ext_version_binary_age"
      end

   interface_age : INTEGER is
      external "C"
      alias "ext_version_interface_age"
      end

feature {NONE} -- Private
   ext_init is
	 -- initialize the whole stuff
      external "C"
      end -- ext_init

   ext_rc_parse(s : POINTER) is
      external "C"
      alias "gtk_rc_parse"
      end -- ext_rc_parse

   ext_events_pending  : INTEGER is
      external "C"
      alias "gtk_events_pending"
      end

   ext_check_version(major, minor, micro : INTEGER) : POINTER is
      external "C"
      alias "gtk_check_version"
      end

end -- GTK_MAIN
