indexing
   description: "gtk menu"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen and Francois Pennaneach"
   id: "$Id: gtk_menu.e,v 1.10 1999/01/18 19:54:58 pcj Exp $"

class GTK_MENU
inherit
   GTK_MENU_SHELL
creation
   make,
   create
feature -- Creation
   make is
      -- Creation and initialization
      do
	 gtkobject := ext_menu_new
      end -- make

   detach  is
      do
         ext_menu_detach ( gtkobject )
      end

   get_active : GTK_WIDGET is
      do
         !!Result.create(ext_menu_get_active ( gtkobject ))
      end

   set_active ( index : INTEGER ) is
      do
         ext_menu_set_active ( gtkobject, index )
      end

   get_attach_widget  : GTK_WIDGET is
      do
         !!Result.create(ext_menu_get_attach_widget ( gtkobject ))
      end

   popdown  is
      do
         ext_menu_popdown ( gtkobject )
      end

   reposition is
      do
	 ext_menu_reposition(gtkobject)
      end

   set_tearoff_state ( torn_off : BOOLEAN ) is
      do
	 ext_menu_set_tearoff_state ( gtkobject, torn_off) 
      end

   set_accel_group ( accel_group : GTK_ACCEL_GROUP ) is
      do
	 ext_menu_set_accel_group ( gtkobject, accel_group.to_external ) 
      end

feature {ANY} -- Queries
feature {ANY} -- Commands
feature {NONE} -- Private
   ext_menu_new : POINTER is
      external "C"
      alias "gtk_menu_new"
      end -- ext_menu_new

   ext_menu_append(c_object, child : POINTER) is
      external "C"
      alias "gtk_menu_append"
      end -- ext_menu_append

   ext_menu_insert(c_object, child : POINTER; postion : INTEGER) is
      external "C"
      alias "gtk_menu_insert"
      end -- ext_menu_insert

   ext_menu_prepend(c_object, child : POINTER) is
      external "C"
      alias "gtk_menu_prepend"
      end -- ext_menu_prepend

   ext_menu_detach ( menu : POINTER ) is
      external "C"
      alias "gtk_menu_detach"
      end

   ext_menu_get_active ( menu : POINTER ) : POINTER is
      external "C"
      alias "gtk_menu_get_active"
      end

   ext_menu_get_attach_widget ( menu : POINTER ) : POINTER is
      external "C"
      alias "gtk_menu_get_attach_widget"
      end

   ext_menu_popdown ( menu : POINTER ) is
      external "C"
      alias "gtk_menu_popdown"
      end

   ext_menu_set_active ( menu : POINTER ; index : INTEGER ) is
      external "C"
      alias "gtk_menu_set_active"
      end

   ext_menu_set_tearoff_state ( menu : POINTER ; torn_off : BOOLEAN ) is
      external "C"
      alias "gtk_menu_set_tearoff_state"
      end
   
   ext_menu_set_accel_group ( menu, accel_group : POINTER ) is
      external "C"
      alias "gtk_menu_set_accel_group"
      end

   ext_menu_reposition(menu : POINTER) is
      external "C"
      alias "gtk_menu_reposition"
      end
 
invariant
end -- GTK_MENU

