indexing
   description: "gtk menu bar"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen and Francois Pennaneach"
   id: "$Id: gtk_menu_bar.e,v 1.6 1999/01/18 19:54:58 pcj Exp $"

class GTK_MENU_BAR
inherit
   GTK_MENU_SHELL
      redefine
	 append,
	 insert,
	 prepend
      end;
creation
   make,
   create
feature -- Creation
   make is
      -- Creation and initialization
      do
	 gtkobject := ext_menubar_new
      end -- make

   append(child : GTK_WIDGET) is
      do
	 ext_menubar_append(gtkobject, child.to_external)
      end -- append

   insert(child : GTK_WIDGET; position : INTEGER) is
      do
	 ext_menubar_insert(gtkobject, child.to_external, position)
      end -- insert

   prepend(child : GTK_WIDGET) is
      do
	 ext_menubar_prepend(gtkobject, child.to_external)
      end -- prepend

   set_shadow_type(type : GTK_SHADOW_TYPE) is
      do
	 ext_menubar_set_shadow_type(gtkobject, type.value)
      end

feature {ANY} -- Queries
feature {ANY} -- Commands
feature {NONE} -- Private
   ext_menubar_new : POINTER is
      external "C"
      alias "gtk_menu_bar_new"
      end -- ext_menubar_new

   ext_menubar_append(c_object, child : POINTER) is
      external "C"
      alias "gtk_menu_bar_append"
      end -- ext_menubar_append

   ext_menubar_insert(c_object, child : POINTER; position : INTEGER) is
      external "C"
      alias "gtk_menu_bar_insert"
      end -- ext_menubar_insert

   ext_menubar_prepend(c_object, child : POINTER) is
      external "C"
      alias "gtk_menu_bar_prepend"
      end -- ext_menubar_prepend

   ext_menubar_set_shadow_type(c_object : POINTER ; type : INTEGER) is
      external "C"
      alias "gtk_menu_bar_set_shadow_type"
      end

invariant
end -- GTK_MENU_BAR

