indexing
   description: "gtk menu item"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen and Francois Pennaneach"
   id: "$Id: gtk_menu_item.e,v 1.7 1999/01/18 19:54:58 pcj Exp $"

class GTK_MENU_ITEM
inherit
   GTK_ITEM
      redefine
	 activate,
	 deselection,
	 selection
      end;
creation
   make,
   make_with_label,
   create
feature
   make is
      -- Creation and initialization
      do
	 gtkobject := ext_menu_item_new
      end -- make

   make_with_label(label : STRING) is
      do
	 gtkobject := ext_menu_item_new_with_label(label.to_external)
      end -- make_with_label

feature {ANY} -- Commands
   activate is
      do
	 ext_menu_item_activate(gtkobject)
      end -- activate

   configure(show_toggle_indicator, show_submenu_indicator : BOOLEAN ) is
      do
	 ext_configure(gtkobject, show_toggle_indicator, 
		       show_submenu_indicator)
      end -- configure

   deselection is
      do
	 ext_menu_item_deselect(gtkobject)
      end -- deselection

   selection is
      do
	 ext_menu_item_select(gtkobject)
      end -- selection

   set_placement(placement : GTK_SUBMENU_PLACEMENT) is
      do
	 ext_set_placement(gtkobject, placement.value)
      end -- set_placement
   
   set_submenu(submenu : GTK_WIDGET) is
      do
	 ext_set_submenu(gtkobject, submenu.to_external)
      end -- set_submenu

   remove_submenu  is
      do
         ext_menu_item_remove_submenu ( gtkobject )
      end

   right_justify  is
      do
         ext_menu_item_right_justify ( gtkobject )
      end

feature {NONE} -- Private
   ext_menu_item_new : POINTER is
      external "C"
      alias "gtk_menu_item_new"
      end -- ext_menu_item_new

   ext_menu_item_new_with_label(label : POINTER) : POINTER is
      external "C"
      alias "gtk_menu_item_new_with_label"
      end -- ext_menui_tem_new_with_label

   ext_menu_item_activate(c_object : POINTER) is
      external "C"
      alias "gtk_menu_item_activate"
      end -- ext_menu_item_activate

   ext_configure(c_object : POINTER; 
		 show_toggle_indicator, 
		 show_submenu_indicator : BOOLEAN ) is
      external "C"
      alias "gtk_menu_item_configure"
      end -- ext_configure

   ext_menu_item_deselect(c_object : POINTER) is
      external "C"
      alias "gtk_menu_item_deselect"
      end -- ext_deselect

   ext_menu_item_select(c_object : POINTER) is
      external "C"
      alias "gtk_menu_item_select"
      end -- ext_select
   
   ext_menu_item_remove_submenu ( menu_item : POINTER ) is
      external "C"
      alias "gtk_menu_item_remove_submenu"
      end

   ext_menu_item_right_justify ( menu_item : POINTER ) is
      external "C"
      alias "gtk_menu_item_right_justify"
      end

   ext_set_placement(c_object : POINTER; placement : INTEGER) is
      external "C"
      alias "gtk_menu_item_set_placement"
      end -- ext_set_placement

   ext_set_submenu(c_object, submenu : POINTER) is
      external "C"
      alias "gtk_menu_item_set_submenu"
      end -- ext_set_submenu

  
invariant
end -- GTK_MENU_ITEM

