indexing
   description: "gtk menu shell"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen"
   id: "$Id: gtk_menu_shell.e,v 1.8 1999/01/18 19:54:58 pcj Exp $"

deferred class GTK_MENU_SHELL
inherit
   GTK_CONTAINER
feature {ANY} -- Commands
   append(child : GTK_WIDGET) is
      do
	 ext_menu_shell_append(gtkobject, child.to_external)
      end -- append

   prepend(child : GTK_WIDGET) is
      do
	 ext_menu_shell_prepend(gtkobject, child.to_external)
      end -- prepend

   insert(child : GTK_WIDGET; position : INTEGER) is
      do
	 ext_menu_shell_insert(gtkobject, child.to_external, position)
      end -- insert

   deactivate is
      do
	 ext_deactivate(gtkobject)
      end -- deactivate
   
   select_item(menu_item : GTK_WIDGET) is
      do
	 ext_menu_shell_select_item(gtkobject, menu_item.to_external)
      end

   activate_item(menu_item : GTK_WIDGET; force_deactivate : BOOLEAN) is
      do
	 ext_menu_shell_activate_item(gtkobject, 
				      menu_item.to_external, 
				      force_deactivate)
      end

feature {NONE} -- Private
   ext_menu_shell_append(c_object, child : POINTER) is
      external "C"
      alias "gtk_menu_shell_append"
      end -- ext_menu_shell_append

   ext_menu_shell_prepend(c_object, child : POINTER) is
      external "C"
      alias "gtk_menu_shell_prepend"
      end -- ext_menu_shell_prepend

   ext_menu_shell_insert(c_object, child : POINTER; position : INTEGER) is
      external "C"
      alias "gtk_menu_shell_insert"
      end -- ext_menu_shell_insert

   ext_deactivate(c_object : POINTER) is
      external "C"
      alias "gtk_menu_shell_deactivate"
      end -- ext_deactivate

   ext_menu_shell_select_item(menu_shell, menu_item : POINTER) is
      external "C"
      alias "gtk_menu_shell_select_item"
      end

   ext_menu_shell_activate_item(menu_shell, menu_item : POINTER ; 
				force_deactivate : BOOLEAN) is
      external "C"
      alias "gtk_menu_shell_activate_item"
      end

invariant
end -- GTK_MENU_SHELL

