indexing
   description: "gtk notebook"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen and Francois Pennaneach"
   id: "$Id: gtk_notebook.e,v 1.12 1999/01/18 19:54:58 pcj Exp $"

class GTK_NOTEBOOK
inherit
   GTK_CONTAINER
creation
   make,
   create
feature {ANY} -- Creation
   make is
      do
	 gtkobject := ext_new
      end -- make
feature {ANY} -- Queries
feature {ANY} -- Commands

   children : ARRAY[GTK_NOTEBOOK_PAGE] is
      local 
	 ptr : POINTER 
	 list : GLIST [POINTER]
	 i : INTEGER
	 obj : GTK_NOTEBOOK_PAGE
      do
	 ptr := ext_notebook_children ( gtkobject ) 
	 !!list.create(ptr)
	 !!Result.make(1, 1)

	 from 
	    i := list.lower 
	 until
	    i > list.upper
	 loop
	    !!obj.create(list.item(i))
	    Result.force(obj,i)
	    i := i+1
	 end
      end

   tab_pos : GTK_POSITION_TYPE is
      do
	 !!Result.make(ext_notebook_tab_pos(gtkobject))
      end

   append_page(child : GTK_WIDGET; tab_label : GTK_WIDGET) is
      do
	 ext_append_page(gtkobject, child.to_external, tab_label.to_external)
      end -- append_page

   append_page_menu ( child, tab_label, menu_label : GTK_WIDGET ) is
      do
         ext_notebook_append_page_menu ( gtkobject, child.to_external, 
					 tab_label.to_external, 
					 menu_label.to_external )
      end

   prepend_page(child : GTK_WIDGET; tab_label : GTK_WIDGET) is
      do
	 ext_prepend_page(gtkobject, child.to_external, tab_label.to_external)
      end -- append_page

   prepend_page_menu ( child, tab_label, menu_label : GTK_WIDGET ) is
      do
         ext_notebook_prepend_page_menu ( gtkobject, child.to_external, 
					  tab_label.to_external, 
					  menu_label.to_external )
      end

   insert_page(child, tab_label : GTK_WIDGET; position : INTEGER) is
      do
	 ext_insert_page(gtkobject, child.to_external, 
			 tab_label.to_external, position)
      end
   
   insert_page_menu ( child, tab_label, menu_label : GTK_WIDGET ; 
		      position : INTEGER ) is
      do
         ext_notebook_insert_page_menu ( gtkobject, child.to_external, 
					 tab_label.to_external, 
					 menu_label.to_external, position )
      end

   remove_page(page_number : INTEGER) is
      do
	 ext_remove_page(gtkobject, page_number)
      end -- remove_page

   current_page : INTEGER is
      do
	 Result := ext_current_page(gtkobject)
      end -- current_page

   -- This is the cur_page field of the notebook structure, not the 
   -- function call (confusing? you betcha.)
   cur_page : GTK_NOTEBOOK_PAGE is
      local curpage : POINTER 
      do
	 curpage := ext_notebook_cur_page(gtkobject)
	 if curpage /= default_pointer then 
	    !!Result.create(curpage)
	 else
	    Result := Void
	 end
      end

   page_num ( child : GTK_WIDGET ) : INTEGER is
      do
	 Result := ext_notebook_page_num ( gtkobject, child.to_external )
      end

   set_page(page_number : INTEGER) is
      do
	 ext_set_page(gtkobject, page_number)
      end -- set_page

   next_page is
      do
	 ext_next_page(gtkobject)
      end -- next_page

   prev_page is
      do
	 ext_prev_page(gtkobject)
      end -- prev_page

   set_show_border(show_border : BOOLEAN ) is
      do
	 ext_set_show_border(gtkobject, show_border)
      end -- set_show_border

   set_show_tabs(show_tabs : BOOLEAN ) is
      do
	 ext_set_show_tabs(gtkobject, show_tabs)
      end -- set_show_tabs

   set_tab_pos( pos : GTK_POSITION_TYPE ) is
      do
	 ext_set_tab_pos(gtkobject, pos.value)
      end -- set_tab_pos

   set_homogeneous_tabs ( homogeneous : BOOLEAN ) is
      do
	 ext_notebook_set_homogeneous_tabs(gtkobject, homogeneous) 
      end

   set_tab_border ( border_width : INTEGER ) is
      do
         ext_notebook_set_tab_border ( gtkobject, border_width )
      end

   set_tab_hborder ( tab_hborder : INTEGER ) is
      require 
	 tab_hborder >= 0
      do
	 ext_notebook_set_tab_hborder(gtkobject, tab_hborder)
      end

   set_tab_vborder ( tab_vborder : INTEGER ) is
      require 
	 tab_vborder >= 0
      do
	 ext_notebook_set_tab_vborder(gtkobject, tab_vborder)
      end

   set_scrollable ( scrollable : BOOLEAN ) is
      do
         ext_notebook_set_scrollable ( gtkobject, scrollable )
      end

   popup_disable is
      do
         ext_notebook_popup_disable ( gtkobject )
      end

   popup_enable is
      do
         ext_notebook_popup_enable ( gtkobject )
      end

   get_tab_label (child : GTK_WIDGET) : GTK_LABEL is 
      local 
	 p : POINTER 
      do
	 p := ext_notebook_get_tab_label (gtkobject, child.to_external)
	 if p /= default_pointer then
	    !!Result.create(p) 
	 else
	    Result := Void
	 end
      end

   set_tab_label ( child, tab_label : GTK_WIDGET ) is
      do
	 ext_notebook_set_tab_label ( gtkobject, child.to_external, 
				      tab_label.to_external ) 
      end

   set_tab_label_text (child : GTK_WIDGET ; tab_text : STRING ) is
      do
	 ext_notebook_set_tab_label_text ( gtkobject, child.to_external, 
					   tab_text.to_external ) 
      end

   get_menu_label (child :GTK_WIDGET) : GTK_LABEL is
      local 
	 p : POINTER
      do
	 p := ext_notebook_get_menu_label(gtkobject, child.to_external) 
	 if p /= default_pointer then 
	    !!Result.create(p)
	 else
	    Result := Void
	 end
      end

   set_menu_label (child, menu_label : GTK_WIDGET) is
      do
	 ext_notebook_set_menu_label(gtkobject, child.to_external, 
				     menu_label.to_external)
      end

   set_menu_label_text (child : GTK_WIDGET ; menu_text : STRING ) is
      do
	 ext_notebook_set_menu_label_text ( gtkobject, child.to_external,
					    menu_text.to_external ) 
      end

   tab_label_packing_expand (child : GTK_WIDGET ) : BOOLEAN is
      do
	 ext_notebook_query_tab_label_packing (gtkobject, child.to_external,
					       $dummy_bool, 
					       default_pointer, 
					       default_pointer) 
	 Result := dummy_bool
      end

   tab_label_packing_fill (child : GTK_WIDGET ) : BOOLEAN is
      do
	 ext_notebook_query_tab_label_packing (gtkobject, child.to_external,
					       $dummy_bool, 
					       default_pointer, 
					       default_pointer)
	 Result := dummy_bool
      end

   tab_label_packing_pack_type (child : GTK_WIDGET ) : GTK_PACK_TYPE is
      do
	 ext_notebook_query_tab_label_packing (gtkobject, child.to_external,
					       default_pointer, 
					       default_pointer,
					       $dummy_int) 
	 !!Result.make(dummy_int)
      end

   set_tab_label_packing(child : GTK_WIDGET; expand, fill : BOOLEAN ;
			 pack_type : GTK_PACK_TYPE) is
      do
	 ext_notebook_set_tab_label_packing(gtkobject, child.to_external,
					    expand, fill, pack_type.value)
      end
			 

   reorder_child ( child : GTK_WIDGET ; pos : INTEGER ) is
      do
	 ext_notebook_reorder_child ( gtkobject, child.to_external, pos ) 
      end

   get_nth_page ( page_number : INTEGER ) : GTK_NOTEBOOK_PAGE is
      do
	 !!Result.create(ext_notebook_get_nth_page(gtkobject, page_number))
      end

feature {NONE} -- Private
   dummy_bool : BOOLEAN
   dummy_int : INTEGER 

   ext_new : POINTER is
      external "C"
      alias "gtk_notebook_new"
      end -- ext_new

   ext_append_page(c_object, child, tab_label : POINTER) is
      external "C"
      alias "gtk_notebook_append_page"
      end -- ext_append_page

   ext_notebook_append_page_menu ( notebook, child, 
				   tab_label, menu_label : POINTER ) is
      external "C"
      alias "gtk_notebook_append_page_menu"
      end

   ext_notebook_page_num ( notebook, child : POINTER ) : INTEGER is
      external "C"
      alias "gtk_notebook_page_num"
      end

   ext_prepend_page(c_object, child, tab_label : POINTER) is
      external "C"
      alias "gtk_notebook_prepend_page"
      end -- ext_prepend_page

   ext_notebook_prepend_page_menu ( notebook, child, 
				    tab_label, menu_label : POINTER ) is
      external "C"
      alias "gtk_notebook_prepend_page_menu"
      end

   ext_insert_page(c_object, child, tab_label : POINTER; position : INTEGER) is
      external "C"
      alias "gtk_notebook_insert_page"
      end -- ext_insert_page

   ext_notebook_insert_page_menu ( notebook, child, 
				   tab_label, menu_label : POINTER ; 
				   position : INTEGER ) is
      external "C"
      alias "gtk_notebook_insert_page_menu"
      end

   ext_remove_page(c_object : POINTER; page_number : INTEGER) is
      external "C"
      alias "gtk_notebook_remove_page"
      end -- ext_remove_page

   ext_current_page(c_object : POINTER) : INTEGER is
      external "C"
      alias "gtk_notebook_get_current_page"
      end -- ext_current_page

   ext_set_page(c_object : POINTER; page_number : INTEGER) is
      external "C"
      alias "gtk_notebook_set_page"
      end -- ext_set_page

   ext_next_page(c_object : POINTER) is
      external "C"
      alias "gtk_notebook_next_page"
      end -- ext_next_page

   ext_prev_page(c_object : POINTER) is
      external "C"
      alias "gtk_notebook_prev_page"
      end -- ext_prev_page

   ext_notebook_set_scrollable ( notebook : POINTER ; scrollable : BOOLEAN ) is
      external "C"
      alias "gtk_notebook_set_scrollable"
      end

   ext_set_tab_pos(c_object : POINTER; pos : INTEGER) is
      external "C"
      alias "gtk_notebook_set_tab_pos"
      end -- ext_set_tab_pos

   ext_set_show_tabs(c_object : POINTER; show_tabs : BOOLEAN) is
      external "C"
      alias "gtk_notebook_set_show_tabs"
      end -- ext_set_show_tabs

   ext_set_show_border(c_object : POINTER; show_border : BOOLEAN ) is
      external "C"
      alias "gtk_notebook_set_show_border"
      end -- ext_set_show_border

   ext_notebook_popup_disable ( notebook : POINTER ) is
      external "C"
      alias "gtk_notebook_popup_disable"
      end

   ext_notebook_popup_enable ( notebook : POINTER ) is
      external "C"
      alias "gtk_notebook_popup_enable"
      end

   ext_notebook_set_tab_border ( notebook : POINTER ; 
				 border_width : INTEGER ) is
      external "C"
      alias "gtk_notebook_set_tab_border"
      end

   ext_notebook_reorder_child ( notebook, child : POINTER ; pos : INTEGER ) is
      external "C"
      alias "gtk_notebook_reorder_child"
      end

   ext_notebook_children ( notebook : POINTER ) : POINTER is
      external "C"
      end

   ext_notebook_tab_pos ( notebook : POINTER ) : INTEGER is
      external "C"
      end

   ext_notebook_cur_page ( notebook : POINTER ) : POINTER is
      external "C"
      end

   ext_notebook_set_homogeneous_tabs (notebook : POINTER ; 
				      homogeneous : BOOLEAN) is
      external "C"
      alias "gtk_notebook_set_homogeneous_tabs"
      end

   ext_notebook_set_tab_hborder (notebook : POINTER ; hborder : INTEGER) is
      external "C"
      alias "gtk_notebook_set_tab_hborder"
      end

   ext_notebook_set_tab_vborder (notebook : POINTER ; vborder : INTEGER) is
      external "C"
      alias "gtk_notebook_set_tab_vborder"
      end

   ext_notebook_get_tab_label ( notebook, child : POINTER ) : POINTER is
      external "C"
      alias "gtk_notebook_get_tab_label"
      end

   ext_notebook_set_tab_label ( notebook, child, tab_label : POINTER ) is
      external "C"
      alias "gtk_notebook_set_tab_label"
      end

   ext_notebook_set_tab_label_text ( notebook, child, tab_text : POINTER ) is
      external "C"
      alias "gtk_notebook_set_tab_label_text"
      end

   ext_notebook_get_menu_label ( notebook, child : POINTER ) : POINTER is
      external "C"
      alias "gtk_notebook_get_menu_label"
      end

   ext_notebook_set_menu_label (notebook, child, menu_label : POINTER ) is
      external "C"
      alias "gtk_notebook_set_menu_label"
      end

   ext_notebook_set_menu_label_text ( notebook, child, menu_text : POINTER ) is
      external "C"
      alias "gtk_notebook_set_menu_label_text"
      end

   ext_notebook_query_tab_label_packing (notebook, child, 
					 expand, fill, pack_type : POINTER) is
      external "C"
      alias "gtk_notebook_query_tab_label_packing"
      end

   ext_notebook_set_tab_label_packing(notebook, child : POINTER ; 
				      expand, fill :BOOLEAN ; 
				      pack_type : INTEGER) is
      external "C"
      alias "gtk_notebook_set_tab_label_packing"
      end

   ext_notebook_get_nth_page(notebook : POINTER ;
			     page_number : INTEGER) : POINTER is
      external "C"
      alias "gtk_notebook_get_nth_page"
      end

invariant
end -- GTK_NOTEBOOK

