indexing
   description: "gtk object"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen and Francois Pennaneach"
   id: "$Id: gtk_object.e,v 1.10 1999/01/18 19:54:58 pcj Exp $"

class GTK_OBJECT
-- implements any Gtk_Object
creation
   create
feature -- Creation
   create(new_gtkobject : POINTER) is
      do
	 gtkobject := new_gtkobject
      end -- create

feature -- Commands
   set_gtkobject(new_gtkobject : POINTER) is
      do
	 gtkobject := new_gtkobject
      end -- set_gtkobject

   add_action, signal_connect (signal_name : STRING; 
			       target : GTK_COMMAND_TYPE; data : ANY ) is
	 -- connect a signal by name
      local id : INTEGER
      do
	 -- Lame attempt to prevent garbage collection of these objects

	 -- id := Current.object_id
	 id := target.object_id
	 if data /= Void then
	    id := data.object_id
	 end
	 ext_signal_connect(Current.to_external, 
			    signal_name.to_external, 
			    target, data)
      end -- add_action
   
   disconnect is
      do
	 -- and what about identifiers returned by every 
	 -- connect() ???
      end -- disconnect
   
   ref is 
      do
	 ext_object_ref(gtkobject)
      end

   unref is
      do
	 ext_object_unref(gtkobject)
      end

   sink is 
      do
	 ext_object_sink(gtkobject) 
      end

   accel_groups_activate ( accel_key : INTEGER ; 
			   accel_mods : GDK_MODIFIER_TYPE ) : BOOLEAN is
      require
	 accel_key > 0 
      do
	 Result := ext_accel_groups_activate ( gtkobject, 
					       accel_key, accel_mods.value ) 
      end

feature {ANY} -- Queries

   to_external : POINTER is
      do
	 Result := gtkobject
      end

feature {NONE} 

      gtkobject : POINTER -- the address of a gtk object

feature {ANY} -- Commands
   set_user_data(data : ANY) is
      do
	 -- needs a GC freeze!
	 ext_object_set_user_data(gtkobject, data)
      end -- set_user_data

feature {NONE} -- C interface
 
   ext_signal_connect( c_object, signal : POINTER;
		      command : GTK_COMMAND_TYPE; data : ANY ) is
      external "C"
      end

   ext_object_ref ( c_object : POINTER ) is
      external "C"
      alias "gtk_object_ref"
      end

   ext_object_unref ( c_object : POINTER ) is
      external "C"
      alias "gtk_object_unref"
      end

   ext_object_sink ( c_object : POINTER ) is
      external "C"
      alias "gtk_object_sink"
      end

   ext_accel_groups_activate ( c_object : POINTER ;  
			       accel_key, accel_mods : INTEGER ) : BOOLEAN is
      external "C"
      alias "gtk_accel_groups_activate"
      end

feature {GTK_OBJECT}

   -- Builder has been replaced by the GTK_OBJECT_FACTORY

   ext_null_pointer : POINTER is
      external "C"
      end -- ext_null_pointer

   ext_object_set_user_data(c_object : POINTER; data : ANY) is
      external "C"
      alias "gtk_object_set_user_data"
      end -- ext_object_set_user_data

   

end -- GTK_OBJECT
