indexing
   description: "gtk object factory"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen"
   id: "$Id: gtk_object_factory.e,v 1.7 1999/01/18 19:54:58 pcj Exp $"

-- NOTE: Currently, if you try this on a composite widget, it 
-- probably won't work. Simple widgets should be OK, though. 

class GTK_OBJECT_FACTORY
feature {ANY} -- Commands
   make_object ( c_object : POINTER ) : GTK_OBJECT is
      local 
	 type : INTEGER
      do
	 from
	    type := ext_object_type(c_object)
	 until
	    object_dict.has(type) or
	       type = 0 
	 loop
	    type := ext_type_parent(type) 
	 end

	 Result := clone(object_dict @ type)
	 Result.create(c_object) 
      end

feature {NONE} -- Private

   the_dict : DICTIONARY[GTK_OBJECT, INTEGER]

   object_dict : DICTIONARY[GTK_OBJECT, INTEGER] is
      local 
	 c_object : GTK_OBJECT
      once
	 !!the_dict.make

	 -- !GTK_ACCEL_LABEL!c_object.create(default_pointer)
	 -- add_type(c_object, gtk_accel_label_get_type)
	 !GTK_ADJUSTMENT!c_object.create(default_pointer)
	 add_type(c_object, gtk_adjustment_get_type)
	 !GTK_ALIGNMENT!c_object.create(default_pointer)
	 add_type(c_object,  gtk_alignment_get_type)
	 !GTK_ARROW!c_object.create(default_pointer)
	 add_type(c_object,  gtk_arrow_get_type)
	 !GTK_ASPECT_FRAME!c_object.create(default_pointer)
	 add_type(c_object,  gtk_aspect_frame_get_type)
	 !GTK_BUTTON!c_object.create(default_pointer)
	 add_type(c_object,  gtk_button_get_type)
	 !GTK_CHECK_BUTTON!c_object.create(default_pointer)
	 add_type(c_object,  gtk_check_button_get_type)
	 !GTK_CHECK_MENU_ITEM!c_object.create(default_pointer)
	 add_type(c_object,  gtk_check_menu_item_get_type)
	 !GTK_CLIST!c_object.create(default_pointer)
	 add_type(c_object,  gtk_clist_get_type)
	 !GTK_COLOR_SELECTION!c_object.create(default_pointer)
	 add_type(c_object,  gtk_color_selection_get_type)
	 !GTK_COLOR_SELECTION_DIALOG!c_object.create(default_pointer)
	 add_type(c_object,  gtk_color_selection_dialog_get_type)
	 !GTK_COMBO!c_object.create(default_pointer)
	 add_type(c_object,  gtk_combo_get_type)
	 !GTK_CTREE!c_object.create(default_pointer)
	 add_type(c_object,  gtk_ctree_get_type)
	 !GTK_CURVE!c_object.create(default_pointer)
	 add_type(c_object,  gtk_curve_get_type)
	 !GTK_DIALOG!c_object.create(default_pointer)
	 add_type(c_object,  gtk_dialog_get_type)
	 !GTK_DRAWING_AREA!c_object.create(default_pointer)
	 add_type(c_object,  gtk_drawing_area_get_type)
	 !GTK_ENTRY!c_object.create(default_pointer)
	 add_type(c_object,  gtk_entry_get_type)
	 !GTK_EVENT_BOX!c_object.create(default_pointer)
	 add_type(c_object,  gtk_event_box_get_type)
	 !GTK_FILE_SELECTION!c_object.create(default_pointer)
	 add_type(c_object,  gtk_file_selection_get_type)
	 !GTK_FIXED!c_object.create(default_pointer)
	 add_type(c_object,  gtk_fixed_get_type)
	 !GTK_FONT_SELECTION!c_object.create(default_pointer)
	 add_type(c_object,  gtk_font_selection_get_type)
	 !GTK_FONT_SELECTION_DIALOG!c_object.create(default_pointer)
	 add_type(c_object,  gtk_font_selection_dialog_get_type)
	 !GTK_FRAME!c_object.create(default_pointer)
	 add_type(c_object,  gtk_frame_get_type)
	 !GTK_GAMMA_CURVE!c_object.create(default_pointer)
	 add_type(c_object,  gtk_gamma_curve_get_type)
	 !GTK_HANDLE_BOX!c_object.create(default_pointer)
	 add_type(c_object,  gtk_handle_box_get_type)
	 !GTK_HBUTTON_BOX!c_object.create(default_pointer)
	 add_type(c_object,  gtk_hbutton_box_get_type)
	 !GTK_HBOX!c_object.create(default_pointer)
	 add_type(c_object,  gtk_hbox_get_type)
	 !GTK_HPANED!c_object.create(default_pointer)
	 add_type(c_object,  gtk_hpaned_get_type)
	 !GTK_HRULER!c_object.create(default_pointer)
	 add_type(c_object,  gtk_hruler_get_type)
	 !GTK_HSCALE!c_object.create(default_pointer)
	 add_type(c_object,  gtk_hscale_get_type)
	 !GTK_HSCROLLBAR!c_object.create(default_pointer)
	 add_type(c_object,  gtk_hscrollbar_get_type)
	 !GTK_HSEPARATOR!c_object.create(default_pointer)
	 add_type(c_object,  gtk_hseparator_get_type)
	 !GTK_IMAGE!c_object.create(default_pointer)
	 add_type(c_object,  gtk_image_get_type)
	 !GTK_INPUT_DIALOG!c_object.create(default_pointer)
	 add_type(c_object,  gtk_input_dialog_get_type)
	 !GTK_LABEL!c_object.create(default_pointer)
	 add_type(c_object,  gtk_label_get_type)
	 !GTK_LIST!c_object.create(default_pointer)
	 add_type(c_object,  gtk_list_get_type)
	 !GTK_LIST_ITEM!c_object.create(default_pointer)
	 add_type(c_object,  gtk_list_item_get_type)
	 !GTK_MENU!c_object.create(default_pointer)
	 add_type(c_object,  gtk_menu_get_type)
	 !GTK_MENU_BAR!c_object.create(default_pointer)
	 add_type(c_object,  gtk_menu_bar_get_type)
	 !GTK_MENU_ITEM!c_object.create(default_pointer)
	 add_type(c_object,  gtk_menu_item_get_type)
	 !GTK_MENU_SHELL!c_object.create(default_pointer)
	 add_type(c_object,  gtk_menu_shell_get_type)
	 !GTK_NOTEBOOK!c_object.create(default_pointer)
	 add_type(c_object,  gtk_notebook_get_type)
	 !GTK_OBJECT!c_object.create(default_pointer)
	 add_type(c_object,  gtk_object_get_type)
	 !GTK_OPTION_MENU!c_object.create(default_pointer)
	 add_type(c_object,  gtk_option_menu_get_type)
	 --	 !GTK_PACKER!c_object.create(default_pointer)
	 -- add_type(c_object,  gtk_packer_get_type)
	 !GTK_PANED!c_object.create(default_pointer)
	 add_type(c_object,  gtk_paned_get_type)
	 !GTK_PIXMAP!c_object.create(default_pointer)
	 add_type(c_object,  gtk_pixmap_get_type)
	 !GTK_PREVIEW!c_object.create(default_pointer)
	 add_type(c_object,  gtk_preview_get_type)
	 !GTK_PROGRESS!c_object.create(default_pointer)
	 add_type(c_object,  gtk_progress_get_type)
	 !GTK_PROGRESS_BAR!c_object.create(default_pointer)
	 add_type(c_object,  gtk_progress_bar_get_type)
	 !GTK_RADIO_BUTTON!c_object.create(default_pointer)
	 add_type(c_object,  gtk_radio_button_get_type)
	 !GTK_RADIO_MENU_ITEM!c_object.create(default_pointer)
	 add_type(c_object,  gtk_radio_menu_item_get_type)
	 !GTK_RANGE!c_object.create(default_pointer)
	 add_type(c_object,  gtk_range_get_type)
	 !GTK_RULER!c_object.create(default_pointer)
	 add_type(c_object,  gtk_ruler_get_type)
	 !GTK_SCALE!c_object.create(default_pointer)
	 add_type(c_object,  gtk_scale_get_type)
	 !GTK_SCROLLBAR!c_object.create(default_pointer)
	 add_type(c_object,  gtk_scrollbar_get_type)
	 !GTK_SCROLLED_WINDOW!c_object.create(default_pointer)
	 add_type(c_object,  gtk_scrolled_window_get_type)
	 !GTK_SPINBUTTON!c_object.create(default_pointer)
	 add_type(c_object,  gtk_spin_button_get_type)
	 !GTK_STATUSBAR!c_object.create(default_pointer)
	 add_type(c_object,  gtk_statusbar_get_type)
	 !GTK_TABLE!c_object.create(default_pointer)
	 add_type(c_object,  gtk_table_get_type)
	 !GTK_TEXT!c_object.create(default_pointer)
	 add_type(c_object,  gtk_text_get_type)
	 -- !GTK_TIPS_QUERY!c_object.create(default_pointer)
	 -- add_type(c_object,  gtk_tips_query_get_type)
	 !GTK_TOGGLE_BUTTON!c_object.create(default_pointer)
	 add_type(c_object,  gtk_toggle_button_get_type)
	 !GTK_TOOLBAR!c_object.create(default_pointer)
	 add_type(c_object,  gtk_toolbar_get_type)
	 !GTK_TOOLTIPS!c_object.create(default_pointer)
	 add_type(c_object,  gtk_tooltips_get_type)
	 !GTK_TREE!c_object.create(default_pointer)
	 add_type(c_object,  gtk_tree_get_type)
	 !GTK_TREE_ITEM!c_object.create(default_pointer)
	 add_type(c_object,  gtk_tree_item_get_type)
	 !GTK_VBUTTON_BOX!c_object.create(default_pointer)
	 add_type(c_object,  gtk_vbutton_box_get_type)
	 !GTK_VBOX!c_object.create(default_pointer)
	 add_type(c_object,  gtk_vbox_get_type)
	 !GTK_VIEWPORT!c_object.create(default_pointer)
	 add_type(c_object,  gtk_viewport_get_type)
	 !GTK_VPANED!c_object.create(default_pointer)
	 add_type(c_object,  gtk_vpaned_get_type)
	 !GTK_VRULER!c_object.create(default_pointer)
	 add_type(c_object,  gtk_vruler_get_type)
	 !GTK_VSCALE!c_object.create(default_pointer)
	 add_type(c_object,  gtk_vscale_get_type)
	 !GTK_VSCROLLBAR!c_object.create(default_pointer)
	 add_type(c_object,  gtk_vscrollbar_get_type)
	 !GTK_VSEPARATOR!c_object.create(default_pointer)
	 add_type(c_object,  gtk_vseparator_get_type)
	 !GTK_WIDGET!c_object.create(default_pointer)
	 add_type(c_object,  gtk_widget_get_type)
	 !GTK_WINDOW!c_object.create(default_pointer)
	 add_type(c_object,  gtk_window_get_type)

	 Result := the_dict
      end

   add_type ( gtk_object : GTK_OBJECT ; object_type : INTEGER ) is 
      do
	 if object_type = 0 then
	    print("Bad stuff: ")
	    print(object_type)
	    print("%N")
	 end
	 the_dict.put(gtk_object, object_type)
      end

   ext_object_type ( c_object : POINTER ) : INTEGER is 
      external "C"
      end

   ext_type_parent ( type : INTEGER ) : INTEGER is
      external "C"
      alias "gtk_type_parent"
      end
-- 
   gtk_accel_label_get_type : INTEGER is
      external "C"
      end
   gtk_adjustment_get_type : INTEGER is
      external "C"
      end
   gtk_alignment_get_type : INTEGER is
      external "C"
      end
   gtk_arrow_get_type : INTEGER is
      external "C"
      end
   gtk_aspect_frame_get_type : INTEGER is
      external "C"
      end
   gtk_button_box_get_type : INTEGER is
      external "C"
      end
   gtk_bin_get_type : INTEGER is
      external "C"
      end
   gtk_box_get_type : INTEGER is
      external "C"
      end
   gtk_button_get_type : INTEGER is
      external "C"
      end
   gtk_check_button_get_type : INTEGER is
      external "C"
      end
   gtk_check_menu_item_get_type : INTEGER is
      external "C"
      end
   gtk_clist_get_type : INTEGER is
      external "C"
      end
   gtk_color_selection_get_type : INTEGER is
      external "C"
      end
   gtk_color_selection_dialog_get_type : INTEGER is
      external "C"
      end
   gtk_combo_get_type : INTEGER is
      external "C"
      end
   gtk_container_get_type : INTEGER is
      external "C"
      end
   gtk_ctree_get_type : INTEGER is
      external "C"
      end
   gtk_curve_get_type : INTEGER is
      external "C"
      end
   gtk_data_get_type : INTEGER is
      external "C"
      end
   gtk_dialog_get_type : INTEGER is
      external "C"
      end
   gtk_drawing_area_get_type : INTEGER is
      external "C"
      end
   gtk_editable_get_type : INTEGER is
      external "C"
      end
   gtk_entry_get_type : INTEGER is
      external "C"
      end
   gtk_event_box_get_type : INTEGER is
      external "C"
      end
   gtk_file_selection_get_type : INTEGER is
      external "C"
      end
   gtk_fixed_get_type : INTEGER is
      external "C"
      end
   gtk_font_selection_get_type : INTEGER is
      external "C"
      end
   gtk_font_selection_dialog_get_type : INTEGER is
      external "C"
      end
   gtk_frame_get_type : INTEGER is
      external "C"
      end
   gtk_gamma_curve_get_type : INTEGER is
      external "C"
      end
   gtk_handle_box_get_type : INTEGER is
      external "C"
      end
   gtk_hbutton_box_get_type : INTEGER is
      external "C"
      end
   gtk_hbox_get_type : INTEGER is
      external "C"
      end
   gtk_hpaned_get_type : INTEGER is
      external "C"
      end
   gtk_hruler_get_type : INTEGER is
      external "C"
      end
   gtk_hscale_get_type : INTEGER is
      external "C"
      end
   gtk_hscrollbar_get_type : INTEGER is
      external "C"
      end
   gtk_hseparator_get_type : INTEGER is
      external "C"
      end
   gtk_image_get_type : INTEGER is
      external "C"
      end
   gtk_input_dialog_get_type : INTEGER is
      external "C"
      end
   gtk_item_get_type : INTEGER is
      external "C"
      end
   gtk_item_factory_get_type : INTEGER is
      external "C"
      end
   gtk_label_get_type : INTEGER is
      external "C"
      end
   gtk_list_get_type : INTEGER is
      external "C"
      end
   gtk_list_item_get_type : INTEGER is
      external "C"
      end
   gtk_menu_get_type : INTEGER is
      external "C"
      end
   gtk_menu_bar_get_type : INTEGER is
      external "C"
      end
   gtk_menu_item_get_type : INTEGER is
      external "C"
      end
   gtk_menu_shell_get_type : INTEGER is
      external "C"
      end
   gtk_misc_get_type : INTEGER is
      external "C"
      end
   gtk_notebook_get_type : INTEGER is
      external "C"
      end
   gtk_object_get_type : INTEGER is
      external "C"
      end
   gtk_option_menu_get_type : INTEGER is
      external "C"
      end
   gtk_packer_get_type : INTEGER is
      external "C"
      end
   gtk_paned_get_type : INTEGER is
      external "C"
      end
   gtk_pixmap_get_type : INTEGER is
      external "C"
      end
   gtk_preview_get_type : INTEGER is
      external "C"
      end
   gtk_progress_get_type : INTEGER is
      external "C"
      end
   gtk_progress_bar_get_type : INTEGER is
      external "C"
      end
   gtk_radio_button_get_type : INTEGER is
      external "C"
      end
   gtk_radio_menu_item_get_type : INTEGER is
      external "C"
      end
   gtk_range_get_type : INTEGER is
      external "C"
      end
   gtk_ruler_get_type : INTEGER is
      external "C"
      end
   gtk_scale_get_type : INTEGER is
      external "C"
      end
   gtk_scrollbar_get_type : INTEGER is
      external "C"
      end
   gtk_scrolled_window_get_type : INTEGER is
      external "C"
      end
   gtk_separator_get_type : INTEGER is
      external "C"
      end
   gtk_spin_button_get_type : INTEGER is
      external "C"
      end
   gtk_statusbar_get_type : INTEGER is
      external "C"
      end
   gtk_table_get_type : INTEGER is
      external "C"
      end
   gtk_text_get_type : INTEGER is
      external "C"
      end
   gtk_tips_query_get_type : INTEGER is
      external "C"
      end
   gtk_toggle_button_get_type : INTEGER is
      external "C"
      end
   gtk_toolbar_get_type : INTEGER is
      external "C"
      end
   gtk_tooltips_get_type : INTEGER is
      external "C"
      end
   gtk_tree_get_type : INTEGER is
      external "C"
      end
   gtk_tree_item_get_type : INTEGER is
      external "C"
      end
   gtk_identifier_get_type : INTEGER is
      external "C"
      end
   gtk_vbutton_box_get_type : INTEGER is
      external "C"
      end
   gtk_vbox_get_type : INTEGER is
      external "C"
      end
   gtk_viewport_get_type : INTEGER is
      external "C"
      end
   gtk_vpaned_get_type : INTEGER is
      external "C"
      end
   gtk_vruler_get_type : INTEGER is
      external "C"
      end
   gtk_vscale_get_type : INTEGER is
      external "C"
      end
   gtk_vscrollbar_get_type : INTEGER is
      external "C"
      end
   gtk_vseparator_get_type : INTEGER is
      external "C"
      end
   gtk_widget_get_type : INTEGER is
      external "C"
      end
   gtk_window_get_type : INTEGER is
      external "C"
      end

invariant
end
