indexing
   description: "gtk packer"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen"
   id: "$Id: gtk_packer.e,v 1.6 1999/01/18 19:54:58 pcj Exp $"

class GTK_PACKER
inherit 
   GTK_CONTAINER
      rename add as container_add 
      end
creation
   make, create
feature -- Creation
   make is
      do
	 gtkobject := ext_packer_new
      end -- make

feature {ANY} -- Commands
   add_defaults (child : GTK_WIDGET ;
		 side : GTK_SIDE_TYPE; 
		 anchor : GTK_ANCHOR_TYPE; 
		 options : GTK_PACKER_OPTIONS) is
      do
	 ext_packer_add_defaults(gtkobject, child.to_external, 
				 side.value, anchor.value, options.value)
      end

   add (child : GTK_WIDGET ;
	side : GTK_SIDE_TYPE; 
	anchor : GTK_ANCHOR_TYPE; 
	options : GTK_PACKER_OPTIONS; 
	border_width, pad_x, pad_y, i_pad_x, i_pad_y : INTEGER) is
      do
	 ext_packer_add(gtkobject, child.to_external, 
			side.value, anchor.value, options.value, 
			border_width, pad_x, pad_y, i_pad_x, i_pad_y)
      end

   set_child_packing(child : GTK_WIDGET ;
	side : GTK_SIDE_TYPE; 
	anchor : GTK_ANCHOR_TYPE; 
	options : GTK_PACKER_OPTIONS; 
	border_width, pad_x, pad_y, i_pad_x, i_pad_y : INTEGER) is
      do
	 ext_packer_set_child_packing(gtkobject, child.to_external, 
				      side.value, anchor.value, options.value, 
				      border_width, pad_x, pad_y, 
				      i_pad_x, i_pad_y)
      end

   reorder_child(child : GTK_WIDGET; position : INTEGER) is
      do
	 ext_packer_reorder_child(gtkobject, child.to_external, position)
      end

   set_spacing (spacing : INTEGER) is
      do
	 ext_packer_set_spacing(gtkobject, spacing)
      end

   set_default_border_width(border : INTEGER) is
      do
	 ext_packer_set_default_border_width(gtkobject, border) 
      end

   set_default_pad(pad_x, pad_y : INTEGER) is
      do
	 ext_packer_set_default_pad(gtkobject, pad_x, pad_y)
      end
   
   set_default_ipad(i_pad_x, i_pad_y : INTEGER) is
      do
	 ext_packer_set_default_ipad(gtkobject, i_pad_x, i_pad_y)
      end

feature {NONE} -- Private

   ext_packer_new : POINTER is
      external "C"
      alias "gtk_packer_new"
      end

   ext_packer_add_defaults(packer, child : POINTER ; 
			   side, anchor, options : INTEGER) is
      external "C"
      alias "gtk_packer_add_defaults"
      end

   ext_packer_add(packer, child : POINTER ; side, anchor, options,
		  border_width, pad_x, pad_y, i_pad_x, i_pad_y : INTEGER ) is
      external "C"
      alias "gtk_packer_add"
      end

   ext_packer_set_child_packing(packer, child : POINTER ; 
				side, anchor, options, border_width, 
				pad_x, pad_y, i_pad_x, i_pad_y : INTEGER ) is
      external "C"
      alias "gtk_packer_set_child_packing"
      end

   ext_packer_reorder_child(packer, child : POINTER ; position : INTEGER) is
      external "C"
      alias "gtk_packer_reorder_child"
      end

   ext_packer_set_spacing(packer : POINTER ; spacing : INTEGER) is
      external "C"
      alias "gtk_packer_set_spacing"
      end
   
   ext_packer_set_default_border_width(packer : POINTER ; border : INTEGER) is
      external "C"
      alias "gtk_packer_set_default_border_width"
      end

   ext_packer_set_default_pad( packer : POINTER ; pad_x, pad_y : INTEGER) is
      external "C"
      alias "gtk_packer_set_default_pad"
      end

   ext_packer_set_default_ipad(packer : POINTER ; 
			       i_pad_x, i_pad_y : INTEGER) is
      external "C"
      alias "gtk_packer_set_default_ipad"
      end

invariant
end 

