indexing
   description: "gtk pixmap"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen and Francois Pennaneach"
   id: "$Id: gtk_pixmap.e,v 1.6 1999/01/18 19:54:58 pcj Exp $"

class GTK_PIXMAP
inherit
   GTK_MISC
creation
   make,
   make_from_pixmap, 
   create
feature -- Creation

   make, make_from_pixmap (pixmap : GDK_PIXMAP) is
      -- Creation and initialization
      do
	 gtkobject := ext_pixmap_new(pixmap.to_external, pixmap.mask.to_external)
      end -- make


feature {ANY} -- Commands
   
   set ( pixmap : GDK_PIXMAP ) is
      do
	 ext_pixmap_set ( gtkobject, pixmap.to_external, pixmap.mask.to_external )
      end

   get : GDK_PIXMAP is
      do
	 ext_pixmap_get ( gtkobject, $dummy1, $dummy2 )
	 !!Result.create_pixmap ( dummy1, dummy2 )
      end

   set_build_insensitive (build : INTEGER) is
      do
	 ext_pixmap_set_build_insensitive(gtkobject, build)
      end
   
feature {NONE} -- Private
   ext_pixmap_new(c1, c2 : POINTER) : POINTER is
      external "C"
      alias "gtk_pixmap_new"
      end

   ext_pixmap_set ( pixmap, val, mask : POINTER ) is
      external "C"
      alias "gtk_pixmap_set"
      end

   ext_pixmap_get ( pixmap, val, mask : POINTER ) is
      external "C"
      alias "gtk_pixmap_get"
      end

   ext_pixmap_set_build_insensitive( pixmap : POINTER ; build : INTEGER ) is
      external "C"
      alias "gtk_pixmap_set_build_insensitive"
      end

   -- This is ridiculous. 
   dummy1, dummy2 : POINTER

invariant
end -- GTK_PIXMAP

