indexing
   description: "gtk preview"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen and Francois Pennaneach"
   id: "$Id: gtk_preview.e,v 1.8 1999/01/18 19:54:59 pcj Exp $"

class GTK_PREVIEW
inherit
   GTK_WIDGET
creation
   make,
   create
feature -- Creation
   make ( type : GTK_PREVIEW_TYPE ) is
      do
         gtkobject := ext_preview_new (type.value) 
      end

feature {ANY}

   get_cmap : GDK_COLORMAP is
      do
         !!Result.create(ext_preview_get_cmap)
      end

   get_visual : GDK_VISUAL is
      do
         !!Result.create(ext_preview_get_visual)
      end

   set_color_cube ( nred_shades, ngreen_shades, 
		    nblue_shades, ngray_shades : INTEGER ) is
      do
         ext_preview_set_color_cube ( nred_shades, ngreen_shades, 
				      nblue_shades, ngray_shades )
      end

   set_expand ( expand : BOOLEAN ) is
      do
         ext_preview_set_expand ( gtkobject, expand )
      end

   set_install_cmap ( install_cmap : BOOLEAN ) is
      do
         ext_preview_set_install_cmap ( install_cmap )
      end

   set_reserved ( nreserved : INTEGER ) is
      do
         ext_preview_set_reserved ( nreserved )
      end

   size ( width, height : INTEGER ) is
      do
         ext_preview_size ( gtkobject, width, height )
      end

   put ( gdk_window : GDK_WINDOW ; gc : GDK_GC; srcx, srcy, destx, desty, 
	 width, height : INTEGER ) is
      do
	 ext_preview_put (gtkobject, gdk_window.to_external, gc.to_external,
			  srcx, srcy, destx, desty, width, height)
      end

   draw_row ( data : ARRAY[CHARACTER] ; x, y, w : INTEGER ) is
      do
	 ext_preview_draw_row (gtkobject, data.to_external, x, y, w)
      end

   set_gamma ( gamma : DOUBLE ) is
      do
	 ext_preview_set_gamma (gtkobject, gamma) 
      end

   uninit is
      do
	 ext_preview_uninit
      end

   reset is
      do
	 ext_preview_reset
      end

-- missing: put_row, get_info

feature {NONE} -- Private

   ext_preview_new ( type : INTEGER ) : POINTER is
      external "C"
      alias "gtk_preview_new"
      end

   ext_preview_get_cmap : POINTER is
      external "C"
      alias "gtk_preview_get_cmap"
      end

   ext_preview_get_visual  : POINTER is
      external "C"
      alias "gtk_preview_get_visual"
      end

   ext_preview_set_color_cube ( nred_shades, ngreen_shades, 
				nblue_shades, ngray_shades : INTEGER ) is
      external "C"
      alias "gtk_preview_set_color_cube"
      end

   ext_preview_set_expand ( preview : POINTER ; expand : BOOLEAN ) is
      external "C"
      alias "gtk_preview_set_expand"
      end

   ext_preview_set_install_cmap ( install_cmap : BOOLEAN ) is
      external "C"
      alias "gtk_preview_set_install_cmap"
      end

   ext_preview_set_reserved ( nreserved : INTEGER ) is
      external "C"
      alias "gtk_preview_set_reserved"
      end

   ext_preview_size ( preview : POINTER ; width, height : INTEGER ) is
      external "C"
      alias "gtk_preview_size"
      end

   ext_preview_draw_row ( preview, data : POINTER ; x, y, z : INTEGER ) is
      external "C"
      alias "gtk_preview_draw_row"
      end

   ext_preview_put ( preview, gdk_window, gc : POINTER ; 
		     srcx, srcy, destx, desty, width, height : INTEGER ) is
      external "C"
      alias "gtk_preview_put"
      end

   ext_preview_set_gamma ( preview : POINTER ; gamma : DOUBLE ) is
      external "C"
      alias "gtk_preview_set_gamma"
      end

   ext_preview_uninit is
      external "C"
      alias "gtk_preview_uninit"
      end

   ext_preview_reset is
      external "C"
      alias "gtk_preview_reset"
      end

invariant
end -- GTK_PREVIEW

