indexing
   description: "gtk progress"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen"
   id: "$Id: gtk_progress.e,v 1.9 1999/01/18 19:54:59 pcj Exp $"

deferred class GTK_PROGRESS
inherit 
   GTK_WIDGET
feature {ANY}

   set_show_text ( show_text : BOOLEAN ) is
      do
	 ext_progress_set_show_text ( gtkobject, show_text )
      end

   set_text_alignment ( x_align, y_align : REAL ) is
      do
	 ext_progress_set_text_alignment ( gtkobject, x_align, y_align ) 
      end

   set_format_string ( format : STRING ) is
      do
	 ext_progress_set_format_string ( gtkobject, format.to_external )
      end

   set_adjustment ( adjustment : GTK_ADJUSTMENT ) is
      do
	 ext_progress_set_adjustment ( gtkobject, adjustment.to_external ) 
      end

   configure ( value, min, max : REAL ) is
      do
	 ext_progress_configure ( gtkobject, value, min, max ) 
      end

   set_percentage ( percentage : REAL ) is
      do
	 ext_progress_set_percentage ( gtkobject, percentage ) 
      end

   set_value ( value :REAL ) is
      do
	 ext_progress_set_value ( gtkobject, value ) 
      end

   get_value : REAL is
      do
	 Result := ext_progress_get_value ( gtkobject ) 
      end

   set_activity_mode ( activity_mode : BOOLEAN ) is
      do
	 ext_progress_set_activity_mode ( gtkobject, activity_mode ) 
      end

   get_current_text : STRING is
      do
	 !!Result.from_external(ext_progress_get_current_text(gtkobject))
      end

   get_text_from_value ( value: REAL ) : STRING is
      do
	 !!Result.from_external(ext_progress_get_text_from_value(gtkobject, 
								 value))
      end

   get_current_percentage : REAL is
      do
	 Result := ext_progress_get_current_percentage ( gtkobject )
      end

   get_percentage_from_value ( value : REAL ) : REAL is
      do
	 Result := ext_progress_get_percentage_from_value (gtkobject, value)
      end

feature {NONE} -- Private
   ext_progress_set_show_text ( progress : POINTER ; show_text : BOOLEAN ) is
      external "C"
      alias "gtk_progress_set_show_text"
      end
   ext_progress_set_text_alignment ( progress : POINTER ; 
				     x_align, y_align : REAL ) is
      external "C"
      alias "gtk_progress_set_text_alignment"
      end
   ext_progress_set_format_string ( progress, format : POINTER ) is
      external "C"
      alias "gtk_progress_set_format_string"
      end
   ext_progress_set_adjustment ( progress, adjustment : POINTER ) is
      external "C"
      alias "gtk_progress_set_adjustment"
      end
   ext_progress_configure ( progress : POINTER ; value, min, max : REAL ) is
      external "C"
      alias "gtk_progress_configure"
      end
   ext_progress_set_percentage ( progress : POINTER ; percentage : REAL ) is
      external "C"
      alias "gtk_progress_set_percentage"
      end
   ext_progress_set_value ( progress : POINTER ; value : REAL ) is
      external "C"
      alias "gtk_progress_set_value"
      end
   ext_progress_get_value( progress : POINTER ) : REAL is
      external "C"
      alias "gtk_progress_get_value"
      end
   ext_progress_set_activity_mode ( progress : POINTER ; 
				    activity_mode : BOOLEAN ) is
      external "C"
      alias "gtk_progress_set_activity_mode"
      end
   ext_progress_get_current_text ( progress : POINTER ) : POINTER is
      external "C"
      alias "gtk_progress_get_current_text"
      end
   ext_progress_get_text_from_value ( progress : POINTER ; 
				      value : REAL ) : POINTER is
      external "C"
      alias "gtk_progress_get_text_from_value"
      end
   ext_progress_get_current_percentage ( progress : POINTER ) : REAL is 
      external "C"
      alias "gtk_progress_get_current_percentage"
      end
   ext_progress_get_percentage_from_value ( progress : POINTER; 
					    value : REAL ) : REAL is
      external "C"
      alias "gtk_progress_get_percentage_from_value"
      end
   
invariant
end 

