indexing
   description: "gtk progress bar"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen and Francois Pennaneach"
   id: "$Id: gtk_progress_bar.e,v 1.7 1999/01/18 19:54:59 pcj Exp $"

class GTK_PROGRESS_BAR
inherit
   GTK_PROGRESS
creation
   make, make_with_adjustment, 
   create
feature -- Creation
   make is
      -- Creation and initialization
      do
	 gtkobject := ext_progress_bar_new
      end -- make

   make_with_adjustment ( adjustment : GTK_ADJUSTMENT ) is
      do
	 gtkobject := ext_progress_bar_new_with_adjustment ( adjustment.to_external)
      end

feature {ANY} -- Commands

   update(percentage : REAL) is
      do
	 ext_update(gtkobject, percentage)
      end -- update

   set_bar_style ( style_ : GTK_PROGRESS_BAR_STYLE ) is
      do
	 ext_progress_bar_set_bar_style ( gtkobject, style_.value )
      end
   
   set_discrete_blocks ( blocks : INTEGER ) is
      require 
	 blocks >= 0 
      do
	 ext_progress_bar_set_discrete_blocks ( gtkobject, blocks ) 
      end

   set_activity_step ( step : INTEGER ) is
      require
	 step >= 0
      do
	 ext_progress_bar_set_activity_step ( gtkobject, step ) 
      end

   set_activity_blocks ( blocks : INTEGER ) is
      require
	 blocks >= 0 
      do
	 ext_progress_bar_set_activity_blocks ( gtkobject, blocks ) 
      end

   set_orientation ( orientation : GTK_PROGRESS_BAR_ORIENTATION ) is
      do
	 ext_progress_bar_set_orientation ( gtkobject, orientation.value ) 
      end

feature {NONE} -- Private

   ext_progress_bar_new : POINTER is
      external "C"
      alias "gtk_progress_bar_new"
      end 

   ext_update(c_object : POINTER; percentage : REAL) is
      external "C"
      alias "gtk_progress_bar_update"
      end -- ext_update

   ext_progress_bar_new_with_adjustment ( adjustment : POINTER ) : POINTER is
      external "C"
      alias "gtk_progress_bar_new_with_adjustment"
      end

   ext_progress_bar_set_bar_style ( pbar: POINTER ; style_ : INTEGER ) is
      external "C"
      alias "gtk_progress_bar_set_bar_style"
      end

   ext_progress_bar_set_discrete_blocks ( pbar: POINTER ;  
					  blocks : INTEGER ) is
      external "C"
      alias "gtk_progress_bar_set_discrete_blocks"
      end
   
   ext_progress_bar_set_activity_step ( pbar: POINTER ;  step : INTEGER ) is
      external "C"
      alias "gtk_progress_bar_set_activity_step"
      end
   
   ext_progress_bar_set_activity_blocks ( pbar: POINTER ; blocks : INTEGER ) is
      external "C"
      alias "gtk_progress_bar_set_activity_blocks"
      end
   
   ext_progress_bar_set_orientation ( pbar: POINTER ; 
				      orientation : INTEGER  ) is
      external "C"
      alias "gtk_progress_bar_set_orientation"
      end

invariant
end -- GTK_PROGRESS_BAR

