indexing
   description: "gtk radio button"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen and Francois Pennaneach"
   id: "$Id: gtk_radio_button.e,v 1.9 1999/01/18 19:54:59 pcj Exp $"

class GTK_RADIO_BUTTON
inherit
   GTK_CHECK_BUTTON
      rename 
	 make as make_check_button
     	 make_with_label as make_with_label_check_button
      end;
creation
   make_with_group,
   make_with_group_and_label,
   make_with_widget, 
   make_with_widget_and_label, 
   create
feature -- Creation

   make_with_group(group : GTK_RADIO_BUTTON_GROUP) is
      -- Creation and initialization
      require
	 group_not_void : group /= Void
      do
	 gtkobject := ext_radio_button_new(group.to_external)
	 group.create(ext_radio_button_group(gtkobject))
      end 

   make_with_group_and_label(group : GTK_RADIO_BUTTON_GROUP; label : STRING) is
      require
	 group_not_void : group /= Void
	 label /= Void
      do
	 gtkobject := ext_radio_button_new_with_label(group.to_external, 
						      label.to_external)
	 group.create(ext_radio_button_group(gtkobject))
      end -- make_and_group_with_label

   make_with_widget ( group : GTK_RADIO_BUTTON ) is
      do
	 gtkobject := ext_radio_button_new_from_widget (group.to_external)
      end

   make_with_widget_and_label ( group : GTK_RADIO_BUTTON ; label : STRING ) is
      do
	 gtkobject := ext_radio_button_new_with_label_from_widget ( group.to_external, 
								    label.to_external ) 
      end

feature {ANY} -- Commands

   set_group ( group : GTK_RADIO_BUTTON_GROUP ) is
      do
	 ext_radio_button_set_group (gtkobject, group.to_external) 
      end

feature {NONE} -- Private

   ext_radio_button_new(group : POINTER) : POINTER is
      external "C"
      alias "gtk_radio_button_new"
      end

   ext_radio_button_new_with_label(group : POINTER; s : POINTER) : POINTER is
      external "C"
      alias "gtk_radio_button_new_with_label"
      end

   ext_radio_button_group(c_object : POINTER) : POINTER is
      external "C"
      alias "gtk_radio_button_group"
      end

   ext_radio_button_new_from_widget (group : POINTER) : POINTER is
      external "C"
      alias "gtk_radio_button_new_from_widget"
      end

   ext_radio_button_new_with_label_from_widget( group, 
						label : POINTER ) : POINTER is
      external "C"
      alias "gtk_radio_button_new_with_label_from_widget"
      end

   ext_radio_button_set_group (radio_button, group : POINTER) is
      external "C"
      alias "gtk_radio_button_set_group"
      end

invariant
end -- GTK_RADIO_BUTTON

