indexing
   description: "gtk radio menu item"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen and Francois Pennaneach"
   id: "$Id: gtk_radio_menu_item.e,v 1.9 1999/01/18 19:54:59 pcj Exp $"

class GTK_RADIO_MENU_ITEM
inherit
   GTK_CHECK_MENU_ITEM
   redefine 
      make, 
      make_with_label
      end
creation
   make, 
   make_with_label, 
   make_with_group,
   make_with_group_and_label,
   make_with_item, 
   make_with_item_and_label, 
   create
feature -- Creation

   make is 
      do
	 gtkobject := ext_radio_menu_item_new(default_pointer)
      end
   
   make_with_label ( label : STRING ) is
      do
	 gtkobject := ext_radio_menu_item_new_with_label(default_pointer, 
							 label.to_external)
      end

   make_with_group(group_ : GTK_GSLIST) is
      do
	 gtkobject := ext_radio_menu_item_new(group_.to_external)
      end -- make_with_group

   make_with_group_and_label(group_ : GTK_GSLIST; label : STRING) is
      do
	 gtkobject := ext_radio_menu_item_new_with_label(group_.to_external, 
							 label.to_external)
      end -- make_with_group_and_label

   make_with_item(item : like Current) is
      local 
	 group_ : GTK_GSLIST
      do
	 if item = Void then 
	    !!group_.make
	 else
	    group_ := item.group
	 end
	 make_with_group(group_)
      end

   make_with_item_and_label(item: like Current ; label : STRING ) is
      local 
	 group_ : GTK_GSLIST
      do
	 if item = Void then 
	    !!group_.make 
	 else
	    group_ := item.group
	 end
	 make_with_group_and_label(group_, label)
      end
   
feature {ANY} -- Queries

   group : GTK_GSLIST is
      do
	 !!Result.create(ext_radio_menu_item_group(gtkobject))
      end

feature {ANY} -- Commands

   set_group ( group_ : GTK_GSLIST ) is 
      do
	 ext_radio_menu_item_set_group(gtkobject, group_.to_external)
      end

feature {NONE} -- Private
   ext_radio_menu_item_new(c_list : POINTER) : POINTER is
      external "C"
      alias "gtk_radio_menu_item_new"
      end -- ext_radio_menu_item_new

   ext_radio_menu_item_new_with_label(c_list, label : POINTER) : POINTER is
      external "C"
      alias "gtk_radio_menu_item_new_with_label"
      end -- ext_radio_menu_item_new_with_label

   ext_radio_menu_item_group ( radio_menu_item : POINTER ) : POINTER is
      external "C"
      alias "gtk_radio_menu_item_group"
      end

   ext_radio_menu_item_set_group ( radio_menu_item, group_ : POINTER ) is
      external "C"
      alias "gtk_radio_menu_item_set_group"
      end

invariant
end -- GTK_RADIO_MENU_ITEM

