indexing
   description: "gtk range"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen and Francois Pennaneach"
   id: "$Id: gtk_range.e,v 1.7 1999/01/18 19:54:59 pcj Exp $"

class GTK_RANGE
inherit
   GTK_WIDGET
creation create
feature {ANY} 

   get_adjustment  : GTK_ADJUSTMENT is
      do
         !!Result.create(ext_range_get_adjustment ( gtkobject ))
      end

   set_adjustment ( adjustment : GTK_ADJUSTMENT ) is
      do
         ext_range_set_adjustment ( gtkobject, adjustment.to_external )
      end

   set_update_policy ( policy : GTK_UPDATE_TYPE ) is
      do
         ext_range_set_update_policy ( gtkobject, policy.value )
      end

   draw_background is
      do
	 ext_range_draw_background ( gtkobject ) 
      end

   clear_background is
      do
	 ext_range_clear_background ( gtkobject ) 
      end

   draw_trough is
      do
	 ext_range_draw_trough ( gtkobject ) 
      end

   draw_slider is
      do
	 ext_range_draw_slider ( gtkobject ) 
      end

   draw_step_forw is
      do
	 ext_range_draw_step_forw ( gtkobject ) 
      end

   draw_step_back is
      do
	 ext_range_draw_step_back ( gtkobject ) 
      end
   
   slider_update is
      do
	 ext_range_slider_update ( gtkobject ) 
      end

   trough_click ( x, y : INTEGER ; jump_perc : REAL ) : INTEGER is 
      do 
	 Result := ext_range_trough_click ( gtkobject, x, y, jump_perc ) 
      end

   default_hslider_update is
      do
	 ext_range_default_hslider_update ( gtkobject ) 
      end

   default_vslider_update is
      do
	 ext_range_default_vslider_update ( gtkobject ) 
      end
   
   default_htrough_click ( x, y : INTEGER ; jump_perc : REAL ) : INTEGER is
      do
	 Result := ext_range_default_htrough_click ( gtkobject, x, y, 
						     jump_perc ) 
      end
   
   default_vtrough_click ( x, y : INTEGER ; jump_perc : REAL ) : INTEGER is
      do
	 Result := ext_range_default_vtrough_click ( gtkobject, x, y, 
						     jump_perc ) 
      end

   default_hmotion ( xdelta, ydelta : INTEGER ) is 
      do
	 ext_range_default_hmotion ( gtkobject, xdelta, ydelta ) 
      end

   default_vmotion ( xdelta, ydelta : INTEGER ) is
      do
	 ext_range_default_vmotion ( gtkobject, xdelta, ydelta ) 
      end

feature {NONE} -- Private

   ext_range_get_adjustment ( range : POINTER ) : POINTER is
      external "C"
      alias "gtk_range_get_adjustment"
      end

   ext_range_set_adjustment ( range, adjustment : POINTER ) is
      external "C"
      alias "gtk_range_set_adjustment"
      end

   ext_range_set_update_policy ( range : POINTER ; policy : INTEGER ) is
      external "C"
      alias "gtk_range_set_update_policy"
      end

   ext_range_draw_background ( range : POINTER ) is 
      external "C"
      alias "gtk_range_draw_background" 
      end
   
   ext_range_clear_background ( range : POINTER ) is
      external "C"
      alias "gtk_range_clear_background" 
      end

   ext_range_draw_trough ( range : POINTER ) is 
      external "C"
      alias "gtk_range_draw_trough" 
      end

   ext_range_draw_slider ( range : POINTER ) is 
      external "C"
      alias "gtk_range_draw_slider" 
      end

   ext_range_draw_step_forw ( range : POINTER ) is 
      external "C"
      alias "gtk_range_draw_step_forw" 
      end

   ext_range_draw_step_back ( range : POINTER ) is 
      external "C"
      alias "gtk_range_draw_step_back" 
      end

   ext_range_slider_update ( range : POINTER ) is
      external "C"
      alias "gtk_range_slider_update"
      end

   ext_range_trough_click ( range : POINTER ; x, y : INTEGER ; 
			    jump_perc : REAL ) : INTEGER is
      external "C"
      alias "gtk_range_trough_click"
      end

   ext_range_default_hslider_update ( range : POINTER ) is
      external "C"
      alias "gtk_range_default_hslider_update"
      end

   ext_range_default_vslider_update ( range : POINTER ) is
      external "C"
      alias "gtk_range_default_vslider_update"
      end

   ext_range_default_htrough_click ( range : POINTER ; 
				     x, y : INTEGER ; 
				     jump_perc : REAL ) : INTEGER is
      external "C"
      alias "gtk_range_default_htrough_click"
      end

   ext_range_default_vtrough_click ( range : POINTER ;
				     x, y : INTEGER ; 
				     jump_perc : REAL ) : INTEGER is
      external "C"
      alias "gtk_range_default_vtrough_click"
      end

   ext_range_default_hmotion ( range : POINTER ; xdelta, ydelta : INTEGER ) is
      external "C"
      alias "gtk_range_default_hmotion"
      end

   ext_range_default_vmotion ( range : POINTER ; xdelta, ydelta : INTEGER ) is
      external "C"
      alias "gtk_range_default_vmotion"
      end

invariant
end -- GTK_RANGE

