indexing
   description: "gtk scrolled window"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen and Francois Pennaneach"
   id: "$Id: gtk_scrolled_window.e,v 1.9 1999/01/18 19:54:59 pcj Exp $"

class GTK_SCROLLED_WINDOW
inherit
   GTK_CONTAINER
creation
   make,
   make_with_adjustment,
   create
feature -- Creation
   make is
      do
	 gtkobject := ext_scrolled_window_new(default_pointer, default_pointer)
      end -- make

   make_with_adjustment(hadjust, vadjust : GTK_ADJUSTMENT) is
      -- Creation and initialization
      require
	 hadjust /= Void
	 vadjust /= Void
      do
	 gtkobject := ext_scrolled_window_new(hadjust.to_external, 
					      vadjust.to_external)
      end -- make_with_adjustment

feature {ANY} -- Queries

   get_hadjustment : GTK_ADJUSTMENT is
      do
	 !!Result.create(ext_scrolled_window_get_hadjustment(gtkobject))
      end -- hadjustment

   get_vadjustment : GTK_ADJUSTMENT is
      do
	 !!Result.create(ext_scrolled_window_get_vadjustment(gtkobject))
      end -- vadjustment

feature {ANY} -- Commands
   set_policy( hscrollbar_policy, vscrollbar_policy : GTK_POLICY_TYPE ) is
      do
	 ext_set_policy(gtkobject, hscrollbar_policy.value, 
			vscrollbar_policy.value)
      end -- set_policy

   add_with_viewport ( child :GTK_WIDGET ) is
      do
	 ext_scrolled_window_add_with_viewport ( gtkobject, child.to_external) 
      end

   set_hadjustment ( hadjustment : GTK_ADJUSTMENT ) is
      do
	 ext_scrolled_window_set_hadjustment(gtkobject, 
					     hadjustment.to_external) 
      end

   set_vadjustment ( vadjustment : GTK_ADJUSTMENT ) is
      do
	 ext_scrolled_window_set_vadjustment(gtkobject, 
					     vadjustment.to_external) 
      end

   set_placement( window_placement : GTK_CORNER_TYPE ) is
      do
	 ext_scrolled_window_set_placement ( gtkobject, 
					     window_placement.value ) 
      end

feature {NONE} -- Private

   ext_scrolled_window_new(horiz, vert : POINTER) : POINTER is
      external "C"
      alias "gtk_scrolled_window_new"
      end -- ext_scrolled_window_new

   ext_set_policy(c_object : POINTER ; horiz, vert : INTEGER) is
      external "C"
      alias "gtk_scrolled_window_set_policy"
      end -- ext_set_policy

   ext_scrolled_window_get_hadjustment ( scrolled_window : POINTER ) : POINTER is
      external "C"
      alias "gtk_scrolled_window_get_hadjustment"
      end

   ext_scrolled_window_get_vadjustment ( scrolled_window : POINTER ) : POINTER is
      external "C"
      alias "gtk_scrolled_window_get_vadjustment"
      end
   
   ext_scrolled_window_add_with_viewport ( scrolled_window, 
					   child : POINTER ) is
      external "C"
      alias "gtk_scrolled_window_add_with_viewport"
      end

   ext_scrolled_window_set_hadjustment ( scrolled_window, 
					 adjustment : POINTER ) is
      external "C"
      alias "gtk_scrolled_window_set_hadjustment"
      end

   ext_scrolled_window_set_vadjustment ( scrolled_window, 
					 adjustment : POINTER ) is
      external "C"
      alias "gtk_scrolled_window_set_vadjustment"
      end

   ext_scrolled_window_set_placement ( scrolled_window : POINTER; 
				       window_placement : INTEGER ) is
      external "C"
      alias "gtk_scrolled_window_set_placement"
      end

invariant
end -- GTK_SCROLLED_WINDOW

