indexing
   description: "gtk spinbutton"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen"
   id: "$Id: gtk_spinbutton.e,v 1.8 1999/01/18 19:54:59 pcj Exp $"

class GTK_SPINBUTTON
inherit 
   GTK_ENTRY
creation
   make_with_adjustment, 
   create
feature -- Creation
   make_with_adjustment (adjustment : GTK_ADJUSTMENT; 
			 climb_rate : REAL; 
			 digits : INTEGER) is
      do
	 gtkobject := ext_spin_button_new (adjustment.to_external, 
					   climb_rate, 
					   digits)
      end -- make

feature {ANY} -- Queries

   get_adjustment : GTK_ADJUSTMENT is
      do
	 !!Result.create(ext_get_adjustment(gtkobject))
      end

   get_value_as_float : REAL is
      do
	 Result := ext_get_value_as_float(gtkobject)
      end

   get_value_as_int : INTEGER is
      do
	 Result := ext_get_value_as_int(gtkobject)
      end

feature {ANY} -- Commands

   configure ( adjustment : GTK_ADJUSTMENT ; 
	       climb_rate : REAL ; 
	       digits : INTEGER ) is
      do
	 ext_configure ( gtkobject, adjustment.to_external, 
			 climb_rate, digits ) 
      end

   set_adjustment(adjustment : GTK_ADJUSTMENT) is
      do
	 ext_set_adjustment(gtkobject, adjustment.to_external)
      end

   set_digits(digits : INTEGER) is
      do
	 ext_set_digits(gtkobject, digits)
      end

   set_value(value : INTEGER) is
      do
	 ext_set_value(gtkobject, value)
      end
   
   set_update_policy(policy : GTK_SPIN_BUTTON_UPDATE_POLICY) is 
      do
	 ext_set_update_policy(gtkobject, policy.value)
      end

   set_numeric(numeric : BOOLEAN) is
      do
	 ext_set_numeric(gtkobject, numeric)
      end

   spin(direction : GTK_ARROW_TYPE; step : REAL) is
      do
	 ext_spin(gtkobject, direction.value, step)
      end
   
   set_wrap(wrap : INTEGER) is
      do
	 ext_set_wrap(gtkobject, wrap)
      end

   set_shadow_type ( shadow_type : GTK_SHADOW_TYPE ) is
      do
	 ext_set_shadow_type ( gtkobject, shadow_type.value ) 
      end

   set_snap_to_ticks ( snap_to_ticks : BOOLEAN ) is
      do
	 ext_set_snap_to_ticks ( gtkobject, snap_to_ticks ) 
      end

feature {NONE} -- Private

   ext_spin_button_new(c_object: POINTER; 
		       rate : REAL; digits : INTEGER) : POINTER is
      external "C"
      alias "gtk_spin_button_new"
      end

   ext_get_adjustment(c_object : POINTER ) : POINTER is
      external "C"
      alias "gtk_spin_button_get_adjustment"
      end

   ext_get_value_as_int(c_object : POINTER) : INTEGER is
      external "C"
      alias "gtk_spin_button_get_value_as_int"
      end

   ext_get_value_as_float(c_object : POINTER) : REAL is
      external "C"
      alias "gtk_spin_button_get_value_as_float"
      end

   ext_set_adjustment(c_object : POINTER; adjustment : POINTER) is
      external "C"
      alias "gtk_spin_button_set_adjustment"
      end

   ext_set_digits(c_object : POINTER; digits : INTEGER) is
      external "C"
      alias "gtk_spin_button_set_digits"
      end

   ext_set_value(c_object : POINTER; value : REAL) is
      external "C"
      alias "gtk_spin_button_set_value"
      end

   ext_set_update_policy(c_object : POINTER ; value : INTEGER) is
      external "C"
      alias "gtk_spin_button_set_update_policy"
      end

   ext_set_numeric(c_object : POINTER ; value : BOOLEAN) is
      external "C"
      alias "gtk_spin_button_set_numeric"
      end

   ext_spin(c_object : POINTER; direction : INTEGER; step : REAL) is
      external "C"
      alias "gtk_spin_button_spin"
      end

   ext_set_wrap(c_object : POINTER; wrap : INTEGER) is
      external "C"
      alias "gtk_spin_button_set_wrap"
      end
   
   ext_set_shadow_type ( spinbutton : POINTER ; shadow_type : INTEGER ) is
      external "C"
      alias "gtk_spin_button_set_shadow_type"
      end

   ext_set_snap_to_ticks ( spinbutton : POINTER ; snap_to_ticks : BOOLEAN ) is
      external "C"
      alias "gtk_spin_button_set_snap_to_ticks"
      end

   ext_configure ( spinbutton, adjustment : POINTER ; climb_rate : REAL ; 
		   digits : INTEGER ) is
      external "C"
      alias "gtk_spin_button_configure"
      end

invariant
end
