indexing
   description: "gtk statusbar"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen"
   id: "$Id: gtk_statusbar.e,v 1.5 1999/01/18 19:54:59 pcj Exp $"

class GTK_STATUSBAR
inherit 
   GTK_HBOX
   rename remove as remove_hbox end
creation
   make_statusbar,
   create
feature -- Creation
   make_statusbar is
      do
	 gtkobject := ext_statusbar_new
      end -- make

   get_context_id ( context_description : STRING ) : INTEGER is
      do
         Result := ext_statusbar_get_context_id ( gtkobject, 
						  context_description.to_external )
      end

   pop ( context_id : INTEGER ) is
      do
         ext_statusbar_pop ( gtkobject, context_id )
      end

   push ( context_id : INTEGER ; text : STRING ) : INTEGER is
      do
         Result := ext_statusbar_push ( gtkobject, context_id, 
					text.to_external )
      end

   remove ( context_id, message_id : INTEGER ) is
      do
         ext_statusbar_remove ( gtkobject, context_id, message_id )
      end

feature {NONE} -- Private

   ext_statusbar_get_context_id ( statusbar, 
				  context_description : POINTER ) : INTEGER is
      external "C"
      alias "gtk_statusbar_get_context_id"
      end

   ext_statusbar_new : POINTER is
      external "C"
      alias "gtk_statusbar_new"
      end

   ext_statusbar_pop ( statusbar : POINTER ; context_id : INTEGER ) is
      external "C"
      alias "gtk_statusbar_pop"
      end

   ext_statusbar_push ( statusbar : POINTER ; 
			context_id : INTEGER ; text : POINTER ) : INTEGER is
      external "C"
      alias "gtk_statusbar_push"
      end

   ext_statusbar_remove ( statusbar : POINTER ; 
			  context_id, message_id : INTEGER ) is
      external "C"
      alias "gtk_statusbar_remove"
      end

invariant
end 

