indexing
   description: "gtk style"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen and Francois Pennaneach"
   id: "$Id: gtk_style.e,v 1.7 1999/01/18 19:54:59 pcj Exp $"

class GTK_STYLE

inherit
   GTK_OBJECT

creation make, make_from_widget

feature -- Creation

   make is
      -- Creation and initialization
      do
	 gtkobject := ext_style_new
      end -- make

   make_from_widget(widget : GTK_WIDGET) is
      do
	 gtkobject := ext_widget_get_style(widget.to_external)
      end
   
feature {ANY} -- Queries

   fg (state : GTK_STATE_TYPE) : GDK_COLOR is
      do
	 !!Result.create(ext_style_fg(gtkobject, state.value))
      end	 

   bg (state : GTK_STATE_TYPE) : GDK_COLOR is
      do
	 !!Result.create(ext_style_bg(gtkobject, state.value))
      end	 

   light (state : GTK_STATE_TYPE) : GDK_COLOR is
      do
	 !!Result.create(ext_style_light(gtkobject, state.value))
      end	 

   dark (state : GTK_STATE_TYPE) : GDK_COLOR is
      do
	 !!Result.create(ext_style_dark(gtkobject, state.value))
      end	 

   mid (state : GTK_STATE_TYPE) : GDK_COLOR is
      do
	 !!Result.create(ext_style_mid(gtkobject, state.value))
      end	 

   text (state : GTK_STATE_TYPE) : GDK_COLOR is
      do
	 !!Result.create(ext_style_text(gtkobject, state.value))
      end	 

   base (state : GTK_STATE_TYPE) : GDK_COLOR is
      do
	 !!Result.create(ext_style_base(gtkobject, state.value))
      end	 

   black : GDK_COLOR is
      do
	 !!Result.create(ext_style_black(gtkobject))
      end

   white : GDK_COLOR is
      do
	 !!Result.create(ext_style_white(gtkobject))
      end
--

   fg_gc (state : GTK_STATE_TYPE) : GDK_GC is
      do
	 !!Result.create(ext_fg_gc(gtkobject, state.value))
      end	 

   bg_gc (state : GTK_STATE_TYPE) : GDK_GC is
      do
	 !!Result.create(ext_bg_gc(gtkobject, state.value))
      end	 

   light_gc (state : GTK_STATE_TYPE) : GDK_GC is
      do
	 !!Result.create(ext_light_gc(gtkobject, state.value))
      end	 

   dark_gc (state : GTK_STATE_TYPE) : GDK_GC is
      do
	 !!Result.create(ext_dark_gc(gtkobject, state.value))
      end	 

   mid_gc (state : GTK_STATE_TYPE) : GDK_GC is
      do
	 !!Result.create(ext_mid_gc(gtkobject, state.value))
      end	 

   text_gc (state : GTK_STATE_TYPE) : GDK_GC is
      do
	 !!Result.create(ext_text_gc(gtkobject, state.value))
      end	 

   base_gc (state : GTK_STATE_TYPE) : GDK_GC is
      do
	 !!Result.create(ext_base_gc(gtkobject, state.value))
      end	 

   black_gc : GDK_GC is
      do
	 !!Result.create(ext_black_gc(gtkobject))
      end

   white_gc : GDK_GC is
      do
	 !!Result.create(ext_white_gc(gtkobject))
      end

   -- bg_pixmap ( state : GTK_STATE_TYPE ) : GDK_PIXMAP

feature {ANY} -- Commands
feature {NONE} -- Private

   ext_widget_get_style ( c_object : POINTER ) : POINTER is
      external "C"
      alias "gtk_widget_get_style"
      end -- ext_widget_get_style

   ext_style_new : POINTER is
      external "C"
      alias "gtk_style_new"
      end -- ext_style_new

   ext_style_fg(c_object : POINTER; i : INTEGER) : POINTER is
      external "C"
      end

   ext_style_bg(c_object : POINTER; i : INTEGER) : POINTER is
      external "C"
      end

   ext_style_light(c_object : POINTER; i : INTEGER) : POINTER is
      external "C"
      end

   ext_style_dark(c_object : POINTER; i : INTEGER) : POINTER is
      external "C"
      end

   ext_style_mid(c_object : POINTER; i : INTEGER) : POINTER is
      external "C"
      end

   ext_style_text(c_object : POINTER; i : INTEGER) : POINTER is
      external "C"
      end

   ext_style_base(c_object : POINTER; i : INTEGER) : POINTER is
      external "C"
      end

   ext_style_black(c_object : POINTER) : POINTER is
      external "C"
      end

   ext_style_white(c_object : POINTER) : POINTER is
      external "C"
      end

   ext_fg_gc(c_object : POINTER; i : INTEGER) : POINTER is
      external "C"
      end

   ext_bg_gc(c_object : POINTER; i : INTEGER) : POINTER is
      external "C"
      end

   ext_light_gc(c_object : POINTER; i : INTEGER) : POINTER is
      external "C"
      end

   ext_dark_gc(c_object : POINTER; i : INTEGER) : POINTER is
      external "C"
      end

   ext_mid_gc(c_object : POINTER; i : INTEGER) : POINTER is
      external "C"
      end

   ext_text_gc(c_object : POINTER; i : INTEGER) : POINTER is
      external "C"
      end

   ext_base_gc(c_object : POINTER; i : INTEGER) : POINTER is
      external "C"
      end

   ext_black_gc(c_object : POINTER) : POINTER is
      external "C"
      end

   ext_white_gc(c_object : POINTER) : POINTER is
      external "C"
      end

invariant
end -- GTK_STYLE

