indexing
   description: "gtk table"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen and Francois Pennaneach"
   id: "$Id: gtk_table.e,v 1.8 1999/01/18 19:54:59 pcj Exp $"

class GTK_TABLE
inherit
   GTK_CONTAINER
creation
   create,
   make,
   make_table
feature -- Creation
   make, make_table(rows, columns : INTEGER; homogeneous : BOOLEAN) is
      -- Creation and initialization
      do
	 gtkobject := ext_table_new(rows, columns, homogeneous)
      end -- make

feature {ANY} -- Queries
feature {ANY} -- Commands
   attach(child : GTK_WIDGET; left, right, top, bottom : INTEGER ; 
	  xoptions, yoptions : GTK_ATTACH_OPTIONS ; 
	  xpadding, ypadding : INTEGER) is
      do
	 ext_attach(gtkobject, child.to_external, 
		    left, right, top, bottom, 
		    xoptions.value, yoptions.value, 
		    xpadding, ypadding)
      end -- attach

   attach_defaults(child : GTK_WIDGET; left, right, top, bottom : INTEGER) is
      do
	 ext_attach_defaults(gtkobject, child.to_external, 
			     left, right, top, bottom)
      end -- attach_defaults

   -- This method has no GTK counterpart.  Use it when you need the 
   -- child to continue to work properly afterwards. 
   detach ( child : GTK_WIDGET ) is
      do
	 child.ref
	 remove(child)
      end

   set_col_spacing(column, spacing : INTEGER) is
      do
	 ext_set_col_spacing(gtkobject, column, spacing)
      end -- set_col_spacing

   set_col_spacings(spacing : INTEGER) is
      do
	 ext_set_col_spacings(gtkobject, spacing)
      end -- set_col_spacings

   set_row_spacing(row, spacing : INTEGER) is
      do
	 ext_set_row_spacing(gtkobject, row, spacing)
      end -- set_row_spacing

   set_row_spacings(spacing : INTEGER) is
      do
	 ext_set_row_spacings(gtkobject, spacing)
      end -- set_row_spacings

   set_homogeneous(homogeneous : BOOLEAN) is
      do
	 ext_set_homogeneous ( gtkobject, homogeneous ) 
      end

feature {NONE} -- Private
   ext_table_new(rows, columns : INTEGER; homogeneous : BOOLEAN) : POINTER is
      external "C"
      alias "gtk_table_new"
      end -- ext_table_new

   ext_attach(c_object, child : POINTER; 
	      left, right, top, bottom, 
	      xoptions, yoptions, xpadding, ypadding : INTEGER) is
      external "C"
      alias "gtk_table_attach"
      end -- ext_attach

   ext_attach_defaults(c_object, child : POINTER; 
		       left, right, top, bottom : INTEGER) is
      external "C"
      alias "gtk_table_attach_defaults"
      end -- ext_attach

   ext_set_col_spacing(c_object : POINTER; column, spacing : INTEGER) is
      external "C"
      alias "gtk_table_set_col_spacing"
      end -- ext_set_col_spacing

   ext_set_col_spacings(c_object : POINTER; spacing : INTEGER) is
      external "C"
      alias "gtk_table_set_col_spacings"
      end -- ext_set_col_spacing

   ext_set_row_spacing(c_object : POINTER; row, spacing : INTEGER) is
      external "C"
      alias "gtk_table_set_row_spacing"
      end -- ext_set_row_spacing

   ext_set_row_spacings(c_object : POINTER; spacing : INTEGER) is
      external "C"
      alias "gtk_table_set_row_spacings"
      end -- ext_set_row_spacing

   ext_set_homogeneous(table : POINTER ; homogeneous : BOOLEAN) is
      external "C"
      alias "gtk_table_set_homogeneous"
      end
   
invariant
end -- GTK_TABLE

