indexing
   description: "gtk target entry array"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen"
   id: "$Id: gtk_target_entry_array.e,v 1.4 1999/01/18 19:54:59 pcj Exp $"

-- Glue from Eiffel collections to C pointer arrays

-- You may be asking yourself why I have to do this. Well, it's 
-- because STRING derives from no base class promising a to_external 
-- method. 

class GTK_TARGET_ENTRY_ARRAY
creation

   from_collection 

feature -- Creation

   from_collection ( collection : COLLECTION[GTK_TARGET_ENTRY] ) is
      local
	 i, j : INTEGER
      do
	 !!res.make(0, collection.count+1)
	 from 
	    i := collection.lower 
	    j := 0
	 until i > collection.upper
	 loop
	    if collection.item(i) = Void then
	       res.put(default_pointer, j)
	    else
	       res.put(collection.item(i).to_external, j)
	    end
	    i := i+1
	    j := j+1
	 end
	 -- NULL terminate. 
	 res.put(default_pointer, j)
      end

feature {ANY} -- Queries

   to_external : POINTER is
      do
	 Result := res.to_external
      end

feature {NONE} 

   res : ARRAY[POINTER]

end 



