indexing
   description: "gtk text"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen"
   id: "$Id: gtk_text.e,v 1.8 1999/01/18 19:54:59 pcj Exp $"

class GTK_TEXT
inherit 
   GTK_EDITABLE
      redefine set_editable end
creation
   make
feature -- Creation
   make ( hadj, vadj : GTK_ADJUSTMENT ) is 
      do
         gtkobject := ext_text_new ( hadj.to_external, vadj.to_external )
      end

feature {ANY}

   backward_delete ( nchars : INTEGER ) : INTEGER is
      do
         Result := ext_text_backward_delete ( gtkobject, nchars )
      end

   forward_delete ( nchars : INTEGER ) : INTEGER is
      do
         Result := ext_text_forward_delete ( gtkobject, nchars )
      end

   freeze  is
      do
         ext_text_freeze ( gtkobject )
      end

   get_length  : INTEGER is
      do
         Result := ext_text_get_length ( gtkobject )
      end

   get_point  : INTEGER is
      do
         Result := ext_text_get_point ( gtkobject )
      end

   insert ( font : GDK_FONT ; fore, back : GDK_COLOR ; 
	    chars : STRING ; length : INTEGER ) is
      do
         ext_text_insert ( gtkobject, font.to_external, fore.to_external, 
			   back.to_external, chars.to_external, length )
      end

   set_adjustments ( hadj, vadj : GTK_ADJUSTMENT ) is
      do
         ext_text_set_adjustments ( gtkobject, hadj.to_external, 
				    vadj.to_external )
      end

   set_editable ( editable : BOOLEAN ) is
      do
         ext_text_set_editable ( gtkobject, editable )
      end

   set_point ( index : INTEGER ) is
      do
         ext_text_set_point ( gtkobject, index )
      end

   set_word_wrap ( word_wrap : INTEGER ) is
      do
	 ext_text_set_word_wrap ( gtkobject, word_wrap ) 
      end

   set_line_wrap ( line_wrap : INTEGER ) is
      do
	 ext_text_set_line_wrap ( gtkobject, line_wrap ) 
      end

   thaw  is
      do
         ext_text_thaw ( gtkobject )
      end

feature {NONE} -- Private

   ext_text_backward_delete ( text : POINTER ; nchars : INTEGER ) : INTEGER is
      external "C"
      alias "gtk_text_backward_delete"
      end

   ext_text_forward_delete ( text : POINTER ; nchars : INTEGER ) : INTEGER is
      external "C"
      alias "gtk_text_forward_delete"
      end

   ext_text_freeze ( text : POINTER ) is
      external "C"
      alias "gtk_text_freeze"
      end

   ext_text_get_length ( text : POINTER ) : INTEGER is
      external "C"
      alias "gtk_text_get_length"
      end

   ext_text_get_point ( text : POINTER ) : INTEGER is
      external "C"
      alias "gtk_text_get_point"
      end

   ext_text_insert ( text, font, fore, back, chars : POINTER ; 
		     length : INTEGER ) is
      external "C"
      alias "gtk_text_insert"
      end

   ext_text_new ( hadj, vadj : POINTER ) : POINTER is
      external "C"
      alias "gtk_text_new"
      end

   ext_text_set_adjustments ( text, hadj, vadj : POINTER ) is
      external "C"
      alias "gtk_text_set_adjustments"
      end

   ext_text_set_editable ( text : POINTER ; editable : BOOLEAN ) is
      external "C"
      alias "gtk_text_set_editable"
      end

   ext_text_set_point ( text : POINTER ; index : INTEGER ) is
      external "C"
      alias "gtk_text_set_point"
      end

   ext_text_set_word_wrap ( text : POINTER ; word_wrap : INTEGER ) is
      external "C"
      alias "gtk_text_set_word_wrap"
      end

   ext_text_thaw ( text : POINTER ) is
      external "C"
      alias "gtk_text_thaw"
      end

   ext_text_set_line_wrap ( text : POINTER ; line_wrap : INTEGER ) is
      external "C"
      alias "gtk_text_set_line_wrap"
      end

invariant
end 

