indexing
   description: "gtk toggle button"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen and Francois Pennaneach"
   id: "$Id: gtk_toggle_button.e,v 1.5 1999/01/18 19:54:59 pcj Exp $"

class GTK_TOGGLE_BUTTON
inherit
   GTK_BUTTON
      redefine
	 make,
	 make_with_label
      end;
creation
   make,
   make_with_label,
   create
feature -- Creation
   make is
      -- Creation and initialization
      do
	 gtkobject := ext_toggle_button_new
      end

   make_with_label(label : STRING) is
      do
	 gtkobject := ext_toggle_button_new_with_label(label.to_external)
      end

   set_mode(draw_indicator : INTEGER) is
      do
	 ext_set_mode(gtkobject, draw_indicator)
      end

   set_active(is_active : BOOLEAN) is
      do
	 ext_set_active(gtkobject, is_active)
      end

   toggled is
      do
	 ext_toggled(gtkobject)
      end

   active : BOOLEAN is 
      do
	 Result := ext_active(gtkobject)
      end

feature {ANY} -- Queries
feature {ANY} -- Commands
feature {NONE} -- Private
   ext_toggle_button_new : POINTER is
      external "C"
      alias "gtk_toggle_button_new"
      end

   ext_toggle_button_new_with_label(s : POINTER) : POINTER is
      external "C"
      alias "gtk_toggle_button_new_with_label"
      end

   ext_set_mode(this : POINTER; draw_indicator : INTEGER) is
      external "C"
      alias "gtk_toggle_button_set_mode"
      end

   ext_set_active(this : POINTER; is_active : BOOLEAN) is
      external "C"
      alias "gtk_toggle_button_set_active"
      end

   ext_toggled(this : POINTER) is
      external "C"
      alias "gtk_toggle_button_toggled"
      end

   ext_active(this : POINTER) : BOOLEAN is
      external "C"
      alias "ext_toggle_button_active"
      end

invariant
end -- GTK_TOGGLE_BUTTON

