indexing
   description: "gtk toolbar"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen"
   id: "$Id: gtk_toolbar.e,v 1.9 1999/01/18 19:54:59 pcj Exp $"

class GTK_TOOLBAR
inherit 
   GTK_CONTAINER
creation
   make, 
   create

feature -- Creation

   make ( orientation: GTK_ORIENTATION ; style_ : GTK_TOOLBAR_STYLE ) is
      do
         gtkobject := ext_toolbar_new ( orientation.value, style_.value )
      end

feature {ANY} 
   
   append_item ( text, tooltip_text, tooltip_private_text : STRING ; 
		 icon : GTK_WIDGET ; 
		 callback : GTK_COMMAND ; 
		 user_data : ANY ) : GTK_WIDGET is
      do
	 !!Result.create(ext_toolbar_append_item ( gtkobject, 
						   text.to_external,
						   tooltip_text.to_external, 
						   tooltip_private_text.to_external, 
						   icon.to_external, 
						   toolbar_callback, 
						   wrap_data(callback, 
							     user_data) ) )
	 -- These signal_connects are required until somebody 
	 -- accepts my "callback or data not null acceptable" patch
	 Result.signal_connect("clicked", callback, user_data)
      end

   prepend_item ( text, tooltip_text, tooltip_private_text : STRING ; 
		  icon : GTK_WIDGET ; 
		  callback : GTK_COMMAND ; 
		  user_data : ANY ) : GTK_WIDGET is
      do
	 !!Result.create(ext_toolbar_prepend_item ( gtkobject, 
						    text.to_external,
						    tooltip_text.to_external, 
						    tooltip_private_text.to_external, 
						    icon.to_external, 
						    toolbar_callback, 
						    wrap_data(callback, 
							      user_data) ) )
	 Result.signal_connect("clicked", callback, user_data)
      end

   insert_item ( text, tooltip_text, tooltip_private_text : STRING ; 
		 icon : GTK_WIDGET ; 
		 callback : GTK_COMMAND ; 
		 user_data : ANY ; 
		 position : INTEGER ) : GTK_WIDGET is
      do
	 !!Result.create(ext_toolbar_insert_item ( gtkobject, 
						   text.to_external,
						   tooltip_text.to_external, 
						   tooltip_private_text.to_external, 
						   icon.to_external, 
						   toolbar_callback, 
						   wrap_data(callback, 
							     user_data),
						   position ) )
	 Result.signal_connect("clicked", callback, user_data)
      end

   append_element ( type : GTK_TOOLBAR_CHILD_TYPE ; 
		    widget : GTK_WIDGET ; 
		    text, tooltip_text, tooltip_private_text : STRING ; 
		    icon : GTK_WIDGET ; 
		    callback : GTK_COMMAND ; 
		    user_data : ANY ) : GTK_WIDGET is
      do
	 !!Result.create(ext_toolbar_append_element ( gtkobject, 
						      type.value, 
						      widget.to_external, 
						      text.to_external,
						      tooltip_text.to_external,
						      tooltip_private_text.to_external, 
						      icon.to_external, 
						      toolbar_callback, 
						      wrap_data(callback, 
								user_data) ) )
	 Result.signal_connect("clicked", callback, user_data)
      end

   prepend_element ( type : GTK_TOOLBAR_CHILD_TYPE ; 
		     widget : GTK_WIDGET ; 
		     text, tooltip_text, tooltip_private_text : STRING ; 
		     icon : GTK_WIDGET ; 
		     callback : GTK_COMMAND ; 
		     user_data : ANY ) : GTK_WIDGET is
      do
	 !!Result.create(ext_toolbar_prepend_element ( gtkobject, 
						      type.value, 
						      widget.to_external, 
						      text.to_external,
						      tooltip_text.to_external,
						      tooltip_private_text.to_external, 
						      icon.to_external, 
						      toolbar_callback, 
						      wrap_data(callback,
								user_data) ) )
	 Result.signal_connect("clicked", callback, user_data)
      end

   insert_element ( type : GTK_TOOLBAR_CHILD_TYPE ; 
		    widget : GTK_WIDGET ; 
		    text, tooltip_text, tooltip_private_text : STRING ; 
		    icon : GTK_WIDGET ; 
		    callback : GTK_COMMAND ; 
		    user_data : ANY ; 
		    position : INTEGER ) : GTK_WIDGET is
      do
	 !!Result.create(ext_toolbar_insert_element ( gtkobject, 
						      type.value, 
						      widget.to_external, 
						      text.to_external,
						      tooltip_text.to_external,
						      tooltip_private_text.to_external, 
						      icon.to_external, 
						      toolbar_callback, 
						      wrap_data(callback,
								user_data), 
						      position ) )
	 Result.signal_connect("clicked", callback, user_data)
      end

   append_space  is
      do
         ext_toolbar_append_space ( gtkobject )
      end

   append_widget ( widget : GTK_WIDGET ; 
		   tooltip_text, tooltip_private_text : STRING ) is
      do
         ext_toolbar_append_widget ( gtkobject, widget.to_external, 
				     tooltip_text.to_external, 
				     tooltip_private_text.to_external )
      end

   insert_space ( position : INTEGER ) is
      do
         ext_toolbar_insert_space ( gtkobject, position )
      end

   insert_widget ( widget : GTK_WIDGET ; 
		   tooltip_text, tooltip_private_text : STRING ; 
		   position : INTEGER ) is
      do
         ext_toolbar_insert_widget ( gtkobject, widget.to_external, 
				     tooltip_text.to_external, 
				     tooltip_private_text.to_external, 
				     position )
      end

   prepend_space is
      do
         ext_toolbar_prepend_space ( gtkobject )
      end

   prepend_widget ( widget : GTK_WIDGET ; 
		    tooltip_text, tooltip_private_text : STRING ) is
      do
         ext_toolbar_prepend_widget ( gtkobject, widget.to_external, 
				      tooltip_text.to_external, 
				      tooltip_private_text.to_external )
      end

   set_orientation ( orientation : GTK_ORIENTATION ) is
      do
         ext_toolbar_set_orientation ( gtkobject, orientation.value )
      end

   set_space_size ( space_size : INTEGER ) is
      do
         ext_toolbar_set_space_size ( gtkobject, space_size )
      end

   set_style ( style_ : GTK_TOOLBAR_STYLE ) is
      do
         ext_toolbar_set_style ( gtkobject, style_.value )
      end

   set_tooltips ( enable : BOOLEAN ) is
      do
         ext_toolbar_set_tooltips ( gtkobject, enable )
      end

   set_button_relief ( relief : GTK_RELIEF_STYLE ) is
      do
	 ext_toolbar_set_button_relief ( gtkobject, relief.value ) 
      end

   get_button_relief : GTK_RELIEF_STYLE is
      do
	 !!Result.make(ext_toolbar_get_button_relief ( gtkobject ) ) 
      end

   set_space_style ( space_style : GTK_TOOLBAR_SPACE_STYLE ) is
      do
	 ext_set_space_style ( gtkobject, space_style.value )
      end

feature {ANY} -- Commands
feature {NONE} -- Private

   ext_toolbar_append_item ( toolbar, text, tooltip_text, 
			     tooltip_private_text, icon, callback,  
			     user_data : POINTER ) : POINTER is
      external "C"
      alias "gtk_toolbar_append_item"
      end

   ext_toolbar_prepend_item ( toolbar, text, tooltip_text, 
			     tooltip_private_text, icon, callback, 
			     user_data : POINTER ) : POINTER is
      external "C"
      alias "gtk_toolbar_prepend_item"
      end

   ext_toolbar_insert_item ( toolbar, text, tooltip_text, 
			     tooltip_private_text, icon, callback, 
			     user_data : POINTER; 
			     position : INTEGER ) : POINTER is
      external "C"
      alias "gtk_toolbar_insert_item"
      end

   ext_toolbar_append_element ( toolbar : POINTER ; type : INTEGER ; 
				widget, text, tooltip_text, 
				tooltip_private_text, icon, callback, 
				user_data : POINTER ) : POINTER is
      external "C"
      alias "gtk_toolbar_append_element"
      end   

   ext_toolbar_prepend_element ( toolbar : POINTER ; type : INTEGER ; 
				widget, text, tooltip_text, 
				tooltip_private_text, icon, callback, 
				user_data : POINTER ) : POINTER is
      external "C"
      alias "gtk_toolbar_prepend_element"
      end   

   ext_toolbar_insert_element ( toolbar : POINTER ; type : INTEGER ; 
				widget, text, tooltip_text, 
				tooltip_private_text, icon, callback, 
				user_data : POINTER ; 
				position : INTEGER ) : POINTER is
      external "C"
      alias "gtk_toolbar_insert_element"
      end   

   ext_toolbar_append_space ( toolbar : POINTER ) is
      external "C"
      alias "gtk_toolbar_append_space"
      end

   ext_toolbar_append_widget ( toolbar, widget, tooltip_text,
			       tooltip_private_text : POINTER ) is
      external "C"
      alias "gtk_toolbar_append_widget"
      end

   ext_toolbar_insert_widget ( toolbar, widget, tooltip_text,
			       tooltip_private_text : POINTER ; 
			       position : INTEGER ) is
      external "C"
      alias "gtk_toolbar_insert_widget"
      end

   ext_toolbar_insert_space ( toolbar : POINTER ; position : INTEGER ) is
      external "C"
      alias "gtk_toolbar_insert_space"
      end

   ext_toolbar_new ( orientation, style_ : INTEGER ) : POINTER is
      external "C"
      alias "gtk_toolbar_new"
      end

   ext_toolbar_prepend_space ( toolbar : POINTER ) is
      external "C"
      alias "gtk_toolbar_prepend_space"
      end

   ext_toolbar_prepend_widget ( toolbar, widget, tooltip_text,
				tooltip_private_text : POINTER ) is
      external "C"
      alias "gtk_toolbar_prepend_widget"
      end

   ext_toolbar_set_orientation ( toolbar : POINTER ;
				 orientation : INTEGER ) is
      external "C"
      alias "gtk_toolbar_set_orientation"
      end

   ext_toolbar_set_space_size ( toolbar : POINTER ; space_size : INTEGER ) is
      external "C"
      alias "gtk_toolbar_set_space_size"
      end

   ext_toolbar_set_tooltips ( toolbar : POINTER ; enable : BOOLEAN ) is
      external "C"
      alias "gtk_toolbar_set_tooltips"
      end

   ext_toolbar_set_style ( toolbar : POINTER ; style_ : INTEGER ) is
      external "C"
      alias "gtk_toolbar_set_style"
      end

   ext_toolbar_get_button_relief ( toolbar : POINTER ) : INTEGER is
      external "C"
      alias "gtk_toolbar_get_button_relief"
      end

   ext_toolbar_set_button_relief ( toolbar : POINTER ; relief : INTEGER ) is
      external "C"
      alias " gtk_toolbar_set_button_relief"
      end

   toolbar_callback : POINTER is
      do
	 Result := default_pointer
      end

   wrap_data ( command : GTK_COMMAND ; user_data : ANY ) : POINTER is
      do 
	 Result := ext_create_signal_data ( command, user_data ) 
      end

   ext_create_signal_data ( command : GTK_COMMAND ; 
			    user_data : ANY ) : POINTER is
      external "C"
      end

   ext_set_space_style ( toolbar : POINTER ; space_style : INTEGER ) is
      external "C"
      alias "gtk_toolbar_set_space_style"
      end

end
