indexing
   description: "gtk tooltips"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen and Francois Pennaneach"
   id: "$Id: gtk_tooltips.e,v 1.10 1999/01/18 19:54:59 pcj Exp $"

class GTK_TOOLTIPS
inherit
   GTK_WIDGET
creation make, create
feature -- Creation
   make is
	 -- Creation and initialization
      do
	 gtkobject := ext_new
      end -- make
feature {ANY} -- Queries
feature {ANY} -- Commands
   enable is
      do
	 ext_enable(gtkobject)
      end 

   disable is
      do
	 ext_disable(gtkobject)
      end 

   set_delay(delay : INTEGER) is
      do
	 ext_set_delay(gtkobject, delay)
      end 

   set_tip, set_tips(widget : GTK_WIDGET; tips : STRING) is
	 -- set a new tips for this tooltips
      do
	 ext_set_tips(gtkobject, widget.to_external, tips.to_external)
      end 

   set_colors(background : GDK_COLOR; foreground : GDK_COLOR) is
      do
	 ext_set_colors(gtkobject,
			background.to_external, foreground.to_external)
      end 
   
   force_window is
      do
	 ext_tooltips_force_window ( gtkobject ) 
      end

feature {NONE} -- Private
   ext_new : POINTER is
      external "C_WithoutCurrent"
      alias "gtk_tooltips_new"
      end 
   
   ext_enable(c_object : POINTER) is
      external "C_WithoutCurrent"
      alias "gtk_tooltips_enable"
      end 

   ext_disable(c_object : POINTER) is
      external "C_WithoutCurrent"
      alias "gtk_tooltips_disable"
      end 

   ext_set_delay(c_object : POINTER; delay : INTEGER) is
      external "C_WithoutCurrent"
      alias "gtk_tooltips_set_delay"
      end 

   ext_set_tips(c_object : POINTER; widget : POINTER; tips : POINTER) is
      external "C_WithoutCurrent"
      alias "gtk_tooltips_set_tip"
      end 

   ext_set_colors(c_object : POINTER;
		  background : POINTER; foreground : POINTER) is
      external "C_WithoutCurrent"
      alias "gtk_tooltips_set_colors"
      end 

   ext_tooltips_force_window ( tooltips : POINTER ) is
      external "C"
      alias "gtk_tooltips_force_window"
      end

invariant
end -- GTK_TOOLTIPS

