indexing
   description: "gtk tree"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen and Francois Pennaneach"
   id: "$Id: gtk_tree.e,v 1.6 1999/01/18 19:55:00 pcj Exp $"

class GTK_TREE
inherit
   GTK_CONTAINER
creation
   make,
   create
feature -- Creation
   make is
      -- Creation and initialization
      do
         gtkobject := ext_tree_new
      end

   append ( child : GTK_WIDGET ) is
      do
         ext_tree_append ( gtkobject, child.to_external )
      end

   child_position ( child : GTK_WIDGET ) : INTEGER is
      do
         Result := ext_tree_child_position ( gtkobject, child.to_external )
      end

   clear_items ( start, end_ : INTEGER ) is
      do
         ext_tree_clear_items ( gtkobject, start, end_ )
      end

   insert ( child : GTK_WIDGET ; position : INTEGER ) is
      do
         ext_tree_insert ( gtkobject, child.to_external, position )
      end

   prepend ( child : GTK_WIDGET ) is
      do
         ext_tree_prepend ( gtkobject, child.to_external )
      end

   remove_items ( items : COLLECTION[GTK_WIDGET] ) is
      local 
	 items_glist : GTK_WIDGET_GLIST
      do
	 !!items_glist.from_collection(items)
	 ext_tree_remove_items(gtkobject, items_glist.to_external)
      end

   select_child ( child : GTK_WIDGET ) is
      do
         ext_tree_select_child ( gtkobject, child.to_external )
      end

   select_item ( item : INTEGER ) is
      do
         ext_tree_select_item ( gtkobject, item )
      end

   set_selection_mode ( mode : GTK_SELECTION_MODE ) is
      do
         ext_tree_set_selection_mode ( gtkobject, mode.value )
      end

   set_view_lines ( flag : BOOLEAN ) is
      do
         ext_tree_set_view_lines ( gtkobject, flag )
      end

   set_view_mode ( mode : GTK_TREE_VIEW_MODE ) is
      do
         ext_tree_set_view_mode ( gtkobject, mode.value )
      end

   unselect_child ( child : GTK_WIDGET ) is
      do
         ext_tree_unselect_child ( gtkobject, child.to_external )
      end

   unselect_item ( item : INTEGER ) is
      do
         ext_tree_unselect_item ( gtkobject, item )
      end

feature {ANY} -- Queries
feature {ANY} -- Commands
feature {NONE} -- Private

   ext_tree_append ( tree, child : POINTER ) is
      external "C"
      alias "gtk_tree_append"
      end

   ext_tree_child_position ( tree, child : POINTER ) : INTEGER is
      external "C"
      alias "gtk_tree_child_position"
      end

   ext_tree_clear_items ( tree : POINTER ; start, end_ : INTEGER ) is
      external "C"
      alias "gtk_tree_clear_items"
      end

   ext_tree_insert ( tree, child : POINTER ; position : INTEGER ) is
      external "C"
      alias "gtk_tree_insert"
      end

   ext_tree_new  : POINTER is
      external "C"
      alias "gtk_tree_new"
      end

   ext_tree_prepend ( tree, child : POINTER ) is
      external "C"
      alias "gtk_tree_prepend"
      end

   ext_tree_remove_items ( tree, items : POINTER ) is
      external "C"
      alias "gtk_tree_remove_items"
      end

   ext_tree_select_child ( tree, child : POINTER ) is
      external "C"
      alias "gtk_tree_select_child"
      end

   ext_tree_select_item ( tree : POINTER ; item : INTEGER ) is
      external "C"
      alias "gtk_tree_select_item"
      end

   ext_tree_set_selection_mode ( tree : POINTER ;  mode : INTEGER ) is
      external "C"
      alias "gtk_tree_set_selection_mode"
      end

   ext_tree_set_view_lines ( tree : POINTER ; flag : BOOLEAN ) is
      external "C"
      alias "gtk_tree_set_view_lines"
      end

   ext_tree_set_view_mode ( tree : POINTER ; mode : INTEGER ) is
      external "C"
      alias "gtk_tree_set_view_mode"
      end

   ext_tree_unselect_child ( tree, child : POINTER ) is
      external "C"
      alias "gtk_tree_unselect_child"
      end

   ext_tree_unselect_item ( tree : POINTER ; item : INTEGER ) is
      external "C"
      alias "gtk_tree_unselect_item"
      end

invariant
end -- GTK_TREE

