indexing
   description: "gtk tree item"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen and Francois Pennaneach"
   id: "$Id: gtk_tree_item.e,v 1.5 1999/01/18 19:55:00 pcj Exp $"

class GTK_TREE_ITEM
inherit
   GTK_ITEM
creation
   make,
   make_with_label, 
   create
feature -- Creation
   make is
      -- Creation and initialization
      do
         gtkobject := ext_tree_item_new 
      end

   make_with_label ( label : STRING ) is
      do
         gtkobject := ext_tree_item_new_with_label ( label.to_external )
      end

feature {ANY} -- Commands

   -- Select and deselect are delegated back up to GTK_ITEM 

   collapse  is
      do
         ext_tree_item_collapse ( gtkobject )
      end

   expand  is
      do
         ext_tree_item_expand ( gtkobject )
      end

   remove_subtree  is
      do
         ext_tree_item_remove_subtree ( gtkobject )
      end

   set_subtree ( subtree : GTK_WIDGET ) is
      do
         ext_tree_item_set_subtree ( gtkobject, subtree.to_external )
      end

feature {NONE} -- Private

   ext_tree_item_collapse ( tree_item : POINTER ) is
      external "C"
      alias "gtk_tree_item_collapse"
      end

   ext_tree_item_deselect ( tree_item : POINTER ) is
      external "C"
      alias "gtk_tree_item_deselect"
      end

   ext_tree_item_expand ( tree_item : POINTER ) is
      external "C"
      alias "gtk_tree_item_expand"
      end

   ext_tree_item_new : POINTER is
      external "C"
      alias "gtk_tree_item_new"
      end

   ext_tree_item_new_with_label ( label : POINTER ) : POINTER is
      external "C"
      alias "gtk_tree_item_new_with_label"
      end

   ext_tree_item_remove_subtree ( tree_item : POINTER ) is
      external "C"
      alias "gtk_tree_item_remove_subtree"
      end

   ext_tree_item_select ( tree_item : POINTER ) is
      external "C"
      alias "gtk_tree_item_select"
      end

   ext_tree_item_set_subtree ( tree_item, subtree : POINTER ) is
      external "C"
      alias "gtk_tree_item_set_subtree"
      end

invariant
end -- GTK_TREE_ITEM

