indexing
   description: "gtk viewport"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen and Francois Pennaneach"
   id: "$Id: gtk_viewport.e,v 1.7 1999/01/18 19:55:00 pcj Exp $"

class GTK_VIEWPORT
inherit
   GTK_BIN
creation
   make,
   make_with_adjustment,
   create
feature -- Creation
   make_with_adjustment ( hadjustment, vadjustment : GTK_ADJUSTMENT ) is
      -- Creation and initialization
      do
	 gtkobject := ext_viewport_new ( hadjustment.to_external, 
					 vadjustment.to_external )
      end -- make

   make is 
      do
	 gtkobject := ext_viewport_new ( default_pointer, default_pointer ) 
      end

feature {ANY} -- Queries

   get_hadjustment  : GTK_ADJUSTMENT is
      do
         !!Result.create( ext_viewport_get_hadjustment ( gtkobject ) )
      end

   get_vadjustment  : GTK_ADJUSTMENT is
      do
         !!Result.create( ext_viewport_get_vadjustment ( gtkobject ) )
      end

   set_hadjustment ( adjustment : GTK_ADJUSTMENT ) is
      do
         ext_viewport_set_hadjustment ( gtkobject, adjustment.to_external )
      end

   set_shadow_type ( type : GTK_SHADOW_TYPE ) is
      do
         ext_viewport_set_shadow_type ( gtkobject, type.value )
      end

   set_vadjustment ( adjustment : GTK_ADJUSTMENT ) is
      do
         ext_viewport_set_vadjustment ( gtkobject, adjustment.to_external )
      end

feature {NONE} -- Private

   ext_viewport_get_hadjustment ( viewport : POINTER ) : POINTER is
      external "C"
      alias "gtk_viewport_get_hadjustment"
      end

   ext_viewport_get_vadjustment ( viewport : POINTER ) : POINTER is
      external "C"
      alias "gtk_viewport_get_vadjustment"
      end

   ext_viewport_new ( hadjustment, vadjustment : POINTER ) : POINTER is
      external "C"
      alias "gtk_viewport_new"
      end

   ext_viewport_set_hadjustment ( viewport, adjustment : POINTER ) is
      external "C"
      alias "gtk_viewport_set_hadjustment"
      end

   ext_viewport_set_shadow_type ( viewport : POINTER ; type : INTEGER ) is
      external "C"
      alias "gtk_viewport_set_shadow_type"
      end

   ext_viewport_set_vadjustment ( viewport, adjustment : POINTER ) is
      external "C"
      alias "gtk_viewport_set_vadjustment"
      end

end -- GTK_VIEWPORT

