indexing
   description: "gtk window"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen and Francois Pennaneach"
   id: "$Id: gtk_window.e,v 1.9 1999/01/18 19:55:00 pcj Exp $"

class GTK_WINDOW
inherit
   GTK_BIN
creation
   make,
   make_with_type,
   create
feature -- Creation

   make is
      -- Creation and initialization
      local 
	 constants : GTK_CONSTANTS
      do
	 !!constants
	 gtkobject := ext_window_new(constants.gtk_window_toplevel.value)
      end -- make
   
   make_with_type(window_type : GTK_WINDOW_TYPE) is
      do
	 gtkobject := ext_window_new(window_type.value)
      end -- do

feature {ANY} -- Queries 
feature {ANY} -- Commands

   set_title(title : STRING) is
	 -- set a new title
      do
	 ext_window_set_title(gtkobject, title.to_external)
      end -- set_title

   set_focus(new_focus : GTK_WIDGET) is
      do
	 ext_window_set_focus(gtkobject, new_focus.to_external)
      end -- set_focus

   set_policy ( allow_shrink, allow_grow, auto_shrink : BOOLEAN ) is
      do
	 ext_window_set_policy(gtkobject,
			       allow_shrink, allow_grow, auto_shrink) 
      end

   set_default(default_widget : GTK_WIDGET) is
      do
	 ext_window_set_default(gtkobject, default_widget.to_external)
      end -- set_default

   set_position ( position : GTK_WINDOW_POSITION ) is
      do
	 ext_window_position(gtkobject, position.value)
      end

   set_transient_for ( parent : GTK_WINDOW ) is
      do
	 ext_window_set_transient_for ( gtkobject, parent.to_external )
      end

   set_default_size ( width, height : INTEGER ) is
      do
	 ext_window_set_default_size ( gtkobject, width, height ) 
      end

   set_modal ( modal : BOOLEAN ) is
      do
	 ext_window_set_modal ( gtkobject, modal ) 
      end

   add_accel_group ( accel_group : GTK_ACCEL_GROUP ) is
      do
	 ext_window_add_accel_group ( gtkobject, accel_group.to_external )
      end

   remove_accel_group ( accel_group : GTK_ACCEL_GROUP ) is
      do
	 ext_window_remove_accel_group ( gtkobject, accel_group.to_external ) 
      end

   activate_focus is
      do
	 ext_window_activate_focus ( gtkobject )
      end
   
   activate_default is
      do
	 ext_window_activate_default ( gtkobject ) 
      end

--   set_geometry_hints ( geometry_widget : GTK_WIDGET ; 
--			geometry : GDK_GEOMETRY ; 
--			geom_mask : GDK_WINDOW_HINTS ) 

feature {NONE} -- Private 
   ext_window_new(type : INTEGER) : POINTER is
      external "C"
      alias "gtk_window_new"
      end -- ext_window_new 

   ext_window_set_title(this : POINTER; new_title : POINTER) is
	 -- set a new title
      external "C"
      alias "gtk_window_set_title"
      end -- ext_window_set_title

   ext_window_set_focus(this : POINTER; new_focus : POINTER) is
      external "C"
      alias "gtk_window_set_focus"
      end -- ext_window_focus

   ext_window_set_default(this : POINTER; default_widget : POINTER) is
      external "C"
      alias "gtk_window_set_default"
      end -- ext_window_set_default

   ext_window_position ( c_object : POINTER; position : INTEGER ) is
      external "C"
      alias "gtk_window_set_position"
      end
   
   ext_window_set_policy ( c_object : POINTER ;
			   allow_shrink, allow_grow, auto_shrink : BOOLEAN) is
      external "C"
      alias "gtk_window_set_policy"
      end

   ext_window_set_transient_for ( window_, parent : POINTER ) is
      external "C"
      alias "gtk_window_set_transient_for"
      end

   ext_window_set_default_size ( window_ : POINTER ; 
				 width, height : INTEGER ) is
      external "C"
      alias "gtk_window_set_default_size" 
      end

   ext_window_set_modal ( window_ : POINTER ; modal : BOOLEAN ) is 
      external "C"
      alias "gtk_window_set_modal" 
      end
   
   ext_window_add_accel_group ( window_, accel_group : POINTER ) is
      external "C"
      alias "gtk_window_add_accel_group"
      end

   ext_window_remove_accel_group ( window_, accel_group : POINTER ) is
      external "C"
      alias "gtk_window_remove_accel_group"
      end

   ext_window_activate_focus ( window_ : POINTER ) is
      external "C"
      alias "gtk_window_activate_focus"
      end

   ext_window_activate_default ( window_ : POINTER ) is
      external "C"
      alias "gtk_window_activate_default"
      end

invariant
end -- GTK_WINDOW

