indexing
   description: "create bbox window"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen and Francois Pennaneach"
   id: "$Id: create_bbox_window.e,v 1.4 1999/01/18 19:55:08 pcj Exp $"

class CREATE_BBOX_WINDOW
creation make
feature -- Creation
   make(horizontal : BOOLEAN; title : STRING; pos, spacing, child_w, child_h : INTEGER ;
	layout : GTK_BUTTON_BOX_STYLE) is
      -- Creation and initialization
      local
	 window : GTK_WINDOW
	 box1 : GTK_BOX
	 bbox : GTK_BUTTON_BOX
	 button : GTK_BUTTON

	 bbox_widget_destroy : BBOX_WIDGET_DESTROY
      do
	 !!bbox_widget_destroy
	 !!window.make
	 window.set_title(title)
	 window.add_action("destroy", bbox_widget_destroy, window)

	 if horizontal then
	    window.set_usize(550,60)
	    window.set_uposition(150, pos)
	    !GTK_VBOX!box1.make_with_aspect(False, 0)
	 else
	    window.set_usize(150, 400)
	    window.set_uposition(pos, 200)
	    !GTK_VBOX!box1.make_with_aspect(False, 0)
	 end -- if
	 window.add(box1)
	 box1.show

	 if horizontal then
	    !GTK_HBUTTON_BOX!bbox.make
	 else
	    !GTK_VBUTTON_BOX!bbox.make
	 end -- if
	 bbox.set_layout(layout)
	 bbox.set_spacing(spacing)
	 bbox.set_child_size(child_w, child_h)
	 bbox.show
	 
	 box1.set_border_width(25)
	 box1.pack_start(bbox, True, True, 0)

	 !!button.make_with_label("OK")
	 bbox.add(button)

	 button.add_clicked_action(bbox_widget_destroy, window)
	 button.show

	 !!button.make_with_label("Cancel")
	 bbox.add(button)
	 button.show

	 !!button.make_with_label("Help")
	 bbox.add(button)
	 button.show

	 window.show
      end -- make
feature {ANY} -- Queries
feature {ANY} -- Commands
feature {NONE} -- Private
invariant
end -- CREATE_BBOX_WINDOW

