indexing
   description: "create buttons"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen and Francois Pennaneach"
   id: "$Id: create_buttons.e,v 1.5 1999/01/18 19:55:08 pcj Exp $"

class CREATE_BUTTONS
inherit
   SIMPLE_TEST
   GTK_CONSTANTS
creation make
feature -- Creation
   make is
      -- Creation and initialization
      local
	 window : GTK_WINDOW
	 box1, box2 : GTK_BOX
	 table : GTK_TABLE
	 buttons : ARRAY[GTK_BUTTON]
	 button : GTK_BUTTON
	 button_string : STRING
	 button_window : BUTTON_WINDOW
--	 drop_window : DROP_WINDOW
--	 drag_begin_window : DRAG_BEGIN_WINDOW
	 destroy_window : DESTROY_WINDOW
	 expfill : GTK_ATTACH_OPTIONS

	 i : INTEGER
	 separator : GTK_HSEPARATOR
      do
	 !!button_window
--	 !!drag_begin_window
--	 !!drop_window
	 !!destroy_window

	 !!window.make
	 window.grab_add
	 window.add_action("destroy", destroy_window, window)
	 window.set_title("buttons")
	 window.set_border_width(0)

	 !GTK_VBOX!box1.make_with_aspect(False, 0)
	 window.add(box1)
	 box1.show

	 !!table.make_table(3, 3, False)
	 table.set_row_spacings(5)
	 table.set_col_spacings(5)
	 table.set_border_width(10)
	 box1.pack_start(table, True, True, 0)
	 table.show

	 !!buttons.make(0,8)
	 !!button_string.make(0)
	 from i := 0 until i > 8
	 loop
	    button_string.copy("button ")
	    button_string.append(i.out)
	    !!button.make_with_label(button_string)
	    buttons.force(button, i)
	    i := i + 1
	 end -- loop

	 expfill := gtk_expand and gtk_fill

	 buttons.item(0).add_clicked_action(button_window, buttons.item(1))
--	 buttons.item(0).add_action("drop_enter_event", drop_window, Void)
--	 buttons.item(0).add_action("drag_begin_event", drag_begin_window, Void)
	 table.attach(buttons.item(0), 0, 1, 0, 1, expfill, expfill, 0, 0)
	 buttons.item(0).show
	 
	 buttons.item(1).add_clicked_action(button_window, buttons.item(2))
	 table.attach(buttons.item(1), 1, 2, 1, 2, expfill, expfill, 0, 0)
	 buttons.item(1).show

	 buttons.item(2).add_clicked_action(button_window, buttons.item(3))
	 table.attach(buttons.item(2), 2, 3, 2, 3, expfill, expfill, 0, 0)
	 buttons.item(2).show

	 buttons.item(3).add_clicked_action(button_window, buttons.item(4))
	 table.attach(buttons.item(3), 0, 1, 2, 3, expfill, expfill, 0, 0)
	 buttons.item(3).show

	 buttons.item(4).add_clicked_action(button_window, buttons.item(5))
	 table.attach(buttons.item(4), 2, 3, 0, 1, expfill, expfill, 0, 0)
	 buttons.item(4).show

	 buttons.item(5).add_clicked_action(button_window, buttons.item(6))
	 table.attach(buttons.item(5), 1, 2, 2, 3, expfill, expfill, 0, 0)
	 buttons.item(5).show

	 buttons.item(6).add_clicked_action(button_window, buttons.item(7))
	 table.attach(buttons.item(6), 1, 2, 0, 1, expfill, expfill, 0, 0)
	 buttons.item(6).show

	 buttons.item(7).add_clicked_action(button_window, buttons.item(8))
	 table.attach(buttons.item(7), 2, 3, 1, 2, expfill, expfill, 0, 0)
	 buttons.item(7).show

	 buttons.item(8).add_clicked_action(button_window, buttons.item(0))
	 table.attach(buttons.item(8), 0, 1, 1, 2, expfill, expfill, 0, 0)
	 buttons.item(8).show
	 
	 !!separator.make
	 box1.pack_start(separator, False, True, 0)
	 separator.show

	 !GTK_VBOX!box2.make_with_aspect(False, 10)
	 box2.set_border_width(10)
	 box1.pack_start(box2, False, True, 0)
	 box2.show

	 !!button.make_with_label("close")
	 buttons.force(button, 9)
	 buttons.item(9).add_clicked_action(destroy_window, window)
	 box2.pack_start(buttons.item(9), True, True, 0)
	 buttons.item(9).set_flags(gtk_can_default)
	 buttons.item(9).grab_default
	 buttons.item(9).show

	 if not window.visible then
	    window.show
	 else
	    window.destroy
	 end -- if
      end -- make
feature {ANY} -- Queries
feature {ANY} -- Commands
feature {NONE} -- Private
invariant
end -- CREATE_BUTTONS

