indexing
   description: "create clist"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen"
   id: "$Id: create_clist.e,v 1.6 1999/01/18 19:55:08 pcj Exp $"

class CREATE_CLIST
inherit 
   SIMPLE_TEST 
   GTK_CONSTANTS
   GTK_COMMAND
creation
   make
feature -- Creation
   make is
      local
	 coltitle : STRING
	 window : GTK_WINDOW
	 titles : ARRAY[STRING]
	 text : ARRAY[STRING]
	 box1 : GTK_BOX
	 box2 : GTK_BOX
	 button : GTK_BUTTON
	 separator : GTK_HSEPARATOR
	 destroy_window : DESTROY_WINDOW
	 create_clist_select : CREATE_CLIST_SELECT
	 create_clist_unselect : CREATE_CLIST_UNSELECT
	 scrolled_win : GTK_SCROLLED_WINDOW
	 iref : INTEGER_REF
	 i : INTEGER
      do
	 titles := << "Title 0", "Title 1", "Title 2", "Title 3", 
		      "Title 4", "Title 5", "Title 6" >>  

	 !!text.make(0, 6)

	 !!destroy_window
	 !!window.make
	 window.signal_connect("destroy", destroy_window, window)
	 window.set_border_width(0)

	 !GTK_VBOX!box1.make(False, 0)
	 window.add(box1)
	 box1.show

	 !GTK_HBOX!box2.make(False, 10)
	 box2.set_border_width(10)
	 box1.pack_start(box2, False, False, 0)
	 box2.show

	 !!clist.make_with_titles(7, titles)
	 clist.show
	 !!scrolled_win.make
	 scrolled_win.set_policy(gtk_policy_automatic, 
				 gtk_policy_automatic) 
	 scrolled_win.add(clist) 

	 !!button.make_with_label("Add 1,000 Rows")
	 button.show
	 button.signal_connect("clicked", Current, add1000)
	 box2.pack_start(button, True, True, 0)
	 
	 !!button.make_with_label("Add 10,000 Rows")
	 button.show
	 button.signal_connect("clicked", Current, add10000)
	 box2.pack_start(button, True, True, 0)

	 !!button.make_with_label("Clear List")
	 button.show
	 button.signal_connect("clicked", Current, clear)
	 box2.pack_start(button, True, True, 0)

	 !!button.make_with_label("Remove Row")
	 button.show
	 button.signal_connect("clicked", Current, remove)
	 box2.pack_start(button, True, True, 0)
	 
	 !GTK_HBOX!box2.make(False, 10)
	 box2.set_border_width(10)
	 box1.pack_start(box2, False, False, 0)
	 box2.show

	 !!button.make_with_label("Insert Row")
	 button.show
	 button.signal_connect("clicked", Current, insert) 
	 box2.pack_start(button, True, True, 0)
	 
	 !!button.make_with_label("Show Title Buttons")
	 button.show
	 button.signal_connect("clicked", Current, show)
	 box2.pack_start(button, True, True, 0)

	 !!button.make_with_label("Hide Title Buttons")
	 button.show
	 button.signal_connect("clicked", Current, hide)
	 box2.pack_start(button, True, True, 0)
	 
	 !GTK_VBOX!box2.make(False, 0)
	 box2.set_border_width(10)
	 box1.pack_start(box2, True, True, 0)
	 box2.show
	 
	 clist.set_row_height(20)
	 !!create_clist_select
	 !!create_clist_unselect
	 clist.signal_connect("select_row", create_clist_select, Current)
	 clist.signal_connect("unselect_row", create_clist_unselect, Current)
	 clist.set_column_width(0, 100)

	 from i := 0
	 until i > 6
	 loop
	    clist.set_column_width(i, 80)
	    !!coltitle.copy("Column ")
	    coltitle.append(i.out)
	    text.put(coltitle, i)
	    i := i+1
	 end
	 
	 from i := 0 
	 until i > 100
	 loop
	    clist.append(text)
	    i := i+1
	 end
	 
	 clist.set_selection_mode(gtk_selection_browse)
--	 clist.set_policy(gtk_policy_automatic, gtk_policy_automatic)
	 clist.set_column_justification(1, gtk_justify_right)
	 clist.set_column_justification(2, gtk_justify_center)

	 scrolled_win.set_border_width(5)
	 box2.pack_start(scrolled_win, True, True, 0)

	 !!separator.make
	 separator.show
	 box1.pack_start(separator, False, True, 0)

	 !GTK_VBOX!box2.make(False, 10)
	 box2.set_border_width(10)
	 box1.pack_start(box2, False, True, 0)
	 box2.show

	 !!button.make_with_label("close")
	 button.signal_connect("clicked", destroy_window, window)
	 button.set_flags(gtk_can_default)
	 button.grab_default
	 box2.pack_start(button, True, True, 0)
	 button.show

	 window.show_all
      end -- make

feature {ANY} -- Queries
feature {ANY} -- Commands
feature {NONE} -- Private

   clist : GTK_CLIST
   event : GDK_EVENT_BUTTON

   add1000, add10000, clear, remove, insert, show, hide : INTEGER is unique
   
   execute (data : ANY) is
      local 
	 i : INTEGER_REF
      do
	 i ?= data
	 inspect i.item
	 when add1000 then
	    add1000_clist
	 when add10000 then
	    add10000_clist
	 when clear then
	    clist.clear
	 when remove then 
	    clist.remove(0)
	 when insert then
	    clist.append(<< "This", "is", "an", "inserted", "row", "lalala", "lalala" >>)
	 when show then
	    clist.column_titles_show
	 when hide then
	    clist.column_titles_hide
	 else
	 end
      end

   add1000_clist is
      local 
	 i : INTEGER
	 text : ARRAY[STRING]
	 rowlabel : STRING
      do
	 text := << "", "Right", "Center", "Column 3", "Column 4",
		    "Column 5", "Column 6" >>
	 !!rowlabel.make(8)
	 clist.freeze
	 from i := 0
	 until i > 1000
	 loop
	    rowlabel.copy("Row ")
	    rowlabel.append(i.out)
	    text.put(rowlabel, 1)
	    clist.append(text)
	    clist.set_pixtext(i, 3, "Testing", 5, pixmap)
	    i := i+1
	 end
	 clist.thaw
      end

   pixmap : GDK_PIXMAP is
      local style : GTK_STYLE
      once
	 !!style.make
	 !!Result.make_from_xpm(clist.window, 
				style.white, 
				"test.xpm")
      end

   add10000_clist is
      local 
	 i : INTEGER
	 text : ARRAY[STRING]
	 rowlabel : STRING
      do
	 !!rowlabel.make(9)
	 text := << "", "Right", "Center", "Column 3", "Column 4", "Column 5",
		    "Column 6" >>
	 clist.freeze
	 from i := 0
	 until i > 10000
	 loop
	    !!rowlabel.copy("Row ")
	    rowlabel.append(i.out)
	    text.put(rowlabel, 1)
	    clist.append(text)
	    i := i+1
	 end
	 clist.thaw
      end

feature {CREATE_CLIST_UNSELECT}

   unselect_row ( row, column : INTEGER; event_ : GDK_EVENT ; data : ANY ) is
      do
	 print("Unselect: Row: ")
	 print(row.out)
	 print(", column ")
	 print(column.out)
	 print("%N")
      end
   
feature {CREATE_CLIST_SELECT}
   select_row ( row, column : INTEGER ; event_ : GDK_EVENT ; data : ANY ) is
      local 
	 i : INTEGER
      do
	 print("Select: Row: ")
	 print(row.out)
	 print(", column ")
	 print(column.out)
	 print("%N")
	 if (row >= 0 and column >= 0) then 
	    print("Text: ")
	    from i:=0
	    until i>6
	    loop
	       if clist.get_cell_type(row, i).is_equal(gtk_cell_text) then
		  print(clist.get_text(row, i))
		  print(" ")
	       else
		  print("unknown cell type ")
	       end
	       i:=i+1
	    end
	    print("%N")
	 end
      end

invariant
end 
