indexing
   description: "create color preview"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen"
   id: "$Id: create_color_preview.e,v 1.7 1999/01/18 19:55:08 pcj Exp $"

class CREATE_COLOR_PREVIEW
inherit 
   SIMPLE_TEST
   GTK_CONSTANTS
   GTK_IDLE_COMMAND
creation
   make
feature -- Creation
   make is
      local 
	 default_object : GTK_WIDGET
	 destroy_preview : DESTROY_PREVIEW
      do
	 !!destroy_preview

	 !!preview.make(gtk_preview_color) 
	 !!default_object.make_default_object
	 default_object.push_visual(preview.get_visual)
	 default_object.push_colormap(preview.get_cmap)
	 !!window.make
	 window.signal_connect("destroy", destroy_preview, Current)
	 window.set_title("test")
	 window.set_border_width(10)

	 preview.size(256, 256)
	 window.add(preview)
	 draw_color
	 
	 !!color_idle.make(Current, "")
	 window.show_all
      end -- make

feature {NONE} -- Private
   
   preview : GTK_PREVIEW
   count : INTEGER 
   window : GTK_WINDOW
   null_rectangle : GDK_RECTANGLE
   color_idle : GTK_IDLE

   execute ( data : ANY ) : BOOLEAN is
      do
	 draw_color
	 Result := True
      end

   -- Why is this so slow? Blame array invariants. 

   draw_color is 
      local
	 buf : ARRAY[CHARACTER]
	 i, j, k : INTEGER 
      do
	 !!null_rectangle.make_default
	 !!buf.make(0,768)
	 from i := 0
	 until i >= 256 
	 loop 
	    from j := 0 
	       k := 0
	    until j >= 256 
	    loop
	       buf.put(((i+count)\\256).to_character, k)
	       buf.put((0).to_character, k+1)
	       buf.put(((j+count)\\256).to_character, k+2)
	       k := k+3
	       j := j+1
	    end
	    preview.draw_row(buf, 0, i, 256)
	    i := i+1
	 end
	 count := count +1
	 preview.draw(null_rectangle)
      end

feature {DESTROY_PREVIEW}
   destroy is
      do
	 window.destroy
	 color_idle.remove
      end
invariant
end 

