indexing
   description: "create ctree"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen"
   id: "$Id: create_ctree.e,v 1.6 1999/01/18 19:55:08 pcj Exp $"

class CREATE_CTREE
inherit 
   SIMPLE_TEST
   GTK_COMMAND
   GTK_CONSTANTS
creation
   make
feature -- Creation
   make is
      do
	 do_ctree
      end -- make
feature {ANY} -- Commands
   do_ctree is
      local
	 hbox, hbox2 : GTK_HBOX
	 vbox : GTK_VBOX
	 frame : GTK_FRAME
	 label : GTK_LABEL
	 button : GTK_BUTTON
         checkbutton : GTK_CHECK_BUTTON
	 adjustment : GTK_ADJUSTMENT
	 spinner, spin1, spin2, spin3 : GTK_SPINBUTTON
	 items1, items2 : GTK_OPTION_MENU
	 destroy_window : DESTROY_WINDOW
	 tooltips : GTK_TOOLTIPS 
      do
	 !!window.make
	 !!destroy_window
	 window.signal_connect("destroy", destroy_window, window)
	 
	 window.set_title("GtkCTree")
	 window.set_border_width(0)

	 !!tooltips.make
	 !!vbox.make(False, 0)
	 window.add(vbox)

	 !!hbox.make(False, 5)
	 hbox.set_border_width(5)
	 vbox.pack_start(hbox, False, True, 0)
	 
	 !!label.make("Depth :")
	 hbox.pack_start(label, False, True, 0)
	 
	 !!adjustment.make(4, 1, 10, 1, 5, 0)
	 !!spin1.make_with_adjustment(adjustment, 0, 0)
	 hbox.pack_start(spin1, False, True, 5)

	 !!label.make("Books: ")
	 hbox.pack_start(label, False, True, 0)

	 !!adjustment.make(3, 1, 20, 1, 5, 0)
	 !!spin2.make_with_adjustment(adjustment, 0, 0)
	 hbox.pack_start(spin2, False, True, 5)
	 
	 !!label.make("Pages: ")
	 hbox.pack_start(label, false, true, 0)
	 
	 !!adjustment.make(5, 1, 20, 1, 5, 0)
	 !!spin3.make_with_adjustment(adjustment, 0, 0)
	 hbox.pack_start(spin3, False, True, 0)
	 
	 !!button.make_with_label("Close")
	 hbox.pack_end(button, True, True, 0)
	 button.signal_connect("clicked", destroy_window, window)
	 
	 !!button.make_with_label("Rebuild Tree")
	 hbox.pack_start(button, True, True, 0)
	 
	 !!ctree.make_ctree_with_titles(2, 0, <<"Tree", "Info">>)
	 ctree.set_line_style(gtk_ctree_lines_dotted)
	 ctree.set_reorderable(true)
-- 	 ctree.signal_connect("button_press_event", 
-- 			      Current, 
-- 			      button_press_event)
-- 	 ctree.signal_connect("button_release_event", 
-- 				    ctree_button_release,
-- 				    Void)
-- 	 after_events := <<"button_press_event", 
-- 			   "button_release_event", 
-- 			   "end_selection", 
-- 			   "toggle_focus_row",
-- 			   "select_all", 
-- 			   "unselect_all", 
-- 			   "scroll_vertical">>
-- 	 from i := after_events.lower
-- 	 until i > after_events.upper 
-- 	 loop
-- 	    ctree.signal_connect_after(after_events@i, 
-- 				       ctree_after_press,
-- 				       Void)
-- 	    i := i+1
-- 	 end
	 
	 vbox.pack_start(ctree, True, True, 0)
	 ctree.column_titles_passive
	 ctree.set_selection_mode(gtk_selection_extended)
--	 ctree.set_policy(gtk_policy_always, gtk_policy_automatic)
	 ctree.set_column_width(0, 200)
	 ctree.set_column_width(1, 200)
	 
	 button.signal_connect("clicked", Current, rebuild_tree)
	 
	 !!hbox.make(False, 5)
	 hbox.set_border_width(5)
	 vbox.pack_start(hbox, False, True, 0)
	 
	 !!button.make_with_label("Expand all")
	 button.signal_connect("clicked", Current, expand_all)
	 hbox.pack_start(button, True, True, 0)
	 
	 !!button.make_with_label("Collapse all")
	 button.signal_connect("clicked", Current, collapse_all)
	 hbox.pack_start(button, True, True, 0)

	 !!button.make_with_label("Sort tree")
	 button.signal_connect("clicked", Current, sort_tree)
	 hbox.pack_start(button, True, True, 0)
	 
	 !!hbox.make(False, 5)
	 hbox.set_border_width(5)
	 vbox.pack_start(hbox, False, True, 0)
	 
	 !!label.make("Row height: ")
	 hbox.pack_start(label, False, True, 0)
	 !!adjustment.make(20, 12, 100, 1, 10, 0)
	 !!spinner.make_with_adjustment(adjustment, 0, 0)
	 
	 tooltips.set_tip(spinner, "Row height of list items")
	 adjustment.signal_connect("value_changed", 
				   Current, change_row_height) 
	 hbox.pack_start(spinner, False, True, 5)
	 ctree.set_row_height(adjustment.value.rounded)
	 
	 !!button.make_with_label("Select all")
	 button.signal_connect("clicked", Current, select_all)
	 hbox.pack_start(button, True, True, 0)
	 
	 !!button.make_with_label("Unselect all")
	 button.signal_connect("clicked", Current, unselect_all)
	 hbox.pack_start(button, True, True, 0)
	 
	 !!button.make_with_label("Remove selection")
	 button.signal_connect("clicked", Current, remove_selection)
	 hbox.pack_start(button, True, True, 0)

	 -- more stuff
	 
	 window.realize
	 ctree.set_usize(0, 300)

	 do_rebuild_tree
	 window.show_all
     end
     
feature {NONE} -- Private

   ctree: GTK_CTREE
   window : GTK_WINDOW
   books, pages : INTEGER

   rebuild_tree, expand_all, collapse_all, sort_tree, select_all, 
   unselect_all, remove_selection, change_row_height : INTEGER is unique

   execute ( command : ANY ) is 
      local i : INTEGER_REF
      do
	 i ?= command
	 print (i)
	 print ("%N")
      end
   
   do_rebuild_tree is
      local 
	 parent : GTK_CTREE_NODE
      do
	 ctree.freeze
	 parent := ctree.insert_node ( Void, Void, <<"Hi">>, 5, 
				       book_closed_xpm, 
				       book_open_xpm, 
				       False, True )
	 
	 build_recursive(1, 4, 3, 5, parent)
	 ctree.thaw
      end

   build_recursive ( cur_depth, depth, num_books, num_pages : INTEGER ; 
		     parent : GTK_CTREE_NODE ) is
      local 
	 i : INTEGER
	 buf1, buf2: STRING
	 sibling : GTK_CTREE_NODE 
	 rng: MIN_STAND
      do
	 !!buf1.make(7)
	 !!buf2.make(8)
	 !!rng.make
	 
	 from 
	    i := num_pages + num_books
	 until
	    i <= num_books
	 loop
	    pages := pages +1
	    buf1.copy("Page ")
	    buf1.append(rng.last_integer(100).out)
	    
	    buf2.copy("Item ")
	    buf2.append(cur_depth.out)
	    buf2.append("-")
	    buf2.append(i.out) 

	    sibling := ctree.insert_node ( parent, sibling, <<buf1, buf2>>, 
					   5, mini_page_xpm, default_pixmap, True, False )

	    i := i-1
	    rng.next

	 end
	 
	 if ( cur_depth = depth ) then 
	 else
	    from 
	       i := num_books
	    until 
	       i <= 0
	    loop
	       books := books + 1
	       buf1.copy("Book ")
	       buf1.append(rng.last_integer(100).out)
	       rng.next
	       buf2.copy("Item ")
	       buf2.append(cur_depth.out)
	       buf2.append("-")
	       buf2.append(i.out)

	       sibling := ctree.insert_node ( parent, sibling, <<buf1, buf2>>, 5, 
					      book_closed_xpm, book_open_xpm, 
					      False, False ) 

	       build_recursive ( cur_depth + 1, depth, 
				 num_books, num_pages, sibling ) 
	       i := i-1
	    end
	 end
      end

   default_pixmap : GDK_PIXMAP is
      once
	 !!Result.make_default
      end

   default_color : GDK_COLOR is
      once
	 !!Result.make_default
      end

   book_closed_xpm : GDK_PIXMAP is 
      once
	 !!Result.make_from_xpm_d(window.window, 
				  default_color, 
				  icons.book_closed_xpm_d)
      end
   book_open_xpm : GDK_PIXMAP is 
      once
	 !!Result.make_from_xpm_d(window.window, 
				  default_color, 
				  icons.book_open_xpm_d)
      end
   mini_page_xpm : GDK_PIXMAP is
      once
	 !!Result.make_from_xpm_d(window.window, 
				  default_color, 
				  icons.mini_page_xpm_d)
      end

   icons : ICONS

invariant
end 
