indexing
   description: "create cursors"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen"
   id: "$Id: create_cursors.e,v 1.5 1999/01/18 19:55:09 pcj Exp $"

class CREATE_CURSORS
inherit 
   SIMPLE_TEST
   GTK_COMMAND
   GTK_CONSTANTS
creation
   make
feature -- Creation
   make is
      local
	 window : GTK_WINDOW
	 frame : GTK_FRAME
	 hbox : GTK_HBOX
	 main_vbox, vbox : GTK_VBOX
	 label : GTK_LABEL
	 adj : GTK_ADJUSTMENT
	 separator : GTK_HSEPARATOR
	 button : GTK_BUTTON
	 destroy_window : DESTROY_WINDOW
	 clicked_command : CURSOR_COMMAND_EVENT
      do
	 !!destroy_window
	 !!window.make
	 window.add_action("destroy", destroy_window, window)

	 !!main_vbox.make_with_aspect(False, 5)
	 main_vbox.set_border_width(0)
	 window.add(main_vbox)

	 !!vbox.make_with_aspect(False, 5)
	 vbox.set_border_width(10)
	 main_vbox.add(vbox)
	 vbox.show
	 
	 !!hbox.make_with_aspect(False, 0)
	 hbox.set_border_width(5)
	 vbox.pack_start(hbox, False, True, 0)
	 
	 !!label.make_with_label("Cursor Value:")
	 label.set_alignment(0.0, 0.5)
	 hbox.pack_start(label, False, True, 0)

	 !!adj.make(0.0, 0.0, 152.0, 2.0, 10.0, 0.0)
	 !!spinner.make_with_adjustment(adj, 0.0, 0)
	 hbox.pack_start(spinner, True, True, 0)
	 
	 !!frame.make_with_label("Cursor Area")
	 frame.set_label_align(0.5, 0.0)
	 frame.set_border_width(10)
	 vbox.add(frame)
	 frame.show

	 !!clicked_command

	 !!darea.make
	 darea.set_size(80,80)
	 frame.add(darea)
	 darea.add_action("button_press_event", clicked_command, Current)
	 darea.add_action("expose_event", Current, "exposed")
	 darea.set_events(gdk_exposure_mask and gdk_button_press_mask)
	 darea.show

	 spinner.add_action("changed", Current, "spun")
	 
	 !!separator.make
	 main_vbox.pack_start(separator, False, True, 0)

	 !!hbox.make_with_aspect(False, 0)
	 hbox.set_border_width(10)
	 main_vbox.pack_start(hbox, False, True, 0)
	 
	 !!button.make_with_label("Close")
	 button.add_clicked_action(destroy_window, window)
	 hbox.pack_start(button, True, True, 5)
	 button.show
	 button.set_flags(gtk_can_default)
	 button.grab_default
	 window.show_all	 
      end -- make

feature {ANY} -- Queries
feature {ANY} -- Commands

   cursor_event ( button : INTEGER ) is
      do
 	 if button = 1 then
 	    spinner.spin(gtk_arrow_up, spinner.get_adjustment.step_increment)
 	 elseif button = 3 then
 	    spinner.spin(gtk_arrow_down, spinner.get_adjustment.step_increment)
 	 end
      end

feature {NONE} -- Private

   darea : GTK_DRAWING_AREA
   spinner : GTK_SPINBUTTON

   execute (data : ANY) is
      local 
	 eventstr : STRING
      do
	 eventstr ?= data
	 if eventstr.is_equal("exposed") then
	    cursor_expose_event
	 elseif eventstr.is_equal("spun") then
	    set_cursor
	 end
      end

   cursor_expose_event is
      local
	 drawable : GDK_DRAWABLE
	 white_gc, gray_gc, black_gc : GDK_GC
	 width, height : INTEGER 
      do
	 !!drawable.create(darea.window.to_external)
	 white_gc := darea.style.white_gc
	 gray_gc := darea.style.bg_gc(gtk_state_normal)
	 black_gc := darea.style.black_gc

	 width := darea.allocation.width
	 height := darea.allocation.height
	 
	 drawable.draw_rectangle(white_gc, True, 0, 0, width, height//2)
	 drawable.draw_rectangle(black_gc, True, 0, height//2, width, height//2)
	 drawable.draw_rectangle(gray_gc, True, width//3, height//3, width//3, height//3)
	 
      end

   set_cursor is
      local c : INTEGER 
	 cursor : GDK_CURSOR
      do
	 c := spinner.get_value_as_int
	 !!cursor.make(c)
	 darea.window.set_cursor(cursor)
	 cursor.destroy
      end

invariant
end 
