indexing
   description: "create drag drop"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen"
   id: "$Id: create_drag_drop.e,v 1.8 1999/01/18 19:55:09 pcj Exp $"

class CREATE_DRAG_DROP
inherit 
   SIMPLE_TEST
   GTK_CONSTANTS
   GTK_COMMAND
creation
   make
feature -- Creation
   make is
      local
	 window : GTK_WINDOW
	 box1, box2, box3 : GTK_BOX
	 frame : GTK_FRAME
	 button : GTK_BUTTON
	 separator : GTK_HSEPARATOR
	 possible_drag_types, accepted_drop_types : GTK_TARGET_ENTRY
	 drag_types, drop_types : ARRAY[GTK_TARGET_ENTRY]
	 destroy_window : DESTROY_WINDOW
	 drag_data_get_command : DRAG_DATA_GET_COMMAND
	 drag_data_received_command : DRAG_DATA_RECEIVED_COMMAND 
      do

	 !!drag_data_get_command
	 !!drag_data_received_command

	 !!drag_types.make(1,2); 
	 !!possible_drag_types.make("STRING", 
				    gtk_target_none, 
				    11) 
	 drag_types.put(possible_drag_types, 1)
	 !!possible_drag_types.make("text/plain", 
				    gtk_target_none, 
				    12) 
	 drag_types.put(possible_drag_types, 2)

	 !!drop_types.make(1,2); 
	 !!accepted_drop_types.make("STRING", 
				    gtk_target_none, 
				    13) 
	 drop_types.put(accepted_drop_types, 1)
	 !!accepted_drop_types.make("text/plain", 
				    gtk_target_none, 
				    14)
	 drop_types.put(accepted_drop_types, 2)

	 !!window.make
	 !!destroy_window
	 window.signal_connect("destroy", destroy_window, window)
	 window.set_title("Drag -N- Drop")
	 window.set_border_width(0)
	 window.show	 
	 
	 !GTK_VBOX!box1.make(False, 0)
	 window.add(box1)
	 box1.show

	 !GTK_HBOX!box2.make(False, 5)
	 box2.set_border_width(10)
	 box1.pack_start(box2, True, True, 0)
	 box2.show

	 !!frame.make_with_label("Drag")
	 box2.pack_start(frame, True, True, 0)
	 frame.show

	 !GTK_VBOX!box3.make(False, 5)
	 box3.set_border_width(5)
	 frame.add(box3)
	 box3.show

	 !!button.make_with_label("Drag me!")
	 box3.pack_start(button, False, True, 0)
	 button.show

	 button.realize
	 button.drag_source_set(gdk_button1_mask,
				drag_types, 
				gdk_action_copy)
	 button.signal_connect("drag_data_get", drag_data_get_command, 
			       drag_data_get_event)

	 
	 !!frame.make_with_label("Drop")
	 box2.pack_start(frame, True, True, 0)
	 frame.show

	 !GTK_VBOX!box3.make(False, 5)
	 box3.set_border_width(5)
	 frame.add(box3)
	 box3.show

	 !!button.make_with_label("To")
	 box3.pack_start(button, False, True, 0)
	 button.show

	 button.realize
	 button.signal_connect("drag_data_received", 
			       drag_data_received_command, 
			       drag_data_received_event) 
	 button.drag_dest_set (gtk_dest_default_all,
			       drop_types, 
			       gdk_action_copy)
	 
	 !!separator.make
	 box1.pack_start(separator, False, True, 0)
	 separator.show

	 !GTK_VBOX!box2.make(False,10)
	 box2.set_border_width(10)
	 box1.pack_start(box2, False, True, 0)
	 box2.show

	 !!button.make_with_label("close")
	 button.signal_connect("clicked", destroy_window, window)
	 box2.pack_start(button, True, True, 0)
	 button.set_flags(gtk_can_default)
	 button.grab_default
	 button.show

      end -- make
feature {ANY} -- Commands
   execute ( data : ANY ) is
      local 
	 i : INTEGER_REF
      do
	 print ("hi%N")
	 i ?= data
	 print (i.item) 
	 print ("%N")
      end

feature {NONE} -- Private
   drag_data_get_event, drag_data_received_event : INTEGER is unique
invariant
end 

