indexing
   description: "create fileselection"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen"
   id: "$Id: create_fileselection.e,v 1.4 1999/01/18 19:55:09 pcj Exp $"

class CREATE_FILESELECTION
inherit 
   SIMPLE_TEST
   GTK_COMMAND
creation
   make
feature -- Creation
   make is
      local 
	 button : GTK_BUTTON
	 destroy_window : DESTROY_WINDOW
      do
	 !!filesel.make("File selection dialog")
	 !!destroy_window
	 filesel.signal_connect("destroy", destroy_window, filesel)
	 filesel.ok_button.signal_connect("clicked", Current, file_selection_ok)
	 filesel.cancel_button.signal_connect("clicked", destroy_window, filesel)

	 !!button.make_with_label("Hide Fileops")
	 button.signal_connect("clicked", Current, hide_fileops)
	 filesel.action_area.pack_start(button, False, False, 0)
	 button.show

	 !!button.make_with_label("Show fileops")
	 button.signal_connect("clicked", Current, show_fileops)
	 filesel.action_area.pack_start(button, False, False, 0)
	 button.show
	 
	 filesel.show
      end -- make

feature {NONE} -- Private

   filesel : GTK_FILE_SELECTION
   file_selection_ok, hide_fileops, show_fileops : INTEGER is unique
   
   execute ( data : ANY )  is
      local 
	 i : INTEGER_REF
      do
	 i ?= data
	 inspect i.item
	 when file_selection_ok then
	    print(filesel.get_filename)
	    print("%N")
	    filesel.destroy
	 when hide_fileops then 
	    filesel.hide_fileop_buttons
	 when show_fileops then
	    filesel.show_fileop_buttons
	 else
	 end
      end
end 

