indexing
   description: "create gamma curve"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen"
   id: "$Id: create_gamma_curve.e,v 1.4 1999/01/18 19:55:09 pcj Exp $"

class CREATE_GAMMA_CURVE
inherit 
   SIMPLE_TEST
   GTK_CONSTANTS
creation
   make
feature -- Creation
   make is
      local 
	 window : GTK_WINDOW
	 curve : GTK_GAMMA_CURVE
	 vec : ARRAY[REAL]
	 max, i : INTEGER
	 destroy_window : DESTROY_WINDOW
      do
	 !!vec.make(0,255)
	 !!window.make
	 !!destroy_window
	 window.set_title("test")
	 window.set_border_width(10)
	 window.signal_connect("destroy", destroy_window, window)
	 
	 !!curve.make_gamma_curve
	 window.add(curve)
	 curve.show

	 max := 127 + ( count \\ 2 ) * 128
	 curve.curve.set_range(0, max, 0, max)
	 from 
	    i := 0
	 until 
	    i > max
	 loop
	    i := i+1
	    vec.put((127.0 / max.sqrt.to_real)*i.sqrt.to_real, i)
	 end
	 curve.curve.set_vector(max, vec)
	 window.show
	 count := count + 1
			  
      end -- make

      count : INTEGER 

feature {ANY} -- Queries
feature {ANY} -- Commands
feature {NONE} -- Private
invariant
end 

