indexing
   description: "create list"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen"
   id: "$Id: create_list.e,v 1.5 1999/01/18 19:55:09 pcj Exp $"

class CREATE_LIST
inherit 
   SIMPLE_TEST
   GTK_COMMAND
   GTK_CONSTANTS
creation
   make
feature -- Creation
   make is
      local
	 list_items : ARRAY[STRING]
	 box1, box2 : GTK_VBOX
	 window : GTK_WINDOW
	 scrolled_win : GTK_SCROLLED_WINDOW
	 list_item : GTK_LIST_ITEM
	 button : GTK_BUTTON
	 separator : GTK_HSEPARATOR
	 destroy_window : DESTROY_WINDOW
	 i : INTEGER
      do
	 list_items := << "hello", "world", "blah", "foo", "bar", "argh",
			  "spencer", "is a", "wussy", "programmer" >>
	 
	 !!destroy_window
	 !!window.make
	 window.add_action("destroy", destroy_window, window)
	 window.set_title("list")
	 
	 !!box1.make_with_aspect(False, 0)
	 window.add(box1)
	 box1.show

	 !!box2.make_with_aspect(False, 10)
	 box2.set_border_width(10)
	 box1.pack_start(box2, True, True, 0)
	 box2.show

	 !!scrolled_win.make
	 scrolled_win.set_policy(gtk_policy_automatic, gtk_policy_automatic)
	 box2.pack_start(scrolled_win, True, True, 0)
	 scrolled_win.show

	 !!list.make
	 list.set_selection_mode(gtk_selection_multiple)
	 scrolled_win.add_with_viewport(list)
	 list.show
	 
	 from i := list_items.lower
	 until i > list_items.upper
	 loop
	    !!list_item.make_with_label(list_items.item(i))
	    list.add(list_item)
	    list_item.show
	    i := i + 1
	 end
	 
	 !!button.make_with_label("Add")
	 button.add_clicked_action(Current, "add")
	 box2.pack_start(button, False, True, 0)
	 button.show

	 !!button.make_with_label("Remove")
	 button.add_clicked_action(Current, "remove")
	 box2.pack_start(button, False, True, 0)
	 button.show
	 
	 !!separator.make
	 box1.pack_start(separator, False, True, 0)
	 separator.show

	 !!box2.make_with_aspect(False, 10)
	 box2.set_border_width(10)
	 box1.pack_start(box2, False, True, 0)
	 box2.show

	 !!button.make_with_label("Close")
	 button.add_clicked_action(destroy_window, window)
	 box2.pack_start(button, True, True, 0)
	 button.set_flags(gtk_can_default)
	 button.show

	 window.show

      end -- make
feature {ANY} -- Queries
feature {ANY} -- Commands
feature {NONE} -- Private

   list : GTK_LIST

   execute ( data : ANY ) is
      local
	 command : STRING
      do
	 command ?= data
	 if (command.is_equal("add")) then
	    print("add%N")
	 else
	    list.remove_items(list.selection)
	 end
      end
invariant
end -- CREATE_LIST
