indexing
   description: "create menus"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen and Francois Pennaneach"
   id: "$Id: create_menus.e,v 1.7 1999/01/18 19:55:09 pcj Exp $"

class CREATE_MENUS
inherit
   SIMPLE_TEST
   GTK_CONSTANTS
creation make
feature -- Creation
   make is
      -- Creation and initialization
      local
	 box1, box2 : GTK_BOX
	 button : GTK_BUTTON
	 menu : GTK_MENU
	 menubar : GTK_MENU_BAR
	 menuitem : GTK_MENU_ITEM
	 optionmenu : GTK_OPTION_MENU
	 separator : GTK_HSEPARATOR
	 window : GTK_WINDOW
	 destroy_window : DESTROY_WINDOW
	 accel_group : GTK_ACCEL_GROUP
	 keys : GDK_KEYS
	 -- commands
      do
	 !!destroy_window
	 !!window.make
	 window.add_action("destroy", destroy_window, window)

	 !!accel_group.make
	 accel_group.attach(window)

	 window.set_title("menus")
	 window.set_border_width(0)

	 !GTK_VBOX!box1.make_with_aspect(False, 0)
	 window.add(box1)
	 box1.show

	 !!menubar.make
	 box1.pack_start(menubar, False, true, 0)
	 menubar.show

	 !!menuitem.make_with_label("test%Nline2")
	 menu := create_menu(2)
	 menuitem.set_submenu(menu)
	 menubar.append(menuitem)
	 menuitem.show

	 !!menuitem.make_with_label("foo")
	 menu := create_menu(3)
	 menuitem.set_submenu(menu)
	 menubar.append(menuitem)
	 menuitem.show

	 !!menuitem.make_with_label("bar")
	 menu := create_menu(4)
	 menuitem.set_submenu(menu)
	 menuitem.right_justify
	 menubar.append(menuitem)
	 menuitem.show

	 !GTK_VBOX!box2.make_with_aspect(False, 10)
	 box2.set_border_width(10)
	 box1.pack_start(box2, true, true, 0)
	 box2.show

	 menu := create_menu (1)
	 menu.set_accel_group(accel_group)
	 !GTK_CHECK_MENU_ITEM!menuitem.make_with_label("Accelerate Me")
	 menu.append(menuitem)
	 menuitem.show
	 !!keys
	 menuitem.add_accelerator("activate", accel_group, 
				  keys.lookup("F1"), 
				  gdk_modifier_none, 
				  gtk_accel_visible and gtk_accel_signal_visible )


	 !GTK_CHECK_MENU_ITEM!menuitem.make_with_label("Accelerator Locked")
	 menu.append(menuitem)
	 menuitem.show
	 menuitem.add_accelerator("activate", accel_group, 
				  keys.lookup("F2"), 
				  gdk_modifier_none, 
				  gtk_accel_visible and gtk_accel_locked)
	 !!optionmenu.make
	 optionmenu.set_menu(menu)
	 optionmenu.set_history(4)
	 box2.pack_start(optionmenu, True, True, 0)
	 optionmenu.show

	 !!separator.make
	 box1.pack_start(separator, False, True, 0)
	 separator.show

	 !GTK_VBOX!box2.make_with_aspect(False, 10)
	 box2.set_border_width(10)
	 box1.pack_start(box2, False, True, 0)
	 box2.show

	 !!button.make_with_label("close")
	 button.add_clicked_action(destroy_window, window)
	 box2.pack_start(button, True, True, 0)
	 button.set_flags(gtk_can_default)
	 button.grab_default
	 button.show

       	 window.show
      end -- make

feature {ANY} -- Queries
feature {ANY} -- Commands
feature {NONE} -- Private

   create_menu(depth : INTEGER) : GTK_MENU is
      -- Creation and initialization
      local
	 menu : GTK_MENU
	 submenu : GTK_MENU
	 menuitem : GTK_RADIO_MENU_ITEM
	 buf : STRING
	 i, j : INTEGER
      do
	 if depth < 1 then
	    Result := Void
	 else
	    !!menu.make
	    from 
	       i := 0
	       j := 1
	    until i >= 5
	    loop
	       !!buf.make(10)
	       buf.copy("item ")
	       buf.append(depth.out)
	       buf.append(" ")
	       buf.append(j.out)

	       !!menuitem.make_with_item_and_label(menuitem, buf)
	       menu.append(menuitem)
	       menuitem.show
	       menuitem.configure(False, False)
	       if depth > 1 then
		  if (submenu = Void) then 
		     submenu := create_menu(depth - 1)
		     menuitem.set_submenu(submenu)
		  end -- if
	       end -- if
	       i := i + 1; j := j + 1
	    end -- loop
	    Result := menu
	 end -- if
      end -- create_menu

invariant
end -- CREATE_MENUS

