indexing
   description: "create notebook"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen"
   id: "$Id: create_notebook.e,v 1.6 1999/01/18 19:55:09 pcj Exp $"

class CREATE_NOTEBOOK 
inherit 
   SIMPLE_TEST
   GTK_CONSTANTS
   GTK_COMMAND
creation
   make
feature -- Creation
   make is
      local 
	 box1, box2 : GTK_BOX
	 button : GTK_BUTTON
	 separator : GTK_HSEPARATOR
	 destroy_window : NOTEBOOK_DESTROY_WINDOW
	 switch_page_command : CREATE_NOTEBOOK_SWITCH_PAGE
      do
	 !!menu_pixwids.make(1,5)
	 !!label_pixwids.make(1,5)
	 
	 !!window.make
	 !!destroy_window
	 window.signal_connect("destroy", destroy_window, Current)
	 
	 window.set_title("notebook")
	 window.set_border_width(10)

	 !GTK_VBOX!box1.make(False, 0)
	 window.add(box1)

	 !!notebook.make
	 !!switch_page_command
	 notebook.signal_connect("switch_page", switch_page_command, Current)
	 notebook.set_tab_pos(gtk_pos_top)
	 box1.pack_start(notebook, True, True, 0)
	 notebook.set_border_width(10)
	 
	 notebook.realize
	 
	 create_pages(1,5)
	 !!separator.make
	 
	 box1.pack_start(separator, False, True, 10)
	 !GTK_HBOX!box2.make(True, 5)
	 box1.pack_start(box2, False, True, 0)
	 
--	 omenu := build_option_menu (items, 3, 0, notebook) 
--	 box2.pack_start(omenu, False, False, 0)

	 !!popup_button.make_with_label("enable popup menu")
	 box2.pack_start(popup_button, False, False, 0)
	 popup_button.signal_connect("clicked", Current, notebook_popup)
	 
	 !GTK_HBOX!box2.make(True, 0)
	 box2.set_border_width(10)
	 box1.pack_start(box2, False, True, 0)
	 
	 !!button.make_with_label("close")
	 button.signal_connect("clicked", destroy_window, Current)
	 box2.pack_start(button, True, True, 0)
--	 button.set_flags(gtk_can_default)
--	 button.grab_default
	 
	 !!button.make_with_label("next")
	 button.signal_connect("clicked", Current, next_page)
	 box2.pack_start(button, True, True, 0)
--	 button.set_flags(gtk_can_default)
	 
	 !!button.make_with_label("prev")
	 button.signal_connect("clicked", Current, prev_page)
	 box2.pack_start(button, True, True, 0)
--	 button.set_flags(gtk_can_default)
	 
	 !!button.make_with_label("rotate")
	 button.signal_connect("clicked", Current, rotate_notebook)
	 box2.pack_start(button, True, True, 0)
--	 button.set_flags(gtk_can_default)

	 window.show_all

      end -- make

feature {NONE} -- Private

   notebook_popup, next_page, prev_page, rotate_notebook : INTEGER is unique
   popup_button : GTK_CHECK_BUTTON
   icons : ICONS
   menu_pixwids, label_pixwids : ARRAY[GTK_PIXMAP]

   execute ( data : ANY ) is 
      local 
	 i : INTEGER_REF 
	 j: INTEGER
	 string : STRING
	 positions : ARRAY[GTK_POSITION_TYPE]
	 rotated : BOOLEAN 
      do
	 i ?= data 
	 inspect i.item 
	 when notebook_popup then 
	    if popup_button.active then
	       notebook.popup_enable
	    else
	       notebook.popup_disable
	    end
	 when next_page then
	    notebook.next_page
	 when prev_page then
	    notebook.prev_page
	 when rotate_notebook then
	    positions := << gtk_pos_top, 
			    gtk_pos_right, 
			    gtk_pos_bottom, 
			    gtk_pos_left >>
	    from 
	       j := positions.lower
	    until 
	       rotated or j > positions.upper
	    loop
	       if notebook.tab_pos.is_equal(positions.item(j)) then
		  notebook.set_tab_pos(positions.item((j \\ 4) +1))
		  rotated := True
	       end
	       j := j+1
	    end
	    else
	 end
      end
   
   create_pages ( start, end_ : INTEGER ) is
      local 
	 i : INTEGER 
	 buffer : STRING 
	 button : GTK_BUTTON
	 frame : GTK_FRAME
	 box : GTK_VBOX
	 menu_box, label_box, hbox : GTK_HBOX
	 label : GTK_LABEL
	 entry : GTK_ENTRY
	 child : GTK_WIDGET
	 pixwid : GTK_PIXMAP 

      do
	 !!buffer.make(32)
	 from 
	    i := start
	 until 
	    i >  end_
	 loop
	    buffer.copy("Page ")
	    buffer.append(i.out)
	    
	    inspect i \\ 4
	    when 3 then
	       button.make_with_label(buffer)
	       button.set_border_width(10)
	       child := button
	    when 2 then 
	       !!label.make(buffer)
	       child := label
	    when 1 then 
	       !!frame.make_with_label(buffer)
	       frame.set_border_width(10)
	       
	       !!box.make(True, 0)
	       box.set_border_width(10)
	       frame.add(box)

	       !!label.make(buffer)
	       box.pack_start(label, True, True, 5)
	       !!entry.make
	       box.pack_start(entry, True, True, 5)
	       !!hbox.make(True, 0)
	       box.pack_start(hbox, True, True, 5)
	       !!button.make_with_label("Ok")
	       hbox.pack_start(button, True, True, 5)
	       !!button.make_with_label("Cancel")
	       hbox.pack_start(button, True, True, 5)
	       
	       child := frame
	    when 0 then
	       !!frame.make_with_label(buffer)
	       frame.set_border_width(10)
	       
	       !!label.make(buffer)
	       frame.add(label)
	       
	       child := frame
	    else
	    end
	    
	    child.show_all

	    !!label_box.make(False, 0)
	    !!pixwid.make(book_closed_xpm)
	    label_box.pack_start(pixwid, False, True, 0)
	    pixwid.set_padding(3,1)
	    label_pixwids.put(pixwid, i)
	    !!label.make(buffer)
	    label_box.pack_start(label, False, True, 0)
	    label_box.show_all

	    !!menu_box.make(False,0)
	    !!pixwid.make(book_closed_xpm)
	    menu_box.pack_start(pixwid, False, True, 0)
	    pixwid.set_padding(3,1)
	    menu_pixwids.put(pixwid, i)
	    !!label.make(buffer)
	    menu_box.pack_start(label, False, True, 0)
	    menu_box.show_all

	    notebook.append_page_menu(child, label_box, menu_box)
	    i := i+1
	 end
      end

   book_open_xpm : GDK_PIXMAP is 
      once
	 !!Result.make_from_xpm_d(window.window, 
				  transparent_color, 
				  icons.book_open_xpm_d)
      end

   book_closed_xpm : GDK_PIXMAP is
      once
	 !!Result.make_from_xpm_d(window.window, 
				  transparent_color, 
				  icons.book_closed_xpm_d)
      end
   
   transparent_color : GDK_COLOR is
      once
	 !!Result.make_default
      end

feature {NOTEBOOK_DESTROY_WINDOW} 
   window : GTK_WINDOW

   set_is_destroying is
      do
	 destroying := true
      end


feature {CREATE_NOTEBOOK_SWITCH_PAGE}
   destroying : BOOLEAN
   notebook : GTK_NOTEBOOK

   update_icons ( new_page : INTEGER ) is
      local 
	 last_page : INTEGER 
      do
	 if new_page > 0 then
	    last_page := notebook.current_page
	    label_pixwids.item(new_page+1).set(book_open_xpm)
	    menu_pixwids.item(new_page+1).set(book_open_xpm)
	    if (last_page >= 0) then 
	       label_pixwids.item(last_page+1).set(book_closed_xpm)
	       menu_pixwids.item(last_page+1).set(book_closed_xpm)
	    end
	 end
      end

--   build_option_menu : GTK_OPTION_MENU is 
--      do
--      end

end 
