indexing
   description: "create statusbar"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen"
   id: "$Id: create_statusbar.e,v 1.4 1999/01/18 19:55:09 pcj Exp $"

class CREATE_STATUSBAR
inherit 
   SIMPLE_TEST
   GTK_COMMAND
   GTK_CONSTANTS
creation
   make
feature -- Creation
   make is
      local
	 window : GTK_WINDOW
	 box1, box2 : GTK_VBOX
	 destroy_window : DESTROY_WINDOW
	 button : GTK_BUTTON
	 separator : GTK_HSEPARATOR
      do
	 !!window.make
	 !!destroy_window
	 window.signal_connect("destroy", destroy_window, window)
	 window.set_title("statusbar")
	 window.set_border_width(0)

	 !!box1.make(False, 0)
	 window.add(box1)
	 
	 !!box2.make(False, 10)
	 box2.set_border_width(10)
	 box1.pack_start(box2, True, True, 0)
	 
	 !!statusbar.make_statusbar
	 box1.pack_end(statusbar, True, True, 0)
	 
	 !!button.make_with_label("push something")
	 box2.add(button)
	 button.signal_connect("clicked", Current, statusbar_push)

	 !!button.make_with_label("pop")
	 box2.add(button)
	 button.signal_connect("clicked", Current, pop)


	 !!button.make_with_label("steal #4")
	 box2.add(button)
	 button.signal_connect("clicked", Current, steal)

	 !!button.make_with_label("dump stack")
	 box2.add(button)
	 button.signal_connect("clicked", Current, dump_stack)
	 
	 !!separator.make
	 box1.pack_start(separator, False, True, 0)
	 
	 !!box2.make(False, 10)
	 box2.set_border_width(10)
	 box1.pack_start(box2, False, True, 0)
	 
	 !!button.make_with_label("close")
	 button.signal_connect("clicked", destroy_window, window)
	 box2.pack_start(button, True, True, 0) 
	 button.set_flags(gtk_can_default)
	 button.grab_default

	 window.show_all

      end -- make
feature {ANY} -- Queries
feature {ANY} -- Commands
feature {NONE} -- Private
   text_popped, statusbar_push, pop, steal, dump_stack : INTEGER is unique
   statusbar_counter : INTEGER
   statusbar : GTK_STATUSBAR

   execute ( data : ANY ) is
      local 
	 i : INTEGER_REF
	 text : STRING
	 dummy : INTEGER
      do
	 i ?= data
	 inspect i.item
	 when statusbar_push then 

	    statusbar_counter := statusbar_counter +1

	    !!text.make(10)
	    text.copy("something ")
	    text.append(statusbar_counter.out)
	    dummy := statusbar.push(1, text)

	 when pop then 
	    statusbar.pop(1)
	    if statusbar_counter > 0 then 
	       statusbar_counter := statusbar_counter -1
	    end
	 when steal then 
	    statusbar.remove(1, 4)
	 else
	 end
      end

invariant
end 

