indexing
   description: "create text"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen"
   id: "$Id: create_text.e,v 1.5 1999/01/18 19:55:09 pcj Exp $"

class CREATE_TEXT
inherit 
   SIMPLE_TEST
   GTK_CONSTANTS
creation
   make
feature -- Creation
   make is
      local 
	 window : GTK_WINDOW
	 box1, box2 : GTK_VBOX
	 button : GTK_BUTTON
	 separator : GTK_HSEPARATOR
	 table : GTK_TABLE
	 text : GTK_TEXT
	 hscrollbar : GTK_HSCROLLBAR
	 vscrollbar : GTK_VSCROLLBAR
	 destroy_window : DESTROY_WINDOW
	 hadj, vadj : GTK_ADJUSTMENT
	 file : STD_FILE_READ
	 default_color : GDK_COLOR
	 default_font : GDK_FONT
	 string : STRING
      do
	 !!window.make
	 !!destroy_window
	 window.signal_connect("destroy", destroy_window, window)
	 
	 window.set_title("text")
	 window.set_border_width(0)
	 
	 !!box1.make(False, 0)
	 window.add(box1)
	 box1.show

	 !!box2.make(False, 10)
	 box2.set_border_width(10)
	 box1.pack_start(box2, True, True, 0)
	 box2.show

	 !!table.make(2, 2, False) 
	 table.set_row_spacing(0, 2)
	 table.set_col_spacing(0,2)
	 box2.pack_start(table, True, True, 0)
	 table.show

	 !!hadj.make(0.0, 0.0, 0.0, 0.0, 0.0, 0.0)
	 !!vadj.make(0.0, 0.0, 0.0, 0.0, 0.0, 0.0)
	 !!text.make(hadj, vadj)
	 table.attach_defaults(text, 0, 1, 0, 1)
	 text.show

	 !!hscrollbar.make(hadj)
	 table.attach(hscrollbar, 0, 1, 1, 2, 
		      gtk_expand and gtk_fill, gtk_fill, 0, 0)
	 hscrollbar.show
	 
	 !!vscrollbar.make(vadj)
	 table.attach(vscrollbar, 1, 2, 0, 1, gtk_fill, 
		      gtk_fill and gtk_expand, 0, 0)
	 vscrollbar.show

	 text.freeze
	 text.realize

	 from 
	    !!file.connect_to("create_text.e")
	    !!default_color.make_default
	    !!default_font.make_default
	    !!string.make(80)
	 until 
	    file.end_of_input
	 loop
	    string.clear
	    file.read_line_in(string)
	    string.append("%N")
	    text.insert(default_font, default_color, default_color,
			string, -1)
	 end
	 
	 !!separator.make
	 box1.pack_start(separator, False, True, 0)
	 separator.show
	 
	 !!box2.make(False, 10)
	 box2.set_border_width(10)
	 box1.pack_start(box2, False, True, 0)
	 box2.show

	 !!button.make_with_label("Close")
	 button.signal_connect("clicked", destroy_window, window)
	 box2.pack_start(button, True, True, 0)
	 button.set_flags(gtk_can_default)
	 button.grab_default
	 button.show

	 window.show
	 
      end -- make

feature {NONE} -- Private
invariant
end 

