indexing
   description: "create toggle buttons"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen and Francois Pennaneach"
   id: "$Id: create_toggle_buttons.e,v 1.4 1999/01/18 19:55:09 pcj Exp $"

class CREATE_TOGGLE_BUTTONS
inherit
   SIMPLE_TEST
   GTK_CONSTANTS
creation make
feature -- Creation
   make is
      -- Creation and initialization
      local
	 window : GTK_WINDOW
	 box1, box2 : GTK_VBOX
	 button : GTK_BUTTON
	 destroy_window : DESTROY_WINDOW
	 separator : GTK_HSEPARATOR
      do
	 !!destroy_window
	 !!window.make
	 window.add_action("destroy", destroy_window, window)
	 window.set_title("toggle buttons")
	 window.set_border_width(0)

	 !!box1.make_with_aspect(False, 0)
	 window.add(box1)
	 box1.show

	 !!box2.make_with_aspect(False, 10)
	 box2.set_border_width(10)
	 box1.pack_start(box2, True, True, 0)
	 box2.show

	 !GTK_TOGGLE_BUTTON!button.make_with_label("button1")
	 box2.pack_start(button, True, True, 0)
	 button.show

	 !GTK_TOGGLE_BUTTON!button.make_with_label("button2")
	 box2.pack_start(button, True, True, 0)
	 button.show

	 !GTK_TOGGLE_BUTTON!button.make_with_label("button3")
	 box2.pack_start(button, True, True, 0)
	 button.show

	 !!separator.make
	 box1.pack_start(separator, False, True, 0)
	 separator.show

	 !!box2.make_with_aspect(False, 10)
	 box2.set_border_width(10)
	 box1.pack_start(box2, False, True, 0)
	 box2.show

	 !GTK_BUTTON!button.make_with_label("close")
	 button.add_clicked_action(destroy_window, window)
	 box2.pack_start(button, True, True, 0)
	 button.set_flags(gtk_can_default)
	 button.grab_default
	 button.show

	 if not window.visible then
	    window.show
	 else
	    window.destroy
	 end -- if

      end -- make
feature {ANY} -- Queries
feature {ANY} -- Commands
feature {NONE} -- Private
invariant
end -- CREATE_TOGGLE_BUTTONS

