indexing
   description: "create toolbar"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen"
   id: "$Id: create_toolbar.e,v 1.5 1999/01/18 19:55:09 pcj Exp $"

class CREATE_TOOLBAR
inherit 
   SIMPLE_TEST
   GTK_COMMAND
   GTK_CONSTANTS
creation
   make
feature -- Creation
   make is
      local 
	 destroy_window : DESTROY_WINDOW
      do
	 !!destroy_window
	 !!window.make
	 window.signal_connect("destroy", destroy_window, window)
	 window.set_title("Toolbar") 
	 window.set_policy(False, True, True)
	 window.set_border_width(0)
	 window.realize

	 make_toolbar

	 window.add(toolbar)
	 window.show_all
      end -- make

feature {NONE}

   horizontal, vertical, icons, text, both, small, big, tooltips_enable, 
   tooltips_disable, show_borders, hide_borders: INTEGER is unique

   window : GTK_WINDOW 
   toolbar : GTK_TOOLBAR

   make_toolbar is
      local 
	 button : GTK_WIDGET
	 entry : GTK_ENTRY
      do
	 !!toolbar.make(gtk_orientation_horizontal, 
			gtk_toolbar_both)
	 button := toolbar.append_item("Horizontal", 
				       "Horizontal toolbar layout", 
				       "Toolbar/Horizontal", 
				       testxpm,
				       Current, horizontal)
	 button := toolbar.append_item("Vertical", 
				       "Vertical toolbar layout", 
				       "Toolbar/Vertical", 
				       testxpm, 
				       Current, vertical)
	 toolbar.append_space
	 button := toolbar.append_item("Icons", "Only show toolbar icons", 
				       "Toolbar/IconsOnly", 
				       testxpm, 
				       Current, icons)
	 button := toolbar.append_item("Text", "Only show toolbar text", 
				       "Toolbar/TextOnly", 
				       testxpm, 
				       Current, text)
	 button := toolbar.append_item("Both", 
				       "Show toolbar icons and text", 
				       "Toolbar/Both", 
				       testxpm, 
				       Current, both) 
	 toolbar.append_space

	 !!entry.make
	 toolbar.append_widget(entry, "This is an unusable GtkEntry", 
			       "Hey don't click me!!!")
	 toolbar.append_space
	 
	 button := toolbar.append_item("Small", "Use small spaces", 
				       "Toolbar/Small", 
				       testxpm, 
				       Current, small) 
	 button := toolbar.append_item("Big", "Use big spaces", 
					"Toolbar/Big", 
					testxpm, 
					Current, big)
	 toolbar.append_space
	 button := toolbar.append_item("Enable", "Enable tooltips", "", 
					     testxpm, 
					     Current, tooltips_enable) 
	 button := toolbar.append_item("Disable", 
					     "Disable tooltips", "", 
					     testxpm, 
					     Current, tooltips_disable) 
	 toolbar.append_space
	 button := toolbar.append_item("Borders", "Show Borders", "", 
					     testxpm, Current, show_borders) 
	 button := toolbar.append_item("Borderless", "Hide Borders", "", 
					     testxpm, Current, hide_borders)
      end

   execute ( data : ANY ) is
      local i: INTEGER_REF
      do
	 i ?= data
	 inspect i.item
	 when horizontal then
	    toolbar.set_orientation(gtk_orientation_horizontal)
	 when vertical then
	    toolbar.set_orientation(gtk_orientation_vertical)
	 when icons then
	    toolbar.set_style(gtk_toolbar_icons)
	 when text then
	    toolbar.set_style(gtk_toolbar_text)
	 when both then
	    toolbar.set_style(gtk_toolbar_both)
	 when small then 
	    toolbar.set_space_size(5)
	 when big then
	    toolbar.set_space_size(10)
	 when tooltips_enable then 
	    toolbar.set_tooltips(True)
	 when tooltips_disable then
	    toolbar.set_tooltips(False)
	 when show_borders then
	    toolbar.set_button_relief(gtk_relief_normal)
	 when hide_borders then
	    toolbar.set_button_relief(gtk_relief_none)
	 else
	 end
      end

   pixmap : GDK_PIXMAP is
      once
	 !!Result.make_from_xpm(window.window, 
				window.style.bg(gtk_state_normal), 
				"test.xpm") 
      end

   testxpm : GTK_PIXMAP is 
      do
	 !!Result.make_from_pixmap(pixmap)
      end
end 

