indexing
   description: "create tooltips"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen and Francois Pennaneach"
   id: "$Id: create_tooltips.e,v 1.5 1999/01/18 19:55:09 pcj Exp $"

class CREATE_TOOLTIPS
inherit
   SIMPLE_TEST
   GTK_COMMAND
   GTK_CONSTANTS
creation make
feature -- Creation
   make is
      -- Creation and initialization
      local
	 --window : GTK_WINDOW
	 box1, box2 : GTK_VBOX
	 button : GTK_BUTTON
	 separator : GTK_HSEPARATOR
	 tooltips : GTK_TOOLTIPS
	 -- commands
	 destroy_window : DESTROY_WINDOW
      do
	 !!destroy_window
	 !!window.make
	 --window.add_action("destroy", destroy_window, window)
	 window.set_title("tooltips")
	 window.set_border_width(0)
	 !!tooltips.make

	 !!box1.make_with_aspect(False, 0)
	 window.add(box1)
	 box1.show

	 !!box2.make_with_aspect(False, 10)
	 box2.set_border_width(10)
	 box1.pack_start(box2, True, True, 0)
	 box2.show

	 !GTK_TOGGLE_BUTTON!button.make_with_label("button1")
	 box2.pack_start(button, True, True, 0)
	 button.show

	 tooltips.set_tips(button, "This is button 1")

	 !GTK_TOGGLE_BUTTON!button.make_with_label("button2")
	 box2.pack_start(button, True, True, 0)
	 button.show

	 tooltips.set_tips(button, "This is button 2")

	 !GTK_TOGGLE_BUTTON!button.make_with_label("button3")
	 box2.pack_start(button, True, True, 0)
	 button.show

	 tooltips.set_tips(button, "This is button 3. This is also a really long tooltip which probably won't fit on a single line and will therefore need to be wrapped. Hopefully the wrapping will work correctly.")

	 !!separator.make
	 box1.pack_start(separator, False, true, 0)
	 separator.show

	 !!box2.make_with_aspect(False, 10)
	 box2.set_border_width(10)
	 box1.pack_start(box2, False, True, 0)
	 box2.show

	 !GTK_BUTTON!button.make_with_label("close")
	 button.add_clicked_action(Current, window)
	 box2.pack_start(button, True, True, 0)
	 button.set_flags(gtk_can_default)
	 button.show

	 tooltips.set_tips(button, "Push this button to close window")

	 if not window.visible then
	    window.show
	 else
	    window.destroy
	 end -- if
      end -- make
feature {ANY} -- Queries
   window : GTK_WINDOW
feature {ANY} -- Commands
   execute(data : ANY) is
      do
	 window.destroy
      end -- execute
feature {NONE} -- Private
invariant
end -- CREATE_TOOLTIPS

