indexing
   description: "create tree"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen"
   id: "$Id: create_tree.e,v 1.6 1999/01/18 19:55:09 pcj Exp $"

class CREATE_TREE
inherit 
   SIMPLE_TEST
   GTK_CONSTANTS
   GTK_COMMAND
creation
   make
feature -- Creation
   make is
      do
	 create_tree_sample
      end -- make
feature {ANY} -- Queries
feature {ANY} -- Commands

   create_tree_sample is
      local
	 window : GTK_WINDOW
	 box1, box2 : GTK_BOX
	 separator : GTK_HSEPARATOR
	 button : GTK_BUTTON
	 scrolled_win : GTK_SCROLLED_WINDOW
	 root_tree: GTK_TREE
	 root_item : GTK_TREE_ITEM
	 destroy_window : DESTROY_WINDOW
      do
	 !!window.make
	 !!destroy_window
	 window.set_title("Tree Sample")
	 window.signal_connect("destroy", destroy_window, window) 
	 
	 !GTK_VBOX!box1.make(False, 0)
	 window.add(box1)
	 box1.show

	 !GTK_VBOX!box2.make(False, 0)
	 box1.pack_start(box2, True, True, 0)
	 box2.set_border_width(5)
	 box2.show

	 !!scrolled_win.make
	 scrolled_win.set_policy(gtk_policy_automatic, gtk_policy_automatic)
	 box2.pack_start(scrolled_win, True, True, 0)
	 scrolled_win.set_usize(200,200)
	 scrolled_win.show

	 !!root_tree.make
	 root_tree.signal_connect("selection_changed", Current, 
				  selection_changed)
	 
	 scrolled_win.add_with_viewport(root_tree)
	 root_tree.set_selection_mode(gtk_selection_single)
	 root_tree.set_view_lines(draw_lines)	 
	 root_tree.set_view_mode(view_lines)
	 
	 root_tree.show
	 
	 !!root_item.make_with_label("root item")
	 root_tree.append(root_item)
	 root_item.show
	 
	 create_subtree(root_item) 

	 !GTK_VBOX!box2.make(False, 0)
	 box1.pack_start(box2, False, False, 0)
	 box2.set_border_width(5)
	 box2.show

	 !!button.make_with_label("Add Item")
	 button.set_sensitive(False)
	 button.signal_connect("clicked", 
			       Current, 
			       add_new_item) 
	 box2.pack_start(button, True, True, 0)
	 button.show

	 !!button.make_with_label("Remove Item(s)")
	 button.set_sensitive(False) 
	 button.signal_connect("clicked", Current, remove_item)
	 box2.pack_start(button, True, True, 0)
	 button.show

	 !!button.make_with_label("Remove Subtree")
	 button.set_sensitive(False)
	 button.signal_connect("clicked", Current, remove_subtree)
	 box2.pack_start(button, True, True, 0)
	 button.show

	 !!separator.make
	 box1.pack_start(separator, False, False, 0)
	 separator.show

	 !GTK_VBOX!box2.make(False, 0)
	 box1.pack_start(box2, False, False, 0)
	 box2.set_border_width(5)
	 box2.show

	 !!button.make_with_label("Close")
	 box2.pack_start(button, True, True, 0)
	 button.signal_connect("clicked", destroy_window, window)
	 button.show
	 window.show
      end
	 
feature {NONE} -- Private

   selection_changed, add_new_item, remove_item, 
   remove_subtree, close : INTEGER is unique
   
   view_lines : GTK_TREE_VIEW_MODE is do Result := gtk_tree_view_line end
   draw_lines : BOOLEAN is true
   selection_mode : GTK_SELECTION_MODE is do Result := gtk_selection_single end
   nb_item_max : INTEGER is 4

   create_subtree ( item : GTK_TREE_ITEM ) is
      local 
	 item_subtree :  GTK_TREE
	 item_new : GTK_TREE_ITEM
	 nb_item : INTEGER 
	 buffer : STRING
      do
	 !!item_subtree.make
	 from nb_item := 0
	 until 
	    nb_item >= nb_item_max
	 loop
	    !!buffer.make(8)
	    buffer.copy("item ")
	    buffer.append(nb_item.out)
	    !!item_new.make_with_label(buffer)
	    item_subtree.append(item_new)
	    item_new.show
	    nb_item := nb_item + 1
	 end
	 item.set_subtree(item_subtree)
      end
   
   execute ( data : ANY ) is
      local 
	 i : INTEGER_REF 
      do
	 i ?= data
      end

invariant
end 

