indexing
   description: "create wm hints"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen"
   id: "$Id: create_wm_hints.e,v 1.4 1999/01/18 19:55:09 pcj Exp $"

class CREATE_WM_HINTS
inherit 
   SIMPLE_TEST
   GTK_CONSTANTS
creation
   make
feature -- Creation
   make is
      local 
	 window : GTK_WINDOW
	 label : GTK_LABEL
	 separator : GTK_SEPARATOR
	 box1, box2: GTK_BOX
	 circles : GDK_PIXMAP
	 destroy_window : DESTROY_WINDOW
	 icon_window : GDK_WINDOW
	 button : GTK_BUTTON
	 transparent_color : GDK_COLOR
      do
	 !!destroy_window
	 !!window.make
	 window.signal_connect("destroy", destroy_window, window) 
	 window.set_title("WM Hints") 
	 window.set_border_width(0)
	 
	 window.realize

	 !!transparent_color.make_default
	 !!circles.make_from_xpm_d(window.window, 
				   transparent_color, 
				   circles_data) 
	 !!icon_window.make_default
	 window.window.set_icon(icon_window, circles)
	 window.window.set_icon_name("WMHints Test Icon")
	 window.window.set_decorations(gdk_decor_all and gdk_decor_menu)
	 window.window.set_functions(gdk_func_all and gdk_func_resize)
	 
	 !GTK_VBOX!box1.make(False, 0)
	 window.add(box1)
	 box1.show

	 !!label.make_with_label("Try iconifiying me!")
	 label.set_usize(150,50)
	 box1.pack_start(label, True, True, 0)
	 label.show

	 !GTK_HSEPARATOR!separator.make
	 box1.pack_start(separator, False, True, 0)
	 separator.show

	 !GTK_VBOX!box2.make(False, 10)
	 box2.set_border_width(10)
	 box1.pack_start(box2, False, True, 0)
	 box2.show

	 !!button.make_with_label("close") 
	 button.signal_connect("clicked", destroy_window, window)
	 box2.pack_start(button, True, True, 0)
	 button.set_flags(gtk_can_default)
	 button.grab_default
	 button.show

	 window.show

      end -- make

feature {NONE} -- Private

   -- Yeah, I know. There's just not any easy way to to import
   -- .xbm data into eiffel. 

   circles_data : ARRAY[STRING] is
      once
	 Result := <<
"64 64 2 1", 		     
". c None",
"# c #000000",
"................................................................",
"........................#############...........................",
".....................###################........................",
"..................#########################.....................",
"................#############################...................",
"..............#################################.................",
".............###################################................",
"............#####################################...............",
"..........#########################################.............",
".........################...........################............",
"........##############.................##############...........",
".......#############.....................#############..........",
".......###########.........................###########..........",
"......###########...........................###########.........",
".....##########...............................##########........",
"....##########.................................##########.......",
"....#########...................................#########.......",
"...##########................#..................##########......",
"...#########............###########..............#########......",
"..#########...........###############.............#########.....",
"..#########.........###################...........#########.....",
"..########.........#####################...........########.....",
".#########........#######################..........#########....",
".########........###########...###########..........########....",
".########........########.........########..........########....",
"#########.......########...........########.........#########...",
"########........#######.............#######..........########...",
"########.......#######...............#######.........########...",
"########.......######.................######.........########...",
"########.......######.................######.........########...",
"########.......######.................######.........########...",
"########.......#####...................#####.........########...",
"########......######...................######........########...",
"########.......#####...................#####.........########...",
"########.......######.................######.........########...",
"########.......######.................######.........########...",
"########.......######.................######.........########...",
"#########......#######...............#######........#########...",
".########.......#######.............#######.........########....",
".########.......########...........########.........########....",
".#########.......########.........########.........#########....",
"..########.......###########...###########.........########.....",
"..#########.......#######################.........#########.....",
"..#########........#####################..........#########.....",
"...#########........###################..........#########......",
"...##########.........###############...........##########......",
"....#########...........###########.............#########.......",
"....##########...............#.................##########.......",
".....##########...............................##########........",
"......###########...........................###########.........",
".......###########.........................###########..........",
".......#############.....................#############..........",
"........##############.................##############...........",
".........################...........################............",
"..........#########################################.............",
"............#####################################...............",
".............###################################................",
"..............#################################.................",
"................#############################...................",
"..................#########################.....................",
".....................###################........................",
"........................#############...........................",
"................................................................",
"................................................................" >>
      end


   circles_width : INTEGER is 64 
   circles_height : INTEGER is 64 
invariant 
end


