indexing
   description: "main window"
   status: "You may be able to redistribute and/or modify this program.% 
          % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen and Francois Pennaneach"
   id: "$Id: main_window.e,v 1.13 1999/01/18 19:55:10 pcj Exp $"

class MAIN_WINDOW
inherit
   GTK_COMMAND
   GTK_CONSTANTS
   GTK_MAIN
creation make
feature -- Creation
   make is
      -- Creation and initialization
      local
	 i : INTEGER
	 buttons : ARRAY[GTK_BUTTON]
	 button : GTK_BUTTON
	 names : ARRAY[STRING]
	 box1,box2 : GTK_VBOX
	 separator : GTK_HSEPARATOR

      do
	 !!buttons.make(1,0)
	 names := << "buttons", 
		     "toggle_buttons", 
		     "check_buttons", 
		     "radio buttons", 
		     "button box", 
		     "reparent", 
		     "pixmap", 
		     "tooltips", 
		     "menus", 
		     "scrolled windows", 
		     "drawing areas", 
		     "entry", 
		     "list", 
		     "color selection", 
		     "file selection", 
		     "dialog", 
		     "cursors",
		     "clist", 
		     "ctree", 
		     "toolbar", 
		     "text", 
		     "notebook",
		     "gamma curve",
		     "paned", 
		     "progress bar", 
		     "handle_box", 
		     "rulers", 
		     "status_bar", 
		     "font selection", 
		     "range controls", 
		     "preview color", 
		     "dnd", 
		     "tree", 
		     "WM Hints", 
		     "miscellaneous", 
		     "preview gray", 
		     "test selection", 
		     "test timeout", 
		     "test idle", 
		     "test" >>

	 !!window.make
	 window.set_name("main window")
	 window.set_title("Gtk-Eiffel")
	 window.set_uposition(20, 20)

	 !!box1.make_with_aspect(False, 0)
	 window.add(box1)
	 box1.show

	 !!box2.make_with_aspect(False, 0)
	 box2.set_border_width(10)
	 box1.pack_start(box2, True, True, 0)
	 box2.show

	 from i := names.lower
	 until i > names.upper
	 loop
	    !!button.make_with_label(names.item(i))
	    button.add_clicked_action(Current, i)
	    box2.pack_start(button, True, True, 0)
	    button.show

	    buttons.force(button, i)
	    i := i + 1
	 end -- loop

	 !!separator.make
	 box1.pack_start(separator, False, True, 0)
	 separator.show

	 !!box2.make_with_aspect(False, 10)
	 box2.set_border_width(10)
	 box1.pack_start(box2, False, True, 0)
	 box2.show

	 !!button.make_with_label("close")
	 button.add_clicked_action(Current, "exit")
	 box2.pack_start(button, True, True, 0)
	 button.set_flags(gtk_can_default)
	 button.grab_default
	 button.show

	 window.show
      end -- make

feature {ANY} -- Queries
feature {ANY} -- Commands
feature {NONE} -- Private

   window : GTK_WINDOW

   execute(data : ANY) is
      local
	 button : INTEGER_REF
	 simple_test : SIMPLE_TEST
	 str : STRING
      do
--	 print("data : ");print(data);print("%N")
	 str ?= data
	 button ?= data
	 if button /= Void then
	    inspect button.item
	    when 1 then
	       !CREATE_BUTTONS!simple_test.make
	    when 2 then
	       !CREATE_TOGGLE_BUTTONS!simple_test.make
	    when 3 then
	       !CREATE_CHECK_BUTTONS!simple_test.make
	    when 4 then
	       !CREATE_RADIO_BUTTONS!simple_test.make
	    when 5 then
	       !CREATE_BUTTON_BOX!simple_test.make
	    when 6 then
	       !CREATE_REPARENT!simple_test.make
	    when 7 then
	       !CREATE_PIXMAP!simple_test.make
	    when 8 then
	       !CREATE_TOOLTIPS!simple_test.make
	    when 9 then
	       !CREATE_MENUS!simple_test.make
	    when 10 then
	       !CREATE_SCROLLED_WINDOWS!simple_test.make
	    when 12 then 
	       !CREATE_ENTRY!simple_test.make
	    when 13 then
	       !CREATE_LIST!simple_test.make
	    when 14 then
	       !CREATE_COLOR_SELECTION!simple_test.make
	    when 15 then
	       !CREATE_FILESELECTION!simple_test.make
	    when 16 then
	       !CREATE_DIALOG!simple_test.make
	    when 17 then 
	       !CREATE_CURSORS!simple_test.make
	    when 18 then
	       !CREATE_CLIST!simple_test.make
	    when 19 then 
	       !CREATE_CTREE!simple_test.make  
	    when 20 then 
	       !CREATE_TOOLBAR!simple_test.make
	    when 21 then
	       !CREATE_TEXT!simple_test.make
	    when 22 then 
	       !CREATE_NOTEBOOK!simple_test.make
	    when 23 then
	       !CREATE_GAMMA_CURVE!simple_test.make
	    when 24 then
	       !CREATE_PANED!simple_test.make
	    when 25 then
	       !CREATE_PROGRESS_BAR!simple_test.make
	    when 26 then 
	       !CREATE_HANDLE_BOX!simple_test.make
	    when 27 then 
	       !CREATE_RULERS!simple_test.make
	    when 28 then 
	       !CREATE_STATUSBAR!simple_test.make
	    when 29 then 
	       !CREATE_FONT_SELECTION!simple_test.make
	    when 30 then
	       !CREATE_RANGE_CONTROLS!simple_test.make
	    when 31 then
	       !CREATE_COLOR_PREVIEW!simple_test.make
	    when 32 then
	       !CREATE_DRAG_DROP!simple_test.make
	    when 33 then
	       !CREATE_TREE!simple_test.make
	    when 34 then 
	       !CREATE_WM_HINTS!simple_test.make
	    else 
	    end -- inspect
	 elseif str /= Void then
	    if str.is_equal("exit") then
	       window.destroy
	       quit
	       exit(0)
	    end --if
	 end -- if
      end -- execute
invariant
end -- MAIN_WINDOW

